

declare
  type tMenuItem is record
  (
    sItemCode    varchar2(40)
   ,sItemCaption varchar2(80)
   ,sItemMethod  varchar2(20)
   ,sIdent       varchar2(80)
   ,nSignExists  number(1)
  );
  type tMenuItems is table of tMenuItem index by varchar2(40);
  rMenuItem        tMenuItem;
  aMenuItems       tMenuItems;
  sSeparator       varchar2(240) := '<Separator Custom="-1"/>';
  sMenuItemPrev    varchar2(40)  := 'SalaryBudgetTransfers';
--  sMenuItemPrev  varchar2(40)  := 'PersonDevelopmentPlans';
  sMenuItem01      varchar2(40)  := 'UdotSalaryRegistersOpenAccounts';
  sMenuItem02      varchar2(40)  := 'UdotSalaryRegistersLoadAccounts';
  sMenuItem03      varchar2(40)  := 'UdotSalaryRegistersTransfers';
  nCondition       number(2) := -1;
  sMenuItem        varchar2(240);
  nSignExists      number(1) := 1;
  sApplistCode     varchar2(40) := 'BudgSlr';
--  sApplistCode   varchar2(40) := 'CivilServ';
  nRN_UserFormsAppMenu   number;
  nRN_Applist      number;
  sClobMenu        clob;
  sClobMenuAdd     clob;
  nCurrentPos      number;
  nCurrentPosItem  number;
  nLength          number;
  sCodeItem        varchar2(40);
begin
  --     
  select a.appcode
    into sApplistCode
    from applist a
   where a.appcode in ('BudgSlr','Salary');

  aMenuItems.delete();
  --      
  for rc in (
  select scode
        ,scaption
        ,sident
        ,rn_usermenu
        ,appmenu
        ,rn_applist
        ,to_char(dbms_lob.instr(appmenu,scode,1),'0000000')  as sPlacePos
    from (
          select xmltype(nvl(m.form_data,a.appmenu))  as para
                ,m.rn                                 as rn_usermenu
                ,nvl(m.form_data,a.appmenu)           as appmenu
                ,a.rn                                 as rn_applist
            from userformsapps m
                ,applist       a
           where a.appcode = sApplistCode --'BudgSlr'
             and a.rn  = m.prn(+)
         ) names
           ,xmltable('/MainMenu/Popup[@Group="Documents"]/MenuItem'
                     passing para
                     columns
                       scode       varchar2(40)  path '@Code'
                      ,scaption    varchar2(240) path '@Caption'
                      ,sident      varchar2(240) path '@Ident'
                    )
   where scode in (sMenuItemPrev,sMenuItem01,sMenuItem02,sMenuItem03)--sMenuItemCode)
--   where scode in ('SalaryBudgetTransfers','UdotSalaryRegistersTransfers','UdotSalaryRegistersOpenAccounts','UdotSalaryRegistersLoadAccounts','')
   order by 7  --    
  ) loop
    if rc.scode = sMenuItemPrev then
      nRN_UserFormsAppMenu  := rc.rn_usermenu;
      sClobMenu             := rc.appmenu;
      nRN_Applist           := rc.rn_applist;
    else
      aMenuItems(rc.splacepos).sItemCode    := rc.scode;
      aMenuItems(rc.splacepos).nSignExists  := 1;
    end if;
--    dbms_output.put_line(rc.splacepos||','||rc.scode||','||rc.scaption||','||rc.sident);
  end loop;
  if aMenuItems.count <= 0 then
    return;
  end if;
  if nRN_Applist is not null then
    dbms_lob.createtemporary( sClobMenuAdd, true);
    sCodeItem   := aMenuItems.first;
    --    ( )
    sMenuItem   := '';
    nCurrentPos := 1;
    for i in 1 .. aMenuItems.count
    loop
      dbms_output.put_line(sCodeItem||'  -  '||aMenuItems.count);
      if aMenuItems(sCodeItem).nSignExists = 1 and aMenuItems(sCodeItem).sItemCode <> sMenuItemPrev then
        sMenuItem := '<MenuItem Code="'||aMenuItems(sCodeItem).sItemCode||'"';
        nCurrentPosItem := dbms_lob.instr(sClobMenu, sMenuItem, nCurrentPos);
        dbms_output.put_line(sCodeItem||', '||nCurrentPos||'-'||nCurrentPosItem);
        if nCurrentPosItem > nCurrentPos then
          --     ,   
          dbms_lob.copy(sClobMenuAdd, sClobMenu, nCurrentPosItem - nCurrentPos, nvl(dbms_lob.getlength(sClobMenuAdd),0) + 1, nCurrentPos);
        end if;
        nCurrentPos := dbms_lob.instr(sClobMenu, '/>', nCurrentPosItem + 1) + 2;
      end if;
      sCodeItem := aMenuItems.next(sCodeItem);
    end loop;
    --    
    dbms_lob.copy(sClobMenuAdd, sClobMenu, dbms_lob.getlength(sClobMenu) - nCurrentPos + 1, dbms_lob.getlength(sClobMenuAdd) + 1, nCurrentPos );
    --     
    dbms_lob.trim(sClobMenu, 0);
    sClobMenu := regexp_replace(regexp_replace(sClobMenuAdd,'(<Separator[^>]*><Separator[^>]*>)',sSeparator),'(<Separator[^>]*><Separator[^>]*>)',sSeparator);
    --     
    if nRN_UserFormsAppMenu is null then
      insert into userformsapps
         (rn, prn, form_appcode, form_language, form_data)
       values
         (gen_id, nRN_Applist, sApplistCode, 'RUSSIAN', sClobMenu);
    else
      update userformsapps u
         set u.form_data = sClobMenu
       where u.rn = nRN_UserFormsAppMenu;
    end if;
/*
    insert into file_buffer(ident, authid, filename, data)
      values (1001, user, 'NewAppMenu', sClobMenuAdd);
*/
    dbms_lob.trim(sClobMenuAdd, 0);
    dbms_lob.trim(sClobMenu, 0);
  else
    p_exception(0,'        "'||sApplistCode||'"');
  end if;
--  dbms_output.put_line(aMenuItems.count);
end;
/

