

spool c:\BSPb\Parus8\Addon\logs\__create_function.log

--UDOT_P_TRIM_PREF_NUMB
--UDOT_F_NAME_TO_LAT

-- create function and procedures
create or replace procedure UDOT_P_TRIM_PREF_NUMB
(
  sPREF      in out varchar2
 ,sNUMB      in out varchar2
)
as
begin
  sPREF  := trim(sPREF);
  sNUMB  := trim(sNUMB);
end;
/

grant execute on UDOT_P_TRIM_PREF_NUMB to public;

create or replace function UDOT_F_NAME_TO_LAT
(
  sSTRING   in varchar2
) return varchar
is
  type tRecParsing is record
  (
    pre        varchar2(2)
   ,rus        varchar2(1)
   ,post       varchar2(2)
   ,eng        varchar2(10)
   ,place_dict binary_integer
  );
  type tTableParsing is table of tRecParsing index by binary_integer;
  type tRecDict is record
  (
    str_value  varchar2(10)
   ,note       varchar2(10)
  );
  type tTableDict is table of tRecDict index by binary_integer;
  rPars    tRecParsing;
  aPars    tTableParsing;
  aDict    tTableDict;
  nLen     binary_integer;
  S1       varchar( 3 );
  S2       varchar( 2 );
  S        varchar( 1 );
  NN       number;
  sNAME    varchar2(240) := upper(trim(sSTRING));
  ENAME    varchar2(240);
  --     ""
  function find_dict_w return binary_integer
  as
    nNumb  binary_integer := 0;
  begin
    for i in 1 .. aPars.count loop
      for j in 1 .. aDict.count loop
        if aPars(i).post = aDict(j).str_value and aPars(i).eng is null then
          aPars(i).place_dict := j;
          nNumb  := i;
          exit;
        end if;
      end loop;
      if nNumb > 0 then
        exit;
      end if;
    end loop;
    return nNumb;
  end find_dict_w;

begin
  aPars.delete;
  if sName is null then
    return '';
  end if;
  for i in 1 .. length( sNAME )
  loop
    rPars  := null;
    if I = 1 then
      rPars.pre  := ' ';
      rPars.post := substr( sName, i, 2 );
      rPars.rus  := substr( sName, i, 1 );
    else
      rPars.pre  := substr( sName, i-1, 2 );
      rPars.post := substr( sName, i, 2 );
      rPars.rus  := substr( sName, i, 1 );
    end if;
    aPars(i) := rPars;
  end loop;
  --   
  aDict.delete;
  select v.str_value, v.note
    bulk collect into aDict
    from EXTRA_DICTS_VALUES  V
        ,EXTRA_DICTS         D
   where D.CODE = ''
     and D.RN = V.PRN;
  --   
  nLen  := find_dict_w;
  while nLen > 0
  loop
    aPars(nLen).eng := trim(aDict(aPars(nLen).place_dict).note);
    if nLen < aPars.count then
      aPars(nLen + 1).eng := '-';
    end if;
    nLen := find_dict_w;
  end loop;
  --   
  -- - 
  aDict.delete;
  select v.str_value, v.note
    bulk collect into aDict
    from EXTRA_DICTS_VALUES  V
        ,EXTRA_DICTS         D
   where D.CODE = ''
     and D.RN = V.PRN;

  for i in 1 .. aPars.count loop
    if aPars(i).eng is null then
      for j in 1 .. aDict.count loop
        if aPars(i).rus = aDict(j).str_value then
          aPars(i).eng := aDict(j).note;
          exit;
        end if;
      end loop;
    end if;
  end loop;
  --   
  -- - 
  aDict.delete;
  select v.str_value, v.note
    bulk collect into aDict
    from EXTRA_DICTS_VALUES  V
        ,EXTRA_DICTS         D
   where D.CODE = ''
     and D.RN = V.PRN;

  for i in 1 .. aPars.count loop
    if aPars(i).eng is null then
      for j in 1 .. aDict.count loop
        if aPars(i).rus = aDict(j).str_value then
          aPars(i).eng := aDict(j).note;
          exit;
        end if;
      end loop;
    end if;
  end loop;
  --    -
  for i in 1 .. aPars.count loop
    if instr(aPars(i).eng,';') > 0 then
      if i = 1 then
        aPars(i).eng := substr( aPars(i).eng, 1, 2 );
      else
        select count(1)
          into NN
          from EXTRA_DICTS_VALUES V, EXTRA_DICTS D
         where D.RN = V.PRN
           and D.CODE = ''
           and V.STR_VALUE = substr( aPars(i).pre, 1, 1 );
        if NN > 0 then
          aPars(i).eng := substr( aPars(i).eng, 1, 2 );
        else
          select count(1)
            into NN
            from EXTRA_DICTS_VALUES V, EXTRA_DICTS D
           where D.RN = V.PRN
             and D.CODE = ''
             and V.STR_VALUE = substr( aPars(i).pre, 1, 1 );
          if NN > 0 then
            aPars(i).eng := substr( aPars(i).eng, instr( aPars(i).eng, ';' ) + 1, 2 );
          else
            aPars(i).eng := substr( trim( aPars(i).eng ), -1, 1 );
          end if;
        end if;
      end if;
    end if;
  end loop;
  --  
  if aPars.count > 2 then
    -- - 
    aDict.delete;
    select v.str_value, v.note
      bulk collect into aDict
      from EXTRA_DICTS_VALUES  V
          ,EXTRA_DICTS         D
     where D.CODE = ''
       and D.RN = V.PRN;
    nLen  := aPars.count - 1;
    for j in 1 .. aDict.count loop
      if aPars(nLen).post = aDict(j).str_value then
        aPars(nLen).eng := aDict(j).note;
        exit;
      end if;
    end loop;
  end if;
  --  
  eName  := '';
  for i in 1 .. aPars.count loop
    if aPars(i).eng <> '-' then
      eName := eName||trim( aPars(i).eng );
    end if;
  end loop;
  return trim( eName );
end;
/

grant execute on UDOT_F_NAME_TO_LAT to public;

create or replace function UDOT_GET_FILENAME_BANKSPB
(
  nCOMP      in number    -- 
 ,sTYPE      in varchar2  --  
 ,dDATE      in date      --  
 ,sBANKCODE  in varchar2  --     
) return varchar2
as
/*
        
     
*/

  sFILE_NAME_NEW   varchar2(80);
  nNumbFile        number(4);
  dDATE_W          date := trunc(dDATE);
begin

  update UDOT_BANKNUMBFILES m
     set m.numb = m.numb + 1
   where m.date_create = dDATE_W and m.type_file = sTYPE and m.company = nCOMP and m.bankcode = sBANKCODE
   returning m.numb into nNumbFile;

  if SQL%rowcount = 0 then
    insert into UDOT_BANKNUMBFILES
        (COMPANY, TYPE_FILE, NUMB, BANKCODE)
      values
        (nCOMP, sTYPE, 1, sBANKCODE)
      returning numb into nNumbFile;
  end if;

  if sTYPE = 'Z' then
    sFILE_NAME_NEW := 'Z'||sBANKCODE||'.'||to_char(sysdate,'dd')||trim(to_char(nNumbFile))||'.dbf';
  elsif sTYPE = 'B' then
    sFILE_NAME_NEW := 'B'||sBANKCODE||'.'||to_char(sysdate,'dd')||trim(to_char(nNumbFile))||'.dbf';
  elsif sTYPE = 'P' then
    sFILE_NAME_NEW := 'P'||sBANKCODE||'.'||to_char(sysdate,'dd')||trim(to_char(nNumbFile))||'.dbf';
  elsif sTYPE = 'N' then
    sFILE_NAME_NEW := 'N'||sBANKCODE||'.'||to_char(sysdate,'dd')||trim(to_char(nNumbFile))||'.dbf';
  else
    p_exception(0,'   - '||sTYPE);
  end if;
  return sFILE_NAME_NEW;
end UDOT_GET_FILENAME_BANKSPB;
/

grant execute on UDOT_GET_FILENAME_BANKSPB to public;

create or replace procedure UDOT_P_STR2TEXT
(
  sSTR_VALUE   in out nocopy varchar2  --      
 ,nLEN_LINE    in number               --     ( )
 ,sDELIM       in varchar2             --      
)
as
/*
        
             
        
*/
  nLEN       number;
  nPosOne    number := 1;
  nPosSpace  number;
begin
  if length(sDELIM) <> 1 then
    p_exception(0,'      1 () .');
  end if;
  nLEN      := length(sSTR_VALUE);
  while (nLen - nPosOne) > nLEN_LINE
  loop
    nPosSpace := instr(sSTR_VALUE, sDELIM, (nPosOne + nLEN_LINE - nLEN));
    if nPosSpace <= nPosOne then
      sSTR_VALUE := substr(sSTR_VALUE,1,(nPosOne + nLEN_LINE - 1))||CR||substr(sSTR_VALUE, (nPosOne + nLEN_LINE));
      nPosOne    := nPosOne + nLEN_LINE;
    else
      sSTR_VALUE := substr(sSTR_VALUE,1,(nPosSpace + length(sDELIM) - 1))||CR||substr(sSTR_VALUE, (nPosSpace + length(sDELIM)));
      nPosOne    := nPosSpace;
    end if;
  end loop;
end UDOT_P_STR2TEXT;
/

grant execute on UDOT_P_STR2TEXT to public;

create or replace procedure UDOT_P_AGNACC_INSERT
(
  nCOMPANY        in number,
  nPRN            in number,
  sSTRCODE        in varchar2,
  sAGNACC         in varchar2 default null,
  sAGNNAMEACC     in varchar2,
  sBANKNAMEACC    in varchar2 default null,
  sBANKFCODEACC   in varchar2 default null,
  sBANKACC        in varchar2 default null,
  sBANKCITYACC    in varchar2 default null,
  sAGNBANKS       in varchar2 default null,
  dOPEN_DATE      in date default null,
  dCLOSE_DATE     in date default null,
  sCOUNTRY_CODE   in varchar2 default null,
  nACCESS_FLAG    in number default 1,
  sSWIFT          in varchar2 default null,
  sREGION         in varchar2 default null,
  sDISTRICT       in varchar2 default null,
  sBANKACC_TYPE   in varchar2 default null,
  sCURRENCY       in varchar2 default null,
  sCORR_AGNACC    in varchar2 default null,
  sCARDNUMB       in varchar2 default null,
  sAGNTREAS       in varchar2 default null,
  sTREAS_AGNACC   in varchar2 default null,
  sINTERMEDIARY   in varchar2 default null,
  sINTERMED_ACC   in varchar2 default null,
  sBANKPRG        in varchar2 default null,
  nRN            out number
)
as
begin
  P_AGNACC_INSERT
  (
    nCOMPANY        => nCOMPANY
   ,nPRN            => nPRN
   ,sSTRCODE        => sSTRCODE
   ,sAGNACC         => sAGNACC
   ,sAGNNAMEACC     => sAGNNAMEACC
   ,sBANKNAMEACC    => sBANKNAMEACC
   ,sBANKFCODEACC   => sBANKFCODEACC
   ,sBANKACC        => sBANKACC
   ,sBANKCITYACC    => sBANKCITYACC
   ,sAGNBANKS       => sAGNBANKS
   ,dOPEN_DATE      => dOPEN_DATE
   ,dCLOSE_DATE     => dCLOSE_DATE
   ,sCOUNTRY_CODE   => sCOUNTRY_CODE
   ,nACCESS_FLAG    => nACCESS_FLAG
   ,sSWIFT          => sSWIFT
   ,sREGION         => sREGION
   ,sDISTRICT       => sDISTRICT
   ,sBANKACC_TYPE   => sBANKACC_TYPE
   ,sCURRENCY       => sCURRENCY
   ,sCORR_AGNACC    => sCORR_AGNACC
   ,sCARDNUMB       => sCARDNUMB
   ,sAGNTREAS       => sAGNTREAS
   ,sTREAS_AGNACC   => sTREAS_AGNACC
   ,sINTERMEDIARY   => sINTERMEDIARY
   ,sINTERMED_ACC   => sINTERMED_ACC
   ,sBANKPRG        => sBANKPRG
   ,nRN             => nRN
  );
end UDOT_P_AGNACC_INSERT;
/

grant execute on UDOT_P_AGNACC_INSERT to public;

spool off
