
spool c:\BSPb\Parus8\Addon\logs\__create_objects_UdoDictionary.log

/*   /      */
create global temporary table UDOT_VIRTUALDICT (
/*    */
COMPANY number(17) not null,
/*   */
RN number(17) not null,
/*    */
CRN number(17) not null,
/*  */
CODE varchar2(20) not null,
/*  */
NAME varchar2(2000) not null,
/*   */
PREF varchar2(80) default null,
/*   */
NUMB varchar2(80) default null,
/*   */
DOCDATE date default null,
/*  /   */
NOTE varchar2(4000) default null,
/*      */
UNITCODE varchar2(40) default null,
constraint C_UDOT_VIRTUALDICT_CODE_VAL check (trim(code) is not null),
constraint C_UDOT_VIRTUALDICT_NAME_VAL check (trim(name) is not null),
constraint C_UDOT_VIRTUALDICT_NUMB_VAL check (numb is null or trim(numb) is not null),
constraint C_UDOT_VIRTUALDICT_PREF_VAL check (pref is null or trim(pref) is not null)
) on commit preserve rows;
-- Add comments to the table and to the columns
comment on table UDOT_VIRTUALDICT
  is '  /     ';
comment on column UDOT_VIRTUALDICT.COMPANY
  is '  ';
comment on column UDOT_VIRTUALDICT.RN
  is ' ';
comment on column UDOT_VIRTUALDICT.CRN
  is '  ';
comment on column UDOT_VIRTUALDICT.CODE
  is '';
comment on column UDOT_VIRTUALDICT.NAME
  is '';
comment on column UDOT_VIRTUALDICT.PREF
  is ' ';
comment on column UDOT_VIRTUALDICT.NUMB
  is ' ';
comment on column UDOT_VIRTUALDICT.DOCDATE
  is ' ';
comment on column UDOT_VIRTUALDICT.NOTE
  is ' /  ';
comment on column UDOT_VIRTUALDICT.UNITCODE
  is '    ';
-- Create foreign key constraints


/* V_UDOT_VIRTUALDICT */
create or replace view V_UDOT_VIRTUALDICT (
  NRN,
  NCRN,
  NCOMPANY,
  SCODE,
  SNAME,
  SPREF,
  SNUMB,
  DDOCDATE,
  SNOTE
) as
select
  M.RN           -- nRN
 ,M.CRN          -- nCRN
 ,M.COMPANY      -- nCOMPANY
 ,M.CODE         -- sCODE
 ,M.NAME         -- sNAME
 ,M.PREF         -- sPREF
 ,M.NUMB         -- sNUMB
 ,M.DOCDATE      -- dDOCDATE
 ,M.NOTE         -- sNOTE
from UDOT_VIRTUALDICT  M
;

grant select on V_UDOT_VIRTUALDICT to public;

create or replace function UDOT_GET_ACATALOG_DICT_DESCR
(
  sIN_PARAM    in varchar2   --      (in_RN  in_NAME)
 ,sOUT_PARAM   in varchar2   --      (out_RN  out_NAME)
 ,sCONTROL     in varchar2   --          
 ,sUNITCODE    in varchar2   --         ( 'SalaryTransfers')
)
return varchar2
as
begin
  delete from UDOT_VIRTUALDICT;

  return '<DictionaryInterface UnitCode="UdotDictionary" Method="catalog">'
     || '<Params><Param Name="' || sIN_PARAM  || '"><ParamTypes><In>1</In></ParamTypes><Control>'||sCONTROL||'</Control></Param>'
     || '<Param Name="' || sOUT_PARAM || '"><ParamTypes><Out>1</Out></ParamTypes><Control>'||sCONTROL||'</Control></Param>'
     || '<Param Name="in_UNITCODE"><ParamTypes><In>1</In></ParamTypes><Constant>'||sUNITCODE||'</Constant></Param>'
     || '</Params></DictionaryInterface>';
end UDOT_GET_ACATALOG_DICT_DESCR;
/

grant execute on UDOT_GET_ACATALOG_DICT_DESCR to public;

create or replace function UDOT_GET_AGNADDRESS_DICT_DESCR
(
  nRN          in number     --   
 ,sIN_PARAM    in varchar2   --     
 ,sOUT_PARAM   in varchar2   --     
 ,sCONTROL     in varchar2   --          
)
return varchar2
as
  nCOUNT       number;
  nCOMPANY     number;
begin
  delete from UDOT_VIRTUALDICT;

  select count(1)
    into nCOUNT
    from AGNLIST  S
   where S.rn = nRN;
  if nCOUNT > 0 then
    insert into UDOT_VIRTUALDICT(RN, COMPANY, CRN, CODE, NAME, PREF, NUMB, DOCDATE, NOTE)
     (select ad.rn
            ,pkg_session.get_company()
            ,ad.crn
            ,ad.rn
            ,FORMAT_HIER_NAME(null, AD.VERSION, G.FULLNAME)
            ,(case when ad.primary_sign = 1 then ',' end||case when ad.legal_sign = 1 then ',' end||case when ad.real_sign = 1 then ',' end||case when ad.registration_sign = 1 then ',' end||case when ad.birth_sign = 1 then ',' end||case when ad.mail_sign = 1 then '' end)
            ,F_AGNADDRESSES_GET_STR_EX(AD.RN,'HBLF')
            ,ad.registration_date
            ,F_AGNADDRESSES_GET_STR_EX(AD.RN,'CPRDYUTSHBLF')||', '||AD.NOTE
      from
        AGNADDRESSES      AD
       ,GEOGRAFY          G
      where AD.PRN = NRN
        and AD.GEOGRAFY_RN = G.RN
        and PKG_ENV_VIEW.PROLOGUE('AGN_VIEW_DOCUM') = 1
        and PKG_ENV_VIEW.EPILOGUE(null,AD.VERSION,AD.CRN,null,null,'AGNLIST','AGN_VIEW_DOCUM','AGNLIST',AD.PRN) = 1
        and exists (select null from V_USERPRIV UP where UP.CATALOG = AD.CRN)
    );
  end if;
  return '<DictionaryInterface UnitCode="UdotDictionary" Method="list">'
     || '<Params><Param Name="' || sIN_PARAM  || '"><ParamTypes><In>1</In></ParamTypes><Control>'||sCONTROL||'</Control></Param>'
     || '<Param Name="' || sOUT_PARAM || '"><ParamTypes><Out>1</Out></ParamTypes><Control>'||sCONTROL||'</Control></Param>'
     || '<Param Name="in_UNITCODE"><ParamTypes><In>1</In></ParamTypes><Constant>AGNLIST</Constant></Param>'
     || '</Params></DictionaryInterface>';

end UDOT_GET_AGNADDRESS_DICT_DESCR;
/

grant execute on UDOT_GET_AGNADDRESS_DICT_DESCR to public;

create or replace function UDOT_GET_PERSONS_DICT_DESCR
(
  sIN_PARAM    in varchar2   --     
 ,sOUT_PARAM   in varchar2   --     
 ,sCONTROL     in varchar2   --          
)
return varchar2
as
  nCOUNT       number;
  nCOMPANY     number;
begin
  delete from UDOT_VIRTUALDICT;

  insert into UDOT_VIRTUALDICT(RN, COMPANY, CRN, CODE, NAME, PREF, NUMB, DOCDATE, NOTE)
   (select ad.rn
          ,ad.company
          ,ad.crn
          ,ag.agnabbr
          ,F_CLNPERSONS_FORMAT_CODE(AD.COMPANY,AD.CODE)
          ,trim(ad.tab_pref)
          ,trim(ad.Tab_Numb)
          ,nvl(ad.last_jobbeg_date, ad.jobbegin_date)
          ,nvl(nvl(ag.fullname, ag.agnfamilyname||' '||ag.agnfirstname||' '||ag.agnlastname),'-')
    from
      CLNPERSONS        AD
     ,AGNLIST           AG
    where AD.PERS_AGENT = AG.RN
      and exists (select null from V_USERPRIV UP where UP.CATALOG = AD.CRN)
      and ad.company = pkg_session.get_company()
  );
  return '<DictionaryInterface UnitCode="UdotDictionary" Method="normal">'
     || '<Params><Param Name="' || sIN_PARAM  || '"><ParamTypes><In>1</In></ParamTypes><Control>'||sCONTROL||'</Control></Param>'
     || '<Param Name="' || sOUT_PARAM || '"><ParamTypes><Out>1</Out></ParamTypes><Control>'||sCONTROL||'</Control></Param>'
     || '<Param Name="in_COUNT_IDENT"><ParamTypes><In>1</In></ParamTypes><Constant>1000</Constant></Param>'
     || '<Param Name="in_UNITCODE"><ParamTypes><In>1</In></ParamTypes><Constant>ClientPersons</Constant></Param>'
     || '</Params></DictionaryInterface>';
end UDOT_GET_PERSONS_DICT_DESCR;
/

grant execute on UDOT_GET_PERSONS_DICT_DESCR to public;

create or replace function UDOT_GET_PRAGNINF_DICT_DESCR
(
  sIN_PARAM    in varchar2   --     
 ,sOUT_PARAM   in varchar2   --     
 ,sCONTROL     in varchar2   --          
)
return varchar2
as
  nCOUNT       number;
  nCOMPANY     number;
begin
  delete from UDOT_VIRTUALDICT;

--: 200824718
--: 40839
--: 41205
-- : PersonAgentAddInfoTypes
--: PRAGNINF
--select * from PRAGNINF t where t.rn = 200824718
--PARUS, Administrator, 23.11.2017 17:45:63948, 212.5.81.211, I,
--AgentAddInfo
    insert into UDOT_VIRTUALDICT(RN, COMPANY, CRN, CODE, NAME, NUMB, NOTE)
     (select ad.rn
            ,pkg_session.get_company()
            ,ad.crn
            ,ad.code
            ,ad.name
            ,'-'
            ,'-'
      from PRAGNINF AD
      where exists (select null from V_USERPRIV UP where UP.CATALOG = AD.CRN)
    );
    return '<DictionaryInterface UnitCode="UdotDictionary" Method="normal">'
       || '<Params><Param Name="' || sIN_PARAM  || '"><ParamTypes><In>1</In></ParamTypes><Control>'||sCONTROL||'</Control></Param>'
       || '<Param Name="' || sOUT_PARAM || '"><ParamTypes><Out>1</Out></ParamTypes><Control>'||sCONTROL||'</Control></Param>'
       || '<Param Name="in_UNITCODE"><ParamTypes><In>1</In></ParamTypes><Constant>PersonAgentAddInfoTypes</Constant></Param>'
       || '</Params></DictionaryInterface>';
end UDOT_GET_PRAGNINF_DICT_DESCR;
/

grant execute on UDOT_GET_PRAGNINF_DICT_DESCR to public;

create or replace function UDOT_GET_PERSDOCUMS_DICT_DESCR
(
  nRN          in number     --   
 ,sIN_PARAM    in varchar2   --     
 ,sOUT_PARAM   in varchar2   --     
 ,sCONTROL     in varchar2   --          
)
return varchar2
as
  nCOUNT       number;
  nCOMPANY     number;
begin
  delete from UDOT_VIRTUALDICT;

  select count(1)
    into nCOUNT
    from AGNLIST  S
   where S.rn = nRN;
  if nCOUNT > 0 then
    insert into UDOT_VIRTUALDICT(RN, COMPANY, CRN, CODE, NAME, PREF, NUMB, DOCDATE, NOTE)
     (select ad.rn
            ,pkg_session.get_company()
            ,ad.crn
            ,trim(ad.docser||' '||ad.docnumb)
            ,pt.name||',  '||ad.docser||',  '||ad.docnumb||',  '||to_char(ad.docwhen,'dd.mm.yyyy')
            ,ad.docser
            ,nvl(ad.docnumb,'-')
            ,ad.docwhen
            ,pt.name||',  '||ad.docser||',  '||ad.docnumb||',  '||to_char(ad.docwhen,'dd.mm.yyyy')||' '||ad.docwho||',   '||ad.depart_code
      from
        AGNDOCUMS         AD
       ,AGNPASSTYPE       PT
      where AD.PRN = NRN
        and AD.AGNPASSTYPE = PT.RN
        and PKG_ENV_VIEW.PROLOGUE('AGN_VIEW_DOCUM') = 1
        and PKG_ENV_VIEW.EPILOGUE(null,AD.VERSION,AD.CRN,null,null,'AGNLIST','AGN_VIEW_DOCUM','AGNLIST',AD.PRN) = 1
        and exists (select null from V_USERPRIV UP where UP.CATALOG = AD.CRN)
    );
  end if;

  return '<DictionaryInterface UnitCode="UdotDictionary" Method="list">'
     || '<Params><Param Name="' || sIN_PARAM  || '"><ParamTypes><In>1</In></ParamTypes><Control>'||sCONTROL||'</Control></Param>'
     || '<Param Name="' || sOUT_PARAM || '"><ParamTypes><Out>1</Out></ParamTypes><Control>'||sCONTROL||'</Control></Param>'
     || '<Param Name="in_UNITCODE"><ParamTypes><In>1</In></ParamTypes><Constant>AGNLIST</Constant></Param>'
     || '</Params></DictionaryInterface>';

end UDOT_GET_PERSDOCUMS_DICT_DESCR;
/

grant execute on UDOT_GET_PERSDOCUMS_DICT_DESCR to public;

spool off

