
spool c:\BSPb\Parus8\Addon\logs\__create_objects_UdoSalaryRegistersOpenAccounts.log

create or replace procedure P_UDOT_SLREGOPACC_JOINS
(
  nCOMPANY                  in number,       --   
  sJUR_PERS                 in varchar2,     --  ()
  sDOCTYPES                 in varchar2,     --   ()
  sAGNBANKS                 in varchar2,     --  () ()
  sCURNAMES                 in varchar2,     --  (  ISO)
  sBANKPRG                  in varchar2,     --   ()
  sBANKACCTYPES             in varchar2,     --   ( ) ()
  nJUR_PERS                 out number,      -- 
  nDOC_TYPE                 out number,      --   (  DOCTYPES(RN))
  nAGNBANKS                 out number,      --  ()
  nCURNAMES                 out number,      -- 
  nBANKPRG                  out number,      --  
  nBANKACCTYPES             out number       --   ( )
)
as
begin
  -- 
  FIND_JURPERSONS_CODE( 0,0,nCOMPANY,sJUR_PERS,nJUR_PERS );

  --  
  FIND_DOCTYPES_CODE_EX( 0,0,nCOMPANY,sDOCTYPES,nDOC_TYPE );

  --  ()
  FIND_AGNBANKS_AGENT( 0, nCOMPANY, sAGNBANKS, nAGNBANKS );

  -- 
  if rtrim(sCURNAMES) is not null then
    FIND_CURRENCY_ISO( 0, nCOMPANY, sCURNAMES, nCURNAMES );
  end if;

  --  
  FIND_BANKPRG_CODE( 0, 1, nCOMPANY, sBANKPRG, nBANKPRG );

  --   ( )
  FIND_BANKACCTYPES_CODE( 0, 1, nCOMPANY, sBANKACCTYPES, nBANKACCTYPES );
end P_UDOT_SLREGOPACC_JOINS;
/

grant execute on P_UDOT_SLREGOPACC_JOINS to public;

/*        */
create table UDOT_SLREGOPACC (
/*   */
RN number(17) not null,
/*    */
COMPANY number(17) not null,
/*    */
CRN number(17) not null,
/*     */
JUR_PERS number(17) not null,
/*      (.) */
JPERS number(17) not null,
/*     */
DOC_TYPE number(17) not null,
/*   */
DOC_PREF varchar2(80) default null,
/*   */
DOC_NUMB varchar2(80) not null,
/*   */
DOC_DATE date not null,
/*      () */
DOC_YEAR number(4) not null,
/*    */
AGNBANKS number(17) not null,
/*      ( .) */
AGNJURDOCS number(17) default null,
/*    */
CURNAMES number(17) default null,
/*     (  ,  ) */
RESIDENT_SIGN number(1) default 1 not null,
/*      */
BANKPRG number(17) default null,
/*      */
BANKACCTYPES number(17) default null,
/*     */
IS_UNLOAD number(1) default 0 not null,
/*    */
FORM_DATE date default null,
/*     */
BDATAR blob default null,
/*     */
BDATAN blob default null,
/*     */
FILENAME_RES varchar2(160) default null,
/*     */
FILENAME_NOR varchar2(160) default null,
/*      */
CDATAR clob default null,
/*       */
CDATAN clob default null,
/*    */
SIGN_ERROR number(1) default 0 not null,
constraint C_UDOT_SLREGOPACC_PK primary key (RN)  using index tablespace &INDX_B1709,
constraint C_UDOT_SLREGOPACC_DOC_TYPE_UK unique (COMPANY,JPERS,DOC_YEAR,DOC_TYPE,DOC_PREF,DOC_NUMB)  using index tablespace &INDX_B1709,
constraint C_UDOT_SLREGOPACC_DOC_NUMB_NB check (rtrim(DOC_NUMB) is not null),
constraint C_UDOT_SLREGOPACC_DOC_PREF_NB check (DOC_PREF is null or rtrim(DOC_PREF) is not null),
constraint C_UDOT_SLREGOPACC_IS_UNLOAD_V check (IS_UNLOAD in (0,1)),
constraint C_UDOT_SLREGOPACC_RESIDENT_VAL check (RESIDENT_SIGN in (0,1,2)),
constraint C_UDOT_SLREGOPACC_SIGN_ERROR_V check (SIGN_ERROR in (0,1))
)
LOB (BDATAR) store as (tablespace &LOBS_B1709 NOCACHE NOLOGGING)
LOB (BDATAN) store as (tablespace &LOBS_B1709 NOCACHE LOGGING)
LOB (CDATAR) store as (tablespace &LOBS_B1709 NOCACHE LOGGING)
LOB (CDATAN) store as (tablespace &LOBS_B1709 NOCACHE LOGGING);
-- Add comments to the table and to the columns
comment on table UDOT_SLREGOPACC
  is '      ';
comment on column UDOT_SLREGOPACC.RN
  is ' ';
comment on column UDOT_SLREGOPACC.COMPANY
  is '  ';
comment on column UDOT_SLREGOPACC.CRN
  is '  ';
comment on column UDOT_SLREGOPACC.JUR_PERS
  is '   ';
comment on column UDOT_SLREGOPACC.JPERS
  is '     (.)';
comment on column UDOT_SLREGOPACC.DOC_TYPE
  is '   ';
comment on column UDOT_SLREGOPACC.DOC_PREF
  is ' ';
comment on column UDOT_SLREGOPACC.DOC_NUMB
  is ' ';
comment on column UDOT_SLREGOPACC.DOC_DATE
  is ' ';
comment on column UDOT_SLREGOPACC.DOC_YEAR
  is '     ()';
comment on column UDOT_SLREGOPACC.AGNBANKS
  is '  ';
comment on column UDOT_SLREGOPACC.AGNJURDOCS
  is '     ( .)';
comment on column UDOT_SLREGOPACC.CURNAMES
  is '  ';
comment on column UDOT_SLREGOPACC.RESIDENT_SIGN
  is '    (  ,  )';
comment on column UDOT_SLREGOPACC.BANKPRG
  is '    ';
comment on column UDOT_SLREGOPACC.BANKACCTYPES
  is '    ';
comment on column UDOT_SLREGOPACC.IS_UNLOAD
  is '   ';
comment on column UDOT_SLREGOPACC.FORM_DATE
  is '  ';
comment on column UDOT_SLREGOPACC.BDATAR
  is '   ';
comment on column UDOT_SLREGOPACC.BDATAN
  is '   ';
comment on column UDOT_SLREGOPACC.FILENAME_RES
  is '   ';
comment on column UDOT_SLREGOPACC.FILENAME_NOR
  is '   ';
comment on column UDOT_SLREGOPACC.CDATAR
  is '    ';
comment on column UDOT_SLREGOPACC.CDATAN
  is '     ';
comment on column UDOT_SLREGOPACC.SIGN_ERROR
  is '  ';
-- Create foreign key constraints
alter table UDOT_SLREGOPACC add (
constraint C_UDOT_SLREGOPACC_CRN_FK foreign key (CRN)
  references ACATALOG (RN),
constraint C_UDOT_SLREGOPACC_AGNBANKS_FK foreign key (AGNBANKS)
  references AGNBANKS (RN),
constraint C_UDOT_SLREGOPACC_AGNJURDOC_FK foreign key (AGNJURDOCS)
  references AGNJURDOCS (RN),
constraint C_UDOT_SLREGOPACC_BANKACCTY_FK foreign key (BANKACCTYPES)
  references BANKACCTYPES (RN),
constraint C_UDOT_SLREGOPACC_BANKPRG_FK foreign key (BANKPRG)
  references BANKPRG (RN),
constraint C_UDOT_SLREGOPACC_COMPANY_FK foreign key (COMPANY)
  references COMPANIES (RN),
constraint C_UDOT_SLREGOPACC_CURNAMES_FK foreign key (CURNAMES)
  references CURNAMES (RN),
constraint C_UDOT_SLREGOPACC_DOC_TYPE_FK foreign key (DOC_TYPE)
  references DOCTYPES (RN),
constraint C_UDOT_SLREGOPACC_JURPERS_FK foreign key (JUR_PERS)
  references JURPERSONS (RN)
);

/* UDOT_SLREGOPACCPR */
create table UDOT_SLREGOPACCPR (
DUMMY varchar2(1) default null,
RN number(17) not null,
COMPANY number(17) not null,
CRN number(17) not null,
PRN number(17) not null,
JUR_PERS number(17) not null,
CLNPERSONS number(17) not null,
AGNADDRESSES number(17) default null,
PERS_DOC number(17) default null,
RF_DOC number(17) default null,
CURNAMES number(17) default null,
RESIDENT_SIGN number(1) default 1 not null,
BANKPRG number(17) default null,
BANKACCTYPES number(17) default null,
EMBOSS varchar2(40) default null,
CONTROL_INF varchar2(100) default null,
RECIEVE_TYPE number(1) default 0 not null,
SMS_COUNTRY varchar2(2) default null,
SMS_PHONE varchar2(10) default null,
RECIEVE_CARD number(1) default 0 not null,
INCOME number(17,2) default 0 not null,
JOBBEGIN date default null,
ACCNT varchar2(40) default null,
ACCNT_OPEN number(1) default 0 not null,
constraint C_UDOT_SLREGOPACCPR_PK primary key (RN)  using index tablespace &INDX_B1709,
constraint C_UDOT_SLREGOPACCPR_PERSON_UK unique (PRN,CLNPERSONS)  using index tablespace &INDX_B1709,
constraint C_UDOT_SLREGOPACCPR_ACCNT_NB check (ACCNT is null or rtrim( ACCNT ) is not null),
constraint C_UDOT_SLREGOPACCPR_ACOPEN_VAL check (ACCNT_OPEN in (0,1)),
constraint C_UDOT_SLREGOPACCPR_CONTROL_NB check (CONTROL_INF is null or rtrim(CONTROL_INF) is not null),
constraint C_UDOT_SLREGOPACCPR_EMBOSS_NB check (EMBOSS is null or rtrim(EMBOSS) is not null),
constraint C_UDOT_SLREGOPACCPR_RECARD_VAL check (RECIEVE_CARD in (0,1,2)),
constraint C_UDOT_SLREGOPACCPR_RESID_VAL check (RESIDENT_SIGN in (0,1)),
constraint C_UDOT_SLREGOPACCPR_RETYPE_VAL check (RECIEVE_TYPE in (0,1,2)),
constraint C_UDOT_SLREGOPACCPR_SMSCNTR_NB check (SMS_COUNTRY is null or rtrim(SMS_COUNTRY) is not null),
constraint C_UDOT_SLREGOPACCPR_SMSPHON_NB check (SMS_PHONE is null or rtrim(SMS_PHONE) is not null)
);
-- Add comments to the table and to the columns
comment on table UDOT_SLREGOPACCPR
  is 'UDOT_SLREGOPACCPR';
-- Create foreign key constraints
alter table UDOT_SLREGOPACCPR add (
constraint C_UDOT_SLREGOPACCPR_CRN_FK foreign key (CRN)
  references ACATALOG (RN),
constraint C_UDOT_SLREGOPACCPR_ADDR_FK foreign key (AGNADDRESSES)
  references AGNADDRESSES (RN),
constraint C_UDOT_SLREGOPACCPR_PERSDOC_FK foreign key (PERS_DOC)
  references AGNDOCUMS (RN),
constraint C_UDOT_SLREGOPACCPR_RF_DOC_FK foreign key (RF_DOC)
  references AGNDOCUMS (RN),
constraint C_UDOT_SLREGOPACCPR_BACCTYP_FK foreign key (BANKACCTYPES)
  references BANKACCTYPES (RN),
constraint C_UDOT_SLREGOPACCPR_BANKPRG_FK foreign key (BANKPRG)
  references BANKPRG (RN),
constraint C_UDOT_SLREGOPACCPR_PERSONS_FK foreign key (CLNPERSONS)
  references CLNPERSONS (RN),
constraint C_UDOT_SLREGOPACCPR_COMPANY_FK foreign key (COMPANY)
  references COMPANIES (RN),
constraint C_UDOT_SLREGOPACCPR_CURNAME_FK foreign key (CURNAMES)
  references CURNAMES (RN),
constraint C_UDOT_SLREGOPACCPR_JURPERS_FK foreign key (JUR_PERS)
  references JURPERSONS (RN),
constraint C_UDOT_SLREGOPACCPR_PRN_FK foreign key (PRN)
  references UDOT_SLREGOPACC (RN) on delete cascade
);

/* V_UDOT_SLREGOPACC */
create or replace view V_UDOT_SLREGOPACC (
  NRN,
  NCOMPANY,
  NCRN,
  NJUR_PERS,
  SJUR_PERS,
  NDOC_TYPE,
  SDOCTYPES,
  SDOC_PREF,
  SDOC_NUMB,
  DDOC_DATE,
  NAGNBANKS,
  SAGNBANKS,
  NAGNJURDOCS,
  SAGNJURDOCS_DOCKIND,
  SAGNJURDOCS_DOCSER,
  SAGNJURDOCS_DOCNUMB,
  DAGNJURDOCS_DATE_WHEN,
  NCURNAMES,
  SCURNAMES,
  NRESIDENT_SIGN,
  NBANKPRG,
  SBANKPRG,
  NBANKACCTYPES,
  SBANKACCTYPES,
  NAGENT,
  SAGENT,
  NIS_UNLOAD,
  DFORM_DATE,
  SFILENAME_RES,
  SFILENAME_NOR,
  NSIGN_ERROR,
  NHAS_PERS
) as
select
  T.RN,                                 -- nRN
  T.COMPANY,                            -- nCOMPANY
  T.CRN,                                -- nCRN
  T.JUR_PERS,                           -- nJUR_PERS
  J.CODE,                               -- sJUR_PERS
  T.DOC_TYPE,                           -- nDOC_TYPE
  D.DOCCODE,                            -- sDOCTYPES
  trim(T.DOC_PREF),                     -- sDOC_PREF
  trim(T.DOC_NUMB),                     -- sDOC_NUMB
  T.DOC_DATE,                           -- dDOC_DATE
  T.AGNBANKS,                           -- nAGNBANKS
  AGN.AGNABBR,                          -- sAGNBANKS
  T.AGNJURDOCS,                         -- nAGNJURDOCS
  B.CODE,                               -- sAGNJURDOCS_DOCKIND
  A2.DOCSER,                            -- sAGNJURDOCS_DOCSER
  A2.DOCNUMB,                           -- sAGNJURDOCS_DOCNUMB
  A2.DATE_WHEN,                         -- dAGNJURDOCS_DATE_WHEN
  T.CURNAMES,                           -- nCURNAMES
  C.INTCODE,                            -- sCURNAMES
  T.RESIDENT_SIGN,                      -- nRESIDENT_SIGN
  T.BANKPRG,                            -- nBANKPRG
  B2.CODE,                              -- sBANKPRG
  T.BANKACCTYPES,                       -- nBANKACCTYPES
  B3.CODE,                              -- sBANKACCTYPES
  J.AGENT,                              -- nAGENT
  AJ.AGNABBR,                           -- sAGENT
  T.IS_UNLOAD,                          -- nIS_UNLOAD
  T.FORM_DATE,                          -- dFORM_DATE
  T.FILENAME_RES,                       -- sFILENAME_RES
  T.FILENAME_NOR,                       -- sFILENAME_NOR
  T.SIGN_ERROR,                         -- nSIGN_ERROR
  case
    when exists (select null from UDOT_SLREGOPACCPR where PRN = T.RN)
      then 1
      else 0
  end                                   -- nHAS_PERS
from
  UDOT_SLREGOPACC   T,
  JURPERSONS        J,
  DOCTYPES          D,
  AGNBANKS          A,
  AGNLIST           AGN,
  AGNJURDOCS        A2,
  BNDOCKIND         B,
  CURNAMES          C,
  BANKPRG           B2,
  BANKACCTYPES      B3,
  AGNLIST           AJ
where T.JUR_PERS     = J.RN
  and J.AGENT        = AJ.RN
  and T.DOC_TYPE     = D.RN
  and T.AGNBANKS     = A.RN
  and A.AGNRN        = AGN.RN
  and T.AGNJURDOCS   = A2.RN(+)
  and A2.BNDOCKIND   = B.RN(+)
  and T.CURNAMES     = C.RN(+)
  and T.BANKPRG      = B2.RN(+)
  and T.BANKACCTYPES = B3.RN(+)
  and exists (select null from V_USERPRIV UP where UP.CATALOG = T.CRN)
  and exists (select null from V_USERPRIV UP where UP.JUR_PERS = T.JUR_PERS and UP.UNITCODE = 'UdotSalaryRegistersOpenAccounts')
;

grant select on V_UDOT_SLREGOPACC to public;

create or replace procedure P_PDUP_UDOT_SLREGOPACCPR_EMBOS
(
  nPROCEDURE      in number,
  nCOMPANY        in number,
  nPERS_AGENT     in number,
  sEMBOSS        out varchar2
)
as
  sBLOCK_TEXT     PKG_STD.tSQL;
begin
  /*   */
  if ( nPROCEDURE is null ) then
    return;
  end if;

  /*     */
  if ( PKG_PDUP.DESCRIBE_PROLOGUE(nPROCEDURE,'UDOT_SLREGOPACCPR_EMBOSS',sBLOCK_TEXT) ) then
    PKG_PDUP.DESCRIBE_PARAMETER( 'COMPANY', PKG_STD.PARAM_TYPE_IN, PKG_STD.DATA_TYPE_NUM );
    PKG_PDUP.DESCRIBE_PARAMETER( 'NCOMPANY',PKG_STD.PARAM_TYPE_IN, PKG_STD.DATA_TYPE_NUM ); --  "COMPANY"
    PKG_PDUP.DESCRIBE_PARAMETER( 'NPERS_AGENT',PKG_STD.PARAM_TYPE_IN, PKG_STD.DATA_TYPE_NUM );
    PKG_PDUP.DESCRIBE_PARAMETER( 'SEMBOSS',PKG_STD.PARAM_TYPE_OUT,PKG_STD.DATA_TYPE_STR );
    PKG_PDUP.DESCRIBE_EPILOGUE( sBLOCK_TEXT );
  end if;

  /*   */
  begin
    execute immediate sBLOCK_TEXT
      using in  nCOMPANY,
            in  nCOMPANY,
            in  nPERS_AGENT,
            out sEMBOSS;
  exception
    when OTHERS then
      PKG_MSG.QUERY_EXEC_ERROR( sBLOCK_TEXT,GET_USERPROCS_CODE_ID(0,nPROCEDURE) );
  end;
end P_PDUP_UDOT_SLREGOPACCPR_EMBOS;
/

create or replace procedure P_UDOT_SLREGOPACC_GETNEXTNUMB
(
  nCOMPANY      in number,
  sJUR_PERS     in varchar2,
  sDOCTYPES     in varchar2,
  sDOC_PREF     in varchar2,
  dDOC_DATE     in date,
  sDOC_NUMB     out varchar2
)
as
  nDOCTYPES     PKG_STD.tREF;
  nJUR_PERS     PKG_STD.tREF;
begin
  if rtrim(sDOCTYPES) is null or rtrim(sJUR_PERS) is null then
    return;
  end if;

  FIND_DOCTYPES_CODE_EX( 0,0,nCOMPANY,sDOCTYPES,nDOCTYPES );
  FIND_JURPERSONS_CODE( 0,0,nCOMPANY,sJUR_PERS,nJUR_PERS );

  PKG_DOCUMENT.NEXT_NUMBER( nCOMPANY, 80, '', 'UDOT_SLREGOPACC', 'JPERS', 'DOC_YEAR', 'DOC_TYPE', 'DOC_PREF', 'DOC_NUMB',
    null, null, null, null, null, null, null,
    null, nJUR_PERS, D_YEAR(dDOC_DATE), nDOCTYPES, sDOC_PREF, sDOC_NUMB );
end P_UDOT_SLREGOPACC_GETNEXTNUMB;
/

grant execute on P_UDOT_SLREGOPACC_GETNEXTNUMB to public;

create or replace function P_TOOLS_NOW
return date
as
begin
  return trunc( sysdate );
end;
/

grant execute on P_TOOLS_NOW to public;

create or replace procedure P_UDOT_SLREGOPACC_BASE_COND
as
begin
  /*    */
  PKG_COND_BROKER.SET_TABLE( 'UDOT_SLREGOPACC' );
  PKG_COND_BROKER.SET_GROUP( 'SPEC','UDOT_SLREGOPACCPR','PRN','RN' );

  /*    */

  -- // 
  PKG_COND_BROKER.ADD_CONDITION_CODE( 'DOCCODE','DOCTYPE','DOC_TYPE <- RN;DOCTYPES' );
  -- //  ..
  PKG_COND_BROKER.ADD_CONDITION_BETWEEN( 'DOC_PREF','DOCPREFFrom','DOCPREFTo',null,80,80 );
  -- //  ..
  PKG_COND_BROKER.ADD_CONDITION_BETWEEN( 'DOC_NUMB','DOCNUMBFrom','DOCNUMBTo',null,80,80 );
  -- //  ..
  PKG_COND_BROKER.ADD_CONDITION_BETWEEN( 'DOC_DATE','DOCDATEFrom','DOCDATETo' );

  -- //
  PKG_COND_BROKER.ADD_CONDITION_CODE( 'CODE','JURPERS','JUR_PERS <- RN;JURPERSONS' );
  -- // ()
  PKG_COND_BROKER.ADD_CONDITION_CODE( 'AGNABBR','BANK','AGNBANKS <- RN;AGNBANKS;AGNRN <- RN;AGNLIST' );
  -- //
  PKG_COND_BROKER.ADD_CONDITION_CODE( 'INTCODE','CURRENCY','CURNAMES <- RN;CURNAMES' );
  -- // 
  PKG_COND_BROKER.ADD_CONDITION_CODE( 'CODE','BANKPROG','BANKPRG <- RN;BANKPRG' );
  -- //  ( )
  PKG_COND_BROKER.ADD_CONDITION_CODE( 'CODE','BANKACCTYPE','BANKACCTYPES <- RN;BANKACCTYPES' );
  -- //  ..
  PKG_COND_BROKER.ADD_CONDITION_BETWEEN( 'FORM_DATE','FORMDATEFrom','FORMDATETo' );

  -- //
  PKG_COND_BROKER.ADD_CONDITION_COMPARE( 'IS_UNLOAD','=','IS_UNLOAD' );

  -- //
  PKG_COND_BROKER.ADD_GROUP_CONDITION_CODE( 'SPEC','F_CLNPERSONS_FORMAT_CODE(COMPANY,CODE)','PERSON','CLNPERSONS <- RN;CLNPERSONS' );
  -- //    ..
  PKG_COND_BROKER.ADD_GROUP_CONDITION_BETWEEN( 'SPEC','JOBBEGIN','JOBBEGINFrom','JOBBEGINTo' );
  -- //
  PKG_COND_BROKER.ADD_GROUP_CONDITION_COMPARE( 'SPEC','RESIDENT_SIGN','=','RESIDENT' );

end P_UDOT_SLREGOPACC_BASE_COND;
/

grant execute on P_UDOT_SLREGOPACC_BASE_COND to public;

create or replace procedure P_UDOT_SLREGOPACC_BASE_UPDATE
(
  nRN                       in number,       --  
  nCOMPANY                  in number,       -- 
  nJUR_PERS                 in number,       -- 
  nDOC_TYPE                 in number,       --   (  DOCTYPES(RN))
  sDOC_PREF                 in varchar2,     --   
  sDOC_NUMB                 in varchar2,     --  
  dDOC_DATE                 in date,         --  
  nAGNBANKS                 in number,       --  ()
  nAGNJURDOCS               in number,       -- 
  nCURNAMES                 in number,       -- 
  nRESIDENT_SIGN            in number,       -- 
  nBANKPRG                  in number,       --  
  nBANKACCTYPES             in number        --   ( )
)
as
begin
  /*     */
  update UDOT_SLREGOPACC
     set JUR_PERS = nJUR_PERS,
         DOC_TYPE = nDOC_TYPE,
         DOC_PREF = sDOC_PREF,
         DOC_NUMB = sDOC_NUMB,
         DOC_DATE = dDOC_DATE,
         AGNBANKS = nAGNBANKS,
         AGNJURDOCS = nAGNJURDOCS,
         CURNAMES = nCURNAMES,
         RESIDENT_SIGN = nRESIDENT_SIGN,
         BANKPRG = nBANKPRG,
         BANKACCTYPES = nBANKACCTYPES
   where RN = nRN
     and COMPANY = nCOMPANY;

  if (SQL%NOTFOUND) then
    PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersOpenAccounts' );
  end if;
end;
/

create or replace trigger T_UDOT_SLREGOPACC_BINSERT
  before insert on UDOT_SLREGOPACC for each row
begin

  /*   */
  :new.DOC_NUMB := trimnumb( :new.DOC_NUMB,80 );

  /*   */
  :new.DOC_PREF := trimnumb( :new.DOC_PREF,80 );

  /*       */
  :new.JPERS     := :new.JUR_PERS;
  :new.DOC_YEAR  := d_year(:new.DOC_DATE);

  /*   */
  if ( PKG_IUD.PROLOGUE('UDOT_SLREGOPACC', 'I') ) then
    PKG_IUD.REG_RN('RN', :new.RN);
    PKG_IUD.REG_COMPANY('COMPANY', :new.COMPANY);
    PKG_IUD.REG_CRN('CRN', :new.CRN);
    PKG_IUD.REG_JUR_PERS(1, 'JUR_PERS', :new.JUR_PERS, 'JURPERSONS', 'CODE');
    PKG_IUD.REG( 'JPERS',:new.JPERS );
    PKG_IUD.REG(2, 'DOC_TYPE', :new.DOC_TYPE, 'DOCTYPES', 'DOCCODE');
    PKG_IUD.REG(3, 'DOC_PREF', :new.DOC_PREF);
    PKG_IUD.REG(4, 'DOC_NUMB', :new.DOC_NUMB);
    PKG_IUD.REG(5, 'DOC_DATE', :new.DOC_DATE);
    PKG_IUD.REG( 'DOC_YEAR',:new.DOC_YEAR );
    PKG_IUD.REG('AGNBANKS', :new.AGNBANKS);
    PKG_IUD.REG('AGNJURDOCS', :new.AGNJURDOCS);
    PKG_IUD.REG('CURNAMES', :new.CURNAMES);
    PKG_IUD.REG('RESIDENT_SIGN', :new.RESIDENT_SIGN);
    PKG_IUD.REG('BANKPRG', :new.BANKPRG);
    PKG_IUD.REG('BANKACCTYPES', :new.BANKACCTYPES);
    PKG_IUD.REG('IS_UNLOAD', :new.IS_UNLOAD);
    PKG_IUD.REG('FORM_DATE', :new.FORM_DATE);
    PKG_IUD.EPILOGUE;
  end if;
end T_UDOT_SLREGOPACC_BINSERT;
/

create index I_UDOT_SLREGOPACC_BANKACCTY_FK on UDOT_SLREGOPACC(BANKACCTYPES) tablespace &INDX_B1709;

create or replace procedure P_UDOT_SLREGOPACC_BASE_INSERT
(
  nCOMPANY                  in number,       -- 
  nCRN                      in number,       -- 
  nJUR_PERS                 in number,       -- 
  nDOC_TYPE                 in number,       --   (  DOCTYPES(RN))
  sDOC_PREF                 in varchar2,     --   
  sDOC_NUMB                 in varchar2,     --  
  dDOC_DATE                 in date,         --  
  nAGNBANKS                 in number,       --  ()
  nAGNJURDOCS               in number,       -- 
  nCURNAMES                 in number,       -- 
  nRESIDENT_SIGN            in number,       -- 
  nBANKPRG                  in number,       --  
  nBANKACCTYPES             in number,       --   ( )
  nRN                       out number       --  
)
as
begin
  /*    */
  nRN := gen_id;

  /*     */
  insert into UDOT_SLREGOPACC
  (
    RN,
    COMPANY,
    CRN,
    JUR_PERS,
    DOC_TYPE,
    DOC_PREF,
    DOC_NUMB,
    DOC_DATE,
    AGNBANKS,
    AGNJURDOCS,
    CURNAMES,
    RESIDENT_SIGN,
    BANKPRG,
    BANKACCTYPES
  )
  values
  (
    nRN,
    nCOMPANY,
    nCRN,
    nJUR_PERS,
    nDOC_TYPE,
    sDOC_PREF,
    sDOC_NUMB,
    dDOC_DATE,
    nAGNBANKS,
    nAGNJURDOCS,
    nCURNAMES,
    nRESIDENT_SIGN,
    nBANKPRG,
    nBANKACCTYPES
  );
end P_UDOT_SLREGOPACC_BASE_INSERT;
/

create or replace trigger T_UDOT_SLREGOPACC_BUPDATE
  before update on UDOT_SLREGOPACC for each row
begin
  /*     */
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGOPACC', 'RN', :new.RN, :old.RN);
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGOPACC', 'COMPANY', :new.COMPANY, :old.COMPANY);
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGOPACC', 'JUR_PERS', :new.JUR_PERS, :old.JUR_PERS);

  /*       */
  if ( CMP_NUM(:new.CRN,:old.CRN) = 1 ) then
    /*     dbf */
    if nvl(:old.is_unload,0) > 0 and nvl(:new.is_unload,0) > 0 then
      p_exception(0, '    dbf .  .');
    end if;
    /*   */
    :new.DOC_NUMB := trimnumb( :new.DOC_NUMB, 80 );
    /*   */
    :new.DOC_PREF := trimnumb( :new.DOC_PREF, 80 );
    /*       */
    :new.JPERS     := :new.JUR_PERS;
    :new.DOC_YEAR  := d_year(:new.DOC_DATE);
  end if;

  /*   */
  if ( PKG_IUD.PROLOGUE('UDOT_SLREGOPACC', 'U') ) then
    PKG_IUD.REG_RN('RN', :new.RN, :old.RN);
    PKG_IUD.REG_COMPANY('COMPANY', :new.COMPANY, :old.COMPANY);
    PKG_IUD.REG_CRN('CRN', :new.CRN, :old.CRN);
    PKG_IUD.REG_JUR_PERS(1, 'JUR_PERS', :new.JUR_PERS, :old.JUR_PERS, 'JURPERSONS', 'CODE');
    PKG_IUD.REG( 'JPERS',:new.JPERS,:old.JPERS );
    PKG_IUD.REG(2, 'DOC_TYPE', :new.DOC_TYPE, :old.DOC_TYPE, 'DOCTYPES', 'DOCCODE');
    PKG_IUD.REG(3, 'DOC_PREF', :new.DOC_PREF, :old.DOC_PREF);
    PKG_IUD.REG(4, 'DOC_NUMB', :new.DOC_NUMB, :old.DOC_NUMB);
    PKG_IUD.REG(5, 'DOC_DATE', :new.DOC_DATE, :old.DOC_DATE);
    PKG_IUD.REG( 'DOC_YEAR',:new.DOC_YEAR,:old.DOC_YEAR );
    PKG_IUD.REG('AGNBANKS', :new.AGNBANKS, :old.AGNBANKS);
    PKG_IUD.REG('AGNJURDOCS', :new.AGNJURDOCS, :old.AGNJURDOCS);
    PKG_IUD.REG('CURNAMES', :new.CURNAMES, :old.CURNAMES);
    PKG_IUD.REG('RESIDENT_SIGN', :new.RESIDENT_SIGN, :old.RESIDENT_SIGN);
    PKG_IUD.REG('BANKPRG', :new.BANKPRG, :old.BANKPRG);
    PKG_IUD.REG('BANKACCTYPES', :new.BANKACCTYPES, :old.BANKACCTYPES);
    PKG_IUD.REG('IS_UNLOAD', :new.IS_UNLOAD, :old.IS_UNLOAD);
    PKG_IUD.REG('FORM_DATE', :new.FORM_DATE, :old.FORM_DATE);
    PKG_IUD.EPILOGUE;
  end if;
end T_UDOT_SLREGOPACC_BUPDATE;
/

create index I_UDOT_SLREGOPACC_AGNJURDOC_FK on UDOT_SLREGOPACC(AGNJURDOCS) tablespace &INDX_B1709;

create index I_UDOT_SLREGOPACC_CRN_FK on UDOT_SLREGOPACC(CRN) tablespace &INDX_B1709;

create or replace procedure P_UDOT_SLREGOPACC_GET_ATTRIB
(
  NRN             in number,            --   
  NHAS_PERS       out number            -- NHAS_PERS
)
as
begin
  begin
    select
      case
      when exists (select null from UDOT_SLREGOPACCPR where PRN = T.RN)
      then 1
      else 0
      end                                   -- nHAS_PERS
    into
      NHAS_PERS
    from
      UDOT_SLREGOPACC T
    where T.RN = NRN
      and exists (select null from V_USERPRIV UP where UP.CATALOG = T.CRN)
      and exists (select null from V_USERPRIV UP where UP.JUR_PERS = T.JUR_PERS and UP.UNITCODE = 'UdotSalaryRegistersOpenAccounts');
  exception
    when NO_DATA_FOUND then
      PKG_MSG.RECORD_NOT_FOUND(NRN, 'UdotSalaryRegistersOpenAccounts');
  end;
end P_UDOT_SLREGOPACC_GET_ATTRIB;
/

grant execute on P_UDOT_SLREGOPACC_GET_ATTRIB to public;

create or replace trigger T_UDOT_SLREGOPACC_ADELETE
  after delete on UDOT_SLREGOPACC for each row
begin
  /*       */
  P_LOG_DELETE( :old.RN,'UdotSalaryRegistersOpenAccounts' );
end;
/

create index I_UDOT_SLREGOPACC_JURPERS_FK on UDOT_SLREGOPACC(JUR_PERS) tablespace &INDX_B1709;

create or replace procedure P_UDOT_SLREGOPACC_UNFORMING
(
  nCOMPANY         in number,
  nRN              in number    -- 
)
as
begin
  for rec in
  (
    select CRN,
           JUR_PERS,
           IS_UNLOAD
      from UDOT_SLREGOPACC
     where RN = nRN
  )
  loop
    if rec.IS_UNLOAD = 1 then
      P_EXCEPTION(0, '    !');
    end if;

    /*     */
    PKG_ENV.PROLOGUE( nCOMPANY,null,rec.CRN,rec.JUR_PERS,null,'UdotSalaryRegistersOpenAccounts','UDOT_SLREGOPACC_UNFORM','UDOT_SLREGOPACC',nRN );

    delete from UDOT_SLREGOPACCPR
      where PRN = nRN;

    update UDOT_SLREGOPACC
       set FORM_DATE    = null
          ,FILENAME_RES = null
          ,FILENAME_NOR = null
          ,SIGN_ERROR   = 0
     where RN = nRN;
    if (SQL%NOTFOUND) then
      PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersOpenAccounts' );
    end if;

    /*     */
    PKG_ENV.EPILOGUE( nCOMPANY,null,rec.CRN,rec.JUR_PERS,null,'UdotSalaryRegistersOpenAccounts','UDOT_SLREGOPACC_UNFORM','UDOT_SLREGOPACC',nRN );
  end loop;
end P_UDOT_SLREGOPACC_UNFORMING;
/

grant execute on P_UDOT_SLREGOPACC_UNFORMING to public;

create or replace trigger T_UDOT_SLREGOPACC_BDELETE
  before delete on UDOT_SLREGOPACC for each row
begin
  /*     dbf */
  if nvl(:old.is_unload,0) > 0 then
    p_exception(0, '    dbf .  .');
  end if;

  /*      */
  P_LINKSALL_CHECK( :old.RN,:old.COMPANY,'UdotSalaryRegistersOpenAccounts' );

  /*   */
  if ( PKG_IUD.PROLOGUE('UDOT_SLREGOPACC', 'D') ) then
    PKG_IUD.REG_RN('RN', :old.RN);
    PKG_IUD.REG_COMPANY('COMPANY', :old.COMPANY);
    PKG_IUD.REG_CRN('CRN', :old.CRN);
    PKG_IUD.REG_JUR_PERS(1, 'JUR_PERS', :old.JUR_PERS, 'JURPERSONS', 'CODE');
    PKG_IUD.REG( 'JPERS',:old.JPERS );
    PKG_IUD.REG(2, 'DOC_TYPE', :old.DOC_TYPE, 'DOCTYPES', 'DOCCODE');
    PKG_IUD.REG(3, 'DOC_PREF', :old.DOC_PREF);
    PKG_IUD.REG(4, 'DOC_NUMB', :old.DOC_NUMB);
    PKG_IUD.REG(5, 'DOC_DATE', :old.DOC_DATE);
    PKG_IUD.REG( 'DOC_YEAR',:old.DOC_YEAR );
    PKG_IUD.REG('AGNBANKS', :old.AGNBANKS);
    PKG_IUD.REG('AGNJURDOCS', :old.AGNJURDOCS);
    PKG_IUD.REG('CURNAMES', :old.CURNAMES);
    PKG_IUD.REG('RESIDENT_SIGN', :old.RESIDENT_SIGN);
    PKG_IUD.REG('BANKPRG', :old.BANKPRG);
    PKG_IUD.REG('BANKACCTYPES', :old.BANKACCTYPES);
    PKG_IUD.REG('IS_UNLOAD', :old.IS_UNLOAD);
    PKG_IUD.REG('FORM_DATE', :old.FORM_DATE);
    PKG_IUD.EPILOGUE;
  end if;
end T_UDOT_SLREGOPACC_BDELETE;
/

create index I_UDOT_SLREGOPACC_AGNBANKS_FK on UDOT_SLREGOPACC(AGNBANKS) tablespace &INDX_B1709;

create index I_UDOT_SLREGOPACC_CURNAMES_FK on UDOT_SLREGOPACC(CURNAMES) tablespace &INDX_B1709;

create or replace procedure P_UDOT_SLREGOPACC_EXISTS
(
  nRN                       in number,       --  
  nCOMPANY                  in number,       -- 
  nCRN                      out number,      -- 
  nJUR_PERS                 out number,      -- 
  nIS_UNLOAD                out number       --    dbf 
)
as
begin
  /*   */
  begin
    select M.CRN, M.JUR_PERS, M.Is_Unload
      into nCRN,nJUR_PERS, nIS_UNLOAD
      from UDOT_SLREGOPACC  M
     where M.RN = nRN
       and M.COMPANY = nCOMPANY;
  exception
    when NO_DATA_FOUND then
      PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersOpenAccounts' );
  end;
end;
/

grant execute on P_UDOT_SLREGOPACC_EXISTS to public;

create or replace trigger T_UDOT_SLREGOPACC_AUPDATE
  after update on UDOT_SLREGOPACC for each row
begin
  /*       */
  P_LOG_UPDATE( :new.RN,'UdotSalaryRegistersOpenAccounts',:new.CRN,:old.CRN,:new.JUR_PERS,:old.JUR_PERS );
end;
/

create index I_UDOT_SLREGOPACC_DOC_TYPE_FK on UDOT_SLREGOPACC(DOC_TYPE) tablespace &INDX_B1709;

create or replace procedure P_UDOT_SLREGOPACC_BASE_DELETE
(
  nRN                       in number,       --  
  nCOMPANY                  in number        -- 
)
as
begin
  /*     */
  delete
    from UDOT_SLREGOPACC
   where RN = nRN
     and COMPANY = nCOMPANY;

  if (SQL%NOTFOUND) then
    PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersOpenAccounts' );
  end if;
end;
/

create or replace procedure P_UDOT_SLREGOPACC_FORM_EDIT
(
  SATTRIB                     in varchar2,     --  
  NFIRST                      in out number,   --  
  NCOMPANY                    in number,       -- 
  AGNJURDOCS                  in out number,
  NMODE                       in number,       --  (0 - , 1 - , 2 - )
  NIS_UNLOAD                  in out number,
  SDOCTYPES                   in out varchar2, --  
  SDOC_PREF                   in out varchar2, --  
  SDOC_NUMB                   in out varchar2, --  
  DDOC_DATE                   in out date,     --  
  NSDOCTYPES_ENAB             in out number,
  NSDOC_PREF_ENAB             in out number,
  NSDOC_NUMB_ENAB             in out number,
  NDDOC_DATE_ENAB             in out number,
  NSAGNBANKS_ENAB             in out number,
  NAGENT                      in out number,
  SJUR_PERS                   in out varchar2, -- 
  NSJUR_PERS_ENAB             in out number,   --  - 
  SCURNAMES                   in out varchar2, -- 
  NSCURNAMES_ENAB             in out number,   --  - 
  NRESIDENT_SIGN              in out number,   -- 
  NNRESIDENT_SIGN_ENAB        in out number,   --  - 
  SBANKPRG                    in out varchar2, --  
  NSBANKPRG_ENAB              in out number,   --   - 
  SBANKACCTYPES               in out varchar2, --   ( )
  NSBANKACCTYPES_ENAB         in out number,   --   ( ) - 
  SAGNJURDOCS_DOCKIND         in out varchar2, --   
  NSAGNJURDOCS_DOCKIND_ENAB   in out number,   --    - 
  SAGNJURDOCS_DOCSER          in out varchar2, --   
  NSAGNJURDOCS_DOCSER_ENAB    in out number,   --    - 
  SAGNJURDOCS_DOCNUMB         in out varchar2, --   
  NSAGNJURDOCS_DOCNUMB_ENAB   in out number,   --    - 
  DAGNJURDOCS_DATE_WHEN       in out date,     --    
  NDAGNJURDOCS_DATE_WHEN_ENAB in out number    --     - 
)
as

  procedure CheckEnable
  as
  begin
    PKG_EXT.SET_VALS( SAGNJURDOCS_DOCKIND, NSAGNJURDOCS_DOCKIND_ENAB, (not NAGENT is null), true );
    if (AGNJURDOCS is null) then
      SAGNJURDOCS_DOCKIND := null;
      SAGNJURDOCS_DOCSER := null;
      SAGNJURDOCS_DOCNUMB := null;
      DAGNJURDOCS_DATE_WHEN := null;
    end if;
  end CheckEnable;

  procedure GetNextNumb
  as
  begin
    P_UDOT_SLREGOPACC_GETNEXTNUMB( NCOMPANY, SJUR_PERS, SDOCTYPES, SDOC_PREF, DDOC_DATE, SDOC_NUMB );
  end GetNextNumb;

  procedure getJUR_PERS
  (
    IsInit        in boolean
  )
  as
    NFLAG_SMART1  PKG_STD.tLNUMBER := 1;
    NFLAG_OPTION1 PKG_STD.tLNUMBER := 1;
    SCODE1        PKG_STD.tSTRING := SJUR_PERS;
    NRN1          PKG_STD.tLNUMBER := null;
    NJRN1         PKG_STD.tLNUMBER;
    SJCODE1       PKG_STD.tSTRING;
    SJNAME1       PKG_STD.tSTRING;
    NJAGENT1      PKG_STD.tLNUMBER;
    SJAGENT1      PKG_STD.tSTRING;
  begin
    FIND_JURPERSONS_ALL( NFLAG_SMART1, NFLAG_OPTION1, NCOMPANY, SCODE1, NRN1, NJRN1, SJCODE1,
                         SJNAME1, NJAGENT1, SJAGENT1 );
    NAGENT := NJAGENT1;
    if (IsInit = false) then

      AGNJURDOCS := null;

    end if;
    CheckEnable;
  end getJUR_PERS;

begin

  if (NFIRST is null) or (NFIRST < 0) then
    NFIRST := 0;
  end if;

  if (NFIRST = 0) then
    PKG_EXT.SET_VALS( SAGNJURDOCS_DOCSER, NSAGNJURDOCS_DOCSER_ENAB, false );
    PKG_EXT.SET_VALS( SAGNJURDOCS_DOCNUMB, NSAGNJURDOCS_DOCNUMB_ENAB, false );
    PKG_EXT.SET_VALS( DAGNJURDOCS_DATE_WHEN, NDAGNJURDOCS_DATE_WHEN_ENAB, false );
    PKG_EXT.SET_VALS( SJUR_PERS, NSJUR_PERS_ENAB, NMODE < 2 );
    PKG_EXT.SET_VALS( SCURNAMES, NSCURNAMES_ENAB, NMODE < 2 );
    PKG_EXT.SET_VALS( NRESIDENT_SIGN, NNRESIDENT_SIGN_ENAB, NMODE < 2 );
    PKG_EXT.SET_VALS( SBANKPRG, NSBANKPRG_ENAB, NMODE < 2 );
    PKG_EXT.SET_VALS( SBANKACCTYPES, NSBANKACCTYPES_ENAB, NMODE < 2 );

    if (NMODE = 0) then
      SJUR_PERS := GET_OPTIONS_STR( 'JuridicalPerson', NCOMPANY );
      SDOCTYPES := GET_OPTIONS_STR( 'SalaryRegistersOpenAccounts_DocType', NCOMPANY );
      SDOC_PREF := GET_OPTIONS_STR( 'SalaryRegistersOpenAccounts_DocPref', NCOMPANY );
      DDOC_DATE := trim(sysdate);
    else
      if (AGNJURDOCS is not null) then
        begin
          select D.DATE_WHEN,
                 K.CODE,
                 D.DOCSER,
                 D.DOCNUMB
          into
            DAGNJURDOCS_DATE_WHEN,
            SAGNJURDOCS_DOCKIND,
            SAGNJURDOCS_DOCSER,
            SAGNJURDOCS_DOCNUMB
          from AGNJURDOCS D,
               BNDOCKIND K
          where (D.RN = AGNJURDOCS)
            and (D.BNDOCKIND = K.RN);
          exception
            when NO_DATA_FOUND then
              SAGNJURDOCS_DOCKIND := null;
        end;
      end if;
    end if;

    getJUR_PERS(true);
    CheckEnable;
    if (NMODE < 2) then
      GetNextNumb;
    else
      if (NIS_UNLOAD = 1) then
        NSDOCTYPES_ENAB := 0;
        NSDOC_PREF_ENAB := 0;
        NSDOC_NUMB_ENAB := 0;
        NDDOC_DATE_ENAB := 0;
        NSAGNBANKS_ENAB := 0;
        NSJUR_PERS_ENAB:= 0;
        NSCURNAMES_ENAB:= 0;
        NNRESIDENT_SIGN_ENAB:= 0;
        NSBANKPRG_ENAB:= 0;
        NSBANKACCTYPES_ENAB:= 0;
        NSAGNJURDOCS_DOCKIND_ENAB:= 0;
        NSAGNJURDOCS_DOCSER_ENAB:= 0;
        NSAGNJURDOCS_DOCNUMB_ENAB:= 0;
        NDAGNJURDOCS_DATE_WHEN_ENAB:= 0;
      end if;
    end if;
    NFIRST := 1;
  end if;

  case SATTRIB
    when 'SJUR_PERS' then
      getJUR_PERS(false);
    when 'NEXTNUMB' then
      GetNextNumb;
    when 'SAGNJURDOCS_DOCKIND' then
      if (SAGNJURDOCS_DOCKIND is null) then
        CheckEnable;
      end if;
    else null;
  end case;

end P_UDOT_SLREGOPACC_FORM_EDIT;
/

grant execute on P_UDOT_SLREGOPACC_FORM_EDIT to public;

create index I_UDOT_SLREGOPACC_BANKPRG_FK on UDOT_SLREGOPACC(BANKPRG) tablespace &INDX_B1709;

create or replace procedure P_UDOT_SLREGOPACC_DELETE
(
  nRN                       in number,       --  
  nCOMPANY                  in number        -- 
)
as
  nCRN                      PKG_STD.tREF;    -- 
  nJUR_PERS                 PKG_STD.tREF;    -- 
  nIS_UNLOAD                pkg_std.tref;
begin
  /*   */
  P_UDOT_SLREGOPACC_EXISTS
  (
    nRN,
    nCOMPANY,
    nCRN,
    nJUR_PERS,
    nIS_UNLOAD
  );

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersOpenAccounts','UDOT_SLREGOPACC_DELETE','UDOT_SLREGOPACC',nRN );

  /*   */
  P_UDOT_SLREGOPACC_BASE_DELETE
  (
    nRN,
    nCOMPANY
  );

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersOpenAccounts','UDOT_SLREGOPACC_DELETE','UDOT_SLREGOPACC',nRN );
end P_UDOT_SLREGOPACC_DELETE;
/

grant execute on P_UDOT_SLREGOPACC_DELETE to public;

create or replace procedure P_UDOT_SLREGOPACC_CLEAR_DBF
(
  nCOMPANY          in number,    -- 
  nRN               in number     --   
)
as
  nCRN              pkg_std.tref;
  nJUR_PERS         pkg_std.tref;
  nIS_UNLOAD        pkg_std.tref;
begin
  --   
  p_udot_slregopacc_exists(nRN, nCOMPANY, nCRN, nJUR_PERS, nIS_UNLOAD);
  --     DBF 
  if nvl(nIS_UNLOAD,0) = 0 then
    p_exception(0, '    dbf .   .');
  end if;

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersOpenAccounts','UDOT_SLREGOPACC_CLEAR_DBF','UDOT_SLREGOPACC',nRN );

  update UDOT_SLREGOPACC u
     set u.is_unload  = 0
        ,u.sign_error = 0
        ,u.bdatar     = empty_blob
        ,u.bdatan     = empty_blob
        ,u.cdatar     = empty_clob
        ,u.cdatan     = empty_clob
        ,u.filename_res = null --nvl2(u.filename_res,'CLEAR_'||u.filename_res,u.filename_res)
        ,u.filename_nor = null --nvl2(u.filename_nor,'CLEAR_'||u.filename_nor,u.filename_nor)
   where u.rn = nRN;

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersOpenAccounts','UDOT_SLREGOPACC_CLEAR_DBF','UDOT_SLREGOPACC',nRN );

end P_UDOT_SLREGOPACC_CLEAR_DBF;
/

grant execute on P_UDOT_SLREGOPACC_CLEAR_DBF to public;

create or replace procedure P_UDOT_SLREGOPACC_MOVE
(
  nCOMPANY      in number,
  nRN           in number,
  nCRN          in number
)
as
  nCRN1         PKG_STD.tREF;
  nJUR_PERS     PKG_STD.tREF;
  nIS_UNLOAD    pkg_std.tref;
begin
  /*   */
  P_UDOT_SLREGOPACC_EXISTS ( nCOMPANY, nRN, nCRN1, nJUR_PERS, nIS_UNLOAD);

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY, null, nCRN1, nJUR_PERS, 'UdotSalaryRegistersOpenAccounts', 'UDOT_SLREGOPACC_MOVE_OUT', 'UDOT_SLREGOPACC', nRN );
  PKG_ENV.PROLOGUE( nCOMPANY, null, nCRN, nJUR_PERS,  'UdotSalaryRegistersOpenAccounts', 'UDOT_SLREGOPACC_MOVE_IN',  'UDOT_SLREGOPACC', nRN );

  /*   */
  update UDOT_SLREGOPACC
     set CRN = nCRN
    where RN = nRN
      and COMPANY = nCOMPANY;

  if ( SQL%NOTFOUND ) then
    PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersOpenAccounts' );
  end if;

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY, null, nCRN1, nJUR_PERS, 'UdotSalaryRegistersOpenAccounts', 'UDOT_SLREGOPACC_MOVE_OUT', 'UDOT_SLREGOPACC', nRN );
  PKG_ENV.EPILOGUE( nCOMPANY, null, nCRN, nJUR_PERS,  'UdotSalaryRegistersOpenAccounts', 'UDOT_SLREGOPACC_MOVE_IN',  'UDOT_SLREGOPACC', nRN );
end P_UDOT_SLREGOPACC_MOVE;
/

grant execute on P_UDOT_SLREGOPACC_MOVE to public;

create or replace procedure P_UDOT_SLREGOPACC_UPDATE
(
  nRN                       in number,       --  
  nCOMPANY                  in number,       -- 
  sJUR_PERS                 in varchar2,     --  ()
  sDOCTYPES                 in varchar2,     --   ()
  sDOC_PREF                 in varchar2,     --   
  sDOC_NUMB                 in varchar2,     --  
  dDOC_DATE                 in date,         --  
  sAGNBANKS                 in varchar2,     --  () ()
  nAGNJURDOCS               in number,       -- 
  sCURNAMES                 in varchar2,     --  (  ISO)
  nRESIDENT_SIGN            in number,       -- 
  sBANKPRG                  in varchar2,     --   ()
  sBANKACCTYPES             in varchar2      --   ( ) ()
)
as
  nCRN                      PKG_STD.tREF;    -- 
  nJUR_PERS                 PKG_STD.tREF;    -- 
  nIS_UNLOAD                pkg_std.tref;
  nDOC_TYPE                 PKG_STD.tREF;    --   (  DOCTYPES(RN))
  nAGNBANKS                 PKG_STD.tREF;    --  ()
  nCURNAMES                 PKG_STD.tREF;    -- 
  nBANKPRG                  PKG_STD.tREF;    --  
  nBANKACCTYPES             PKG_STD.tREF;    --   ( )
begin
  /*   */
  P_UDOT_SLREGOPACC_EXISTS
  (
    nRN,
    nCOMPANY,
    nCRN,
    nJUR_PERS,
    nIS_UNLOAD
  );

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersOpenAccounts','UDOT_SLREGOPACC_UPDATE','UDOT_SLREGOPACC',nRN );

  /*   */
  P_UDOT_SLREGOPACC_JOINS
  (
    nCOMPANY,
    sJUR_PERS,
    sDOCTYPES,
    sAGNBANKS,
    sCURNAMES,
    sBANKPRG,
    sBANKACCTYPES,
    nJUR_PERS,
    nDOC_TYPE,
    nAGNBANKS,
    nCURNAMES,
    nBANKPRG,
    nBANKACCTYPES
  );

  /*   */
  P_UDOT_SLREGOPACC_BASE_UPDATE
  (
    nRN,
    nCOMPANY,
    nJUR_PERS,
    nDOC_TYPE,
    sDOC_PREF,
    sDOC_NUMB,
    dDOC_DATE,
    nAGNBANKS,
    nAGNJURDOCS,
    nCURNAMES,
    nRESIDENT_SIGN,
    nBANKPRG,
    nBANKACCTYPES
  );

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersOpenAccounts','UDOT_SLREGOPACC_UPDATE','UDOT_SLREGOPACC',nRN );
end P_UDOT_SLREGOPACC_UPDATE;
/

grant execute on P_UDOT_SLREGOPACC_UPDATE to public;

create or replace procedure P_UDOT_SLREGOPACC_INSERT
(
  nCOMPANY                  in number,       -- 
  nCRN                      in number,       -- 
  sJUR_PERS                 in varchar2,     --  ()
  sDOCTYPES                 in varchar2,     --   ()
  sDOC_PREF                 in varchar2,     --   
  sDOC_NUMB                 in varchar2,     --  
  dDOC_DATE                 in date,         --  
  sAGNBANKS                 in varchar2,     --  () ()
  nAGNJURDOCS               in number,       -- 
  sCURNAMES                 in varchar2,     --  (  ISO)
  nRESIDENT_SIGN            in number,       -- 
  sBANKPRG                  in varchar2,     --   ()
  sBANKACCTYPES             in varchar2,     --   ( ) ()
  nRN                       out number       --  
)
as
  nJUR_PERS                 PKG_STD.tREF;    -- 
  nDOC_TYPE                 PKG_STD.tREF;    --   (  DOCTYPES(RN))
  nAGNBANKS                 PKG_STD.tREF;    --  ()
  nCURNAMES                 PKG_STD.tREF;    -- 
  nBANKPRG                  PKG_STD.tREF;    --  
  nBANKACCTYPES             PKG_STD.tREF;    --   ( )
begin
  /*   */
  P_UDOT_SLREGOPACC_JOINS
  (
    nCOMPANY,
    sJUR_PERS,
    sDOCTYPES,
    sAGNBANKS,
    sCURNAMES,
    sBANKPRG,
    sBANKACCTYPES,
    nJUR_PERS,
    nDOC_TYPE,
    nAGNBANKS,
    nCURNAMES,
    nBANKPRG,
    nBANKACCTYPES
  );

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersOpenAccounts','UDOT_SLREGOPACC_INSERT','UDOT_SLREGOPACC' );

  /*   */
  P_UDOT_SLREGOPACC_BASE_INSERT
  (
    nCOMPANY,
    nCRN,
    nJUR_PERS,
    nDOC_TYPE,
    sDOC_PREF,
    sDOC_NUMB,
    dDOC_DATE,
    nAGNBANKS,
    nAGNJURDOCS,
    nCURNAMES,
    nRESIDENT_SIGN,
    nBANKPRG,
    nBANKACCTYPES,
    nRN
  );

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersOpenAccounts','UDOT_SLREGOPACC_INSERT','UDOT_SLREGOPACC',nRN );
end P_UDOT_SLREGOPACC_INSERT;
/

grant execute on P_UDOT_SLREGOPACC_INSERT to public;

create or replace procedure                   P_UDOT_SLREGOPACC_MAKE_DBF
(
  nCOMPANY     in number     -- 
 ,nRN          in number     --   
 ,sDOP_ORG     in varchar2   --     
 ,sDOP_GEO     in varchar2   --          ()
 ,nPROCESS     in number     --  
 ,nSIGN_OLD    in number     --      ( )
 ,sMSG         out varchar2  --   
)
as
/*
    dbf     
*/
  type tRecFile is record
  (
    nRN        FILE_BUFFER.RN%type
   ,sFILENAME  FILE_BUFFER.FILENAME%type
   ,sTYPE      varchar2(1)
  );
  type tTabFiles is table of tRecFile index by binary_integer;
  aTableFiles       tTabFiles;
--  sPERS             PKG_STD.tLSTRING;
  sERR              PKG_STD.tLSTRING;
  sWARN             PKG_STD.tLSTRING;
  sTMP              PKG_STD.tLSTRING;
  sCARD_CODE        PKG_STD.tLSTRING;

  nDOCS_PROPS_ORG   pkg_std.tref;
  nDOP_GEO          pkg_std.tref;

  nRESIDENT_SIGN    UDOT_SLREGOPACCPR.RESIDENT_SIGN%type := null;
  sFILENAME_SAVE    FILE_BUFFER.FILENAME%type;
  sFILENAME         varchar2(40);
  sCOMP_CODE        varchar2(40);
  bBLOB             BLOB;
  cLOG              CLOB;
--  sLAT              constant varchar2(26)  := 'abcdefghijklmnopqrstuvwxyz';
--  sRUS              constant varchar2(33)  := '';
--  sDIG              constant varchar2(10)  := '1234567890';
  sDELIM            constant varchar2(3)   := ''' -';
  sERR_RUS_DELIM    constant varchar2(240) := '   ,     , ,   ';
  sERR_RUSLAT_DELIM constant varchar2(240) := '   ,       , ,   ';
  sCOUNTRY_LIST     varchar2(240) := ';AZ;AM;BY;EE;GE;KZ;KG;LV;LT;MD;RU;TJ;TM;UA;UZ;';
--  nRN               pkg_std.tref;
  nCRN              pkg_std.tref;
  nJUR_PERS         pkg_std.tref;
  nIS_UNLOAD        pkg_std.tref;
  nTMP              pkg_std.tref;
  rCURRENT_PERS     BANK_SPB_PNFF_DBF%rowtype;
  nCOUNT_PERS       number := 0;  --    
  nCOUNT_ERR        number := 0;  --    

  function CHECK_ERR
  (
    sMASK           in varchar2,
    sSTRING         in varchar2
  )
  return boolean
  as
  begin
--    for i in 1..nvl(length(sSTRING),0) loop
--      if instr(sMASK, lower(substr(sSTRING,i,1))) = 0 then
--        return true;
--      end if;
--    end loop;
    return (regexp_replace(lower(sSTRING),'['||sMASK||']','') is not null);
  end CHECK_ERR;

  procedure GET_EMBOSS
  (
    sEMBOSS         in varchar2
  )
  as
  begin
--    sPERS := sPERS||sEMBOSS||';';
    if sEMBOSS is null then
      sERR := sERR||':  "     "  '||CR;
    elsif length(sEMBOSS) > 22 then
      sERR := sERR||' "     "     22  ('||sEMBOSS||')'||CR;
    end if;
  end GET_EMBOSS;

  procedure GET_AGNBURN
  (
    dAGNBURN        in date
  )
  as
  begin
--    sPERS := sPERS||to_char(dAGNBURN,'DD.MM.YYYY')||';';
    if dAGNBURN is null then
      sERR := sERR||':  " "  '||CR;
    end if;
  end GET_AGNBURN;

  --        
  procedure WRITE_FIELD_CONTROL
  (
    sFIELD      in varchar2
   ,dDATE_VAL   in date default null
   ,nNUMB_VAL   in number default null
   ,sSTR_VAL    in varchar2 default null
  )
  as
    error_field_name  exception;
    error_data_vals   exception;
    sTYPE             varchar2(40);
  begin
    if not (dDATE_VAL is null and nNUMB_VAL is null and sSTR_VAL is null
            or dDATE_VAL is null and nNUMB_VAL is null and sSTR_VAL is not null
            or dDATE_VAL is null and nNUMB_VAL is not null and sSTR_VAL is null
            or dDATE_VAL is not null and nNUMB_VAL is null and sSTR_VAL is null
           )
    then
      raise error_data_vals;
    end if;
    if upper(sFIELD) = 'FNAME' then
      sTYPE  := '(32)';
      rCURRENT_PERS.fname := sSTR_VAL;
    elsif upper(sFIELD) = 'LNAME' then
      sTYPE  := '(32)';
      rCURRENT_PERS.lname := sSTR_VAL;
    elsif upper(sFIELD) = 'SNAME' then
      sTYPE  := '(32)';
      rCURRENT_PERS.sname := sSTR_VAL;
    elsif upper(sFIELD) = 'SEX' then
      sTYPE  := '(1)';
      rCURRENT_PERS.sex := sSTR_VAL;
    elsif upper(sFIELD) = 'BIRTHDAY' then
      sTYPE  := '';
      rCURRENT_PERS.Birthday := dDATE_VAL;
    elsif upper(sFIELD) = 'PLACE_B' then
      sTYPE  := '(250)';
      rCURRENT_PERS.Place_b := sSTR_VAL;
    elsif upper(sFIELD) = 'COUNTRY' then
      sTYPE  := '(2)';
      rCURRENT_PERS.Country := sSTR_VAL;
    elsif upper(sFIELD) = 'INDEX' then
      sTYPE  := '(6)';
      rCURRENT_PERS."INDEX" := nNUMB_VAL;
    elsif upper(sFIELD) = 'AREA' then
      sTYPE  := '(40)';
      rCURRENT_PERS.area := sSTR_VAL;
    elsif upper(sFIELD) = 'PUNKT' then
      sTYPE  := '(40)';
      rCURRENT_PERS.Punkt := sSTR_VAL;
    elsif upper(sFIELD) = 'CITY' then
      sTYPE  := '(35)';
      rCURRENT_PERS.city := sSTR_VAL;
    elsif upper(sFIELD) = 'STREET' then
      sTYPE  := '(30)';
      rCURRENT_PERS.street := sSTR_VAL;
    elsif upper(sFIELD) = 'HOUSE' then
      sTYPE  := '(7)';
      rCURRENT_PERS.house := sSTR_VAL;
    elsif upper(sFIELD) = 'BLOCK' then
      sTYPE  := '(7)';
      rCURRENT_PERS."BLOCK" := sSTR_VAL;
    elsif upper(sFIELD) = 'APPART' then
      sTYPE  := '(7)';
      rCURRENT_PERS.appart := sSTR_VAL;
    elsif upper(sFIELD) = 'ADRESS' then
      sTYPE  := '(80)';
      rCURRENT_PERS.adress := sSTR_VAL;
    elsif upper(sFIELD) = 'PHONE' then
      sTYPE  := '(20)';
      rCURRENT_PERS.phone := sSTR_VAL;
    elsif upper(sFIELD) = 'PASNOM' then
      sTYPE  := '(20)';
      rCURRENT_PERS.pasnom := sSTR_VAL;
    elsif upper(sFIELD) = 'PASDAT' then
      sTYPE  := '';
      rCURRENT_PERS.pasdat := dDATE_VAL;
    elsif upper(sFIELD) = 'PASPLACE' then
      sTYPE  := '(250)';
      rCURRENT_PERS.pasplace := sSTR_VAL;
    elsif upper(sFIELD) = 'MKART' then
      sTYPE  := '(100)';
      rCURRENT_PERS.mkart := sSTR_VAL;
    elsif upper(sFIELD) = 'PERMIS' then
      sTYPE  := '(100)';
      rCURRENT_PERS.permis := sSTR_VAL;
    elsif upper(sFIELD) = 'COMPANY' then
      sTYPE  := '(15)';
      rCURRENT_PERS.company := nNUMB_VAL;
    elsif upper(sFIELD) = 'TABNOM' then
      sTYPE  := '(15)';
      rCURRENT_PERS.tabnom := nNUMB_VAL;
    elsif upper(sFIELD) = 'INDCOD' then
      sTYPE  := '(4)';
      rCURRENT_PERS.indcod := nNUMB_VAL;
    else
      raise error_field_name;
    end if;
  exception
    when error_field_name then
      p_exception(0,'     "'||sFIELD||'"');
    when error_data_vals then
      p_exception(0, '    "'||sFIELD||'"     ,   (dDATE="'||dDATE_VAL||'", nNUMB="'||nNUMB_VAL||'", sSTRING="'||sSTR_VAL||'")');
    when others then
      p_exception(0, '  "'||rCURRENT_PERS.fname||' '||rCURRENT_PERS.lname||' '||rCURRENT_PERS.sname||'"     "'||sFIELD||'"       :  - "'||sTYPE||'",   (dDATE="'||dDATE_VAL||'", nNUMB="'||nNUMB_VAL||'", sSTRING="'||sSTR_VAL||'")');
  end WRITE_FIELD_CONTROL;

  procedure CREATE_DBF_FILE
  (
    nSIGN_RES     in number
   ,sFILE_NAME    in varchar2
   ,nDOC          in number
   ,nIS_UNLOAD    in number
  )
  as
  begin
    --   
    dbms_lob.trim(bBLOB,0);
    if nCOUNT_ERR = 0 and nCOUNT_PERS > 0 then
      --     
      sTMP := CR||CR||chr(9)||chr(9)||'  "'||sFILE_NAME||'"   .'||CR;
      dbms_lob.writeappend(cLOG, length(sTMP), sTMP);
      --   BANK_SPB_PNFF_DBF   dbf
      pkg_dbase.DUMP_TABLE_BLOB
      (
        sTABLE_NAME   => 'BANK_SPB_PNFF_DBF'
       ,bDATA         => bBlob
       ,sCOLUMNS      => 'FNAME,LNAME,SNAME,SEX,BIRTHDAY,PLACE_B,COUNTRY,INDEX,AREA,PUNKT,CITY,STREET,HOUSE,BLOCK,APPART,ADRESS,PHONE,PASNOM,PASDAT,PASPLACE,MKART,PERMIS,COMPANY,TABNOM,INDCOD'
       ,sWHERE_CLAUSE => ''
       ,nCONVERT      => 1  --  dbase-IV
      );
      --   dbf  
      insert into FILE_BUFFER(IDENT, FILENAME, BDATA) values (nPROCESS, sFILE_NAME, bBLOB);
    end if;
    --  dbf    
    if nSIGN_RES = 1 then
      aTableFiles(aTableFiles.count + 1).sType  := 'P';
      aTableFiles(aTableFiles.count).sFilename  := sFILE_NAME;
      update UDOT_SLREGOPACC u
         set u.bdatar       = bBLOB
            ,u.cdatar       = cLOG
            ,u.sign_error   = greatest(sign(nCOUNT_ERR),u.sign_error)
       where RN = nDOC;
    elsif nSIGN_RES = 0 then
      aTableFiles(aTableFiles.count + 1).sType  := 'N';
      aTableFiles(aTableFiles.count).sFilename  := sFILE_NAME;
      update UDOT_SLREGOPACC u
         set u.bdatan       = bBLOB
            ,u.cdatan       = cLOG
            ,u.sign_error   = greatest(sign(nCOUNT_ERR),u.sign_error)
       where RN = nDOC;
    end if;

    if (SQL%NOTFOUND) then
      PKG_MSG.RECORD_NOT_FOUND( nDOC,'UdotSalaryRegistersOpenAccounts' );
    end if;
    --     
    aTableFiles(aTableFiles.count + 1).sFilename := replace(sFILE_NAME,'.dbf','.log');
    insert into FILE_BUFFER(IDENT, FILENAME, BDATA) values (nPROCESS, replace(sFILE_NAME,'.dbf','.log'), clob2blob(cLOG));
    dbms_lob.trim(bBLOB,0);
    dbms_lob.trim(cLOG,0);

  end CREATE_DBF_FILE;

begin
  dbms_lob.createtemporary(bBLOB, True, dbms_lob.CALL);
  dbms_lob.createtemporary(cLOG, True, dbms_lob.CALL);
  --   
  p_udot_slregopacc_exists
  (
    nRN        => nRN
   ,nCOMPANY   => nCOMPANY
   ,nCRN       => nCRN
   ,nJUR_PERS  => nJUR_PERS
   ,nIS_UNLOAD => nIS_UNLOAD
  );
  --   .  .
  find_docs_props_code(0, nCOMPANY, sDOP_ORG, nDOCS_PROPS_ORG);
  --  .   ( )
  find_docs_props_code(0, nCOMPANY, sDOP_GEO, nDOP_GEO);
  --      .    .,
  --    ,       
  for rc_k in (
  select EV.STR_VALUE, rownum as numb_row
    from DOCS_PROPS         P
        ,EXTRA_DICTS_VALUES EV
   where P.rn = nDOP_GEO
     and P.EXTRA_DICT_RN = EV.PRN
  ) loop
    if rc_k.numb_row = 1 then
      sCOUNTRY_LIST  := ';'||rc_k.str_value||';';
    else
      sCOUNTRY_LIST  := sCOUNTRY_LIST||rc_k.str_value||';';
    end if;
  end loop;
  --     
  select count(1)
    into nCOUNT_PERS
    from UDOT_SLREGOPACCPR  P
   where P.Prn = nRN;

  if nCOUNT_PERS = 0 then
    p_exception(0, '  (RN='||nRN||')  .   dbf .');
  else
    nCOUNT_PERS  := 0;
  end if;

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersOpenAccounts','UDOT_SLREGOPACC_MAKE_DBF','UDOT_SLREGOPACC',nRN );

  --   
  begin
    select (select dv.str_value from DOCS_PROPS_VALS dv
             where dv.unitcode = 'AGNLIST' and dv.unit_rn = j.agent
               and dv.docs_prop_rn = nDOCS_PROPS_ORG--200824720
           )         as  sCOMPANY
      into sCOMP_CODE
      from jurpersons j
     where j.rn = nJUR_PERS;
    if trim(sCOMP_CODE) is null then
      p_exception(0, '       "    "     .');
    elsif length(trim(sCOMP_CODE)) <> 9 then
      p_exception(0, '   "    "            9  ('||trim(sCOMP_CODE)||').');
    end if;
  exception
    when no_data_found then
      p_exception(0, '       "    "     .');
  end;

  --      
  sFILENAME   := substr(sCOMP_CODE, 3, 2)||substr(sCOMP_CODE, 1, 2)||'_'||substr(sCOMP_CODE, 5);

  --       ,
  --    ,     
  if nSIGN_OLD = 1 and nIS_UNLOAD = 1 then
    --     
    for rc in (
    select u.filename_res
          ,u.bdatar, u.cdatar
          ,u.filename_nor
          ,u.bdatan, u.cdatan
      from UDOT_SLREGOPACC u
     where u.rn = nRN
    ) loop
      if rc.filename_res is not null then
        insert into FILE_BUFFER(IDENT, FILENAME, BDATA) values (nPROCESS, rc.filename_res, rc.bdatar);
        insert into FILE_BUFFER(IDENT, FILENAME, BDATA) values (nPROCESS, replace(rc.filename_res,'.dbf','.log'), clob2blob(rc.cdatar));
      end if;
      if rc.filename_nor is not null then
        insert into FILE_BUFFER(IDENT, FILENAME, BDATA) values (nPROCESS, rc.filename_nor, rc.bdatan);
        insert into FILE_BUFFER(IDENT, FILENAME, BDATA) values (nPROCESS, replace(rc.filename_nor,'.dbf','.log'), clob2blob(rc.cdatan));
      end if;
    end loop;
  elsif nIS_UNLOAD = 0 then

    --     
    update UDOT_SLREGOPACC
       set SIGN_ERROR   = 0
     where RN = nRN;
    nRESIDENT_SIGN := null;
    -- 
    for recs in
    (
      select T.RESIDENT_SIGN,
             nvl(BPS.CARD_CODE,nvl(BAT.CODE,'_'))     CARD_CODE,
             A.AGNFAMILYNAME,
             A.AGNFIRSTNAME,
             A.AGNLASTNAME,
             A.AGNABBR,
             A.AGNBURN,
             A.ADDR_BURN,
             decode(A.SEX,1,'',2,'',null)           SEX,
             A.PHONE                                  PHONE,
             A.PHONE2,
             A.MAIL,
             A.PENSION_NBR,
             C.PERS_AGENT,
             C.TAB_PREF,
             C.TAB_NUMB,
             decode(T.RESIDENT_SIGN,0,'N','P')        R_SYMB,
             decode(T.RECIEVE_TYPE,0,'P',2,'E',null)  RECIEVE_TYPE,
             nvl(T.JOBBEGIN,nvl(C.LAST_JOBBEG_DATE,C.JOBBEGIN_DATE))
                                                      JOBBEGIN,
             T.CONTROL_INF,
             T.EMBOSS,
             T.INCOME,
             T.AGNADDRESSES,
             regexp_replace(T.SMS_COUNTRY||T.SMS_PHONE, '[^[:digit:]]')
                                                      SMS_PHONE,
             trim(A2.DOCSER)                          PERS_DOC_SER,
             trim(A2.DOCNUMB)                         PERS_DOC_NUMB,
             A2.DOCWHEN                               PERS_DOC_DATE,
             substr(A2.DOCWHO,1,100)                  PERS_DOC_WHO,
             A2.DEPART_CODE                           PERS_DOC_DEPART,
             A2.DOC_ENDDATE                           PERS_DOC_ENDDATE,
            (select dv.str_value
               from DOCS_PROPS_VALS dv
                   ,AGNPASSTYPE     TP
              where TP.rn = A2.AGNPASSTYPE
                and dv.unitcode = 'GEOGRAFY'
                and dv.unit_rn = TP.COUNTRY
                and dv.docs_prop_rn = nDOP_GEO
             )                                        PERS_DOC_CODE_COUNTRY, --    
             A5.GNI_CODE                              RF_DOC_GNI_CODE,
             A5.NAME                                  RF_DOC_NAME,
             trim(A4.DOCSER)                          RF_DOC_SER,
             trim(A4.DOCNUMB)                         RF_DOC_NUMB,
             A4.DOC_BEGINDATE                         RF_DOC_BEGINDATE,
             A4.DOC_ENDDATE                           RF_DOC_ENDDATE,
             AG.ADDR_POST,
            (select CS.CODE from GEOGRAFY CS
              where CS.RN = A.CITIZENSHIP)            CITIZENSHIP
           ,(select dv.str_value
               from DOCS_PROPS_VALS dv
              where dv.unitcode = 'GEOGRAFY'
                and dv.unit_rn = A.CITIZENSHIP
                and dv.docs_prop_rn = nDOP_GEO
             )                                        CODE_CITIZENSHIP       --    
        from UDOT_SLREGOPACCPR T,
             CLNPERSONS        C,
             AGNLIST           A,
             BANKACCTYPES      BAT,
             BANKPRGSP         BPS,
             AGNDOCUMS         A2,
             AGNDOCUMS         A4,
             AGNPASSTYPE       A5,
             AGNADDRESSES      AG
       where T.CLNPERSONS   = C.RN
         and C.PERS_AGENT   = A.RN
         and T.BANKPRG      = BPS.PRN(+)
         and T.BANKACCTYPES = BPS.BANKACCTYPES(+)
         and T.BANKACCTYPES = BAT.RN(+)
         and T.PERS_DOC     = A2.RN(+)
         and T.RF_DOC       = A4.RN(+)
         and A4.AGNPASSTYPE = A5.RN(+)
         and T.AGNADDRESSES = AG.RN(+)
         and T.PRN          = nRN
       order by 1,2,3,4,5
    ) loop
      --   -    
      --      ,
      --         P_SLREGOPACC_UNL
      if CMP_NUM(nRESIDENT_SIGN, recs.RESIDENT_SIGN) = 0 then
        if nCOUNT_PERS > 0 or nCOUNT_ERR > 0 then
          CREATE_DBF_FILE
          (
            nSIGN_RES     => nRESIDENT_SIGN
           ,sFILE_NAME    => sFILENAME_SAVE
           ,nDOC          => nRN
           ,nIS_UNLOAD    => 0
          );
        end if;
        nRESIDENT_SIGN := recs.RESIDENT_SIGN;
        sCARD_CODE     := recs.CARD_CODE;
        if nRESIDENT_SIGN = 0 then
          sFILENAME_SAVE := 'N'||sFILENAME||'.dbf';  --UDOT_GET_FILENAME_BANKSPB(nCOMPANY, 'N', trunc(sysdate), sFILENAME);
        elsif nRESIDENT_SIGN = 1 then
          sFILENAME_SAVE := 'P'||sFILENAME||'.dbf';  --UDOT_GET_FILENAME_BANKSPB(nCOMPANY, 'P', trunc(sysdate), sFILENAME);
        else
          p_exception(0,'   "" = '||nRESIDENT_SIGN);
        end if;
        -- 
        sERR          := null;
        nCOUNT_PERS   := 0;
        nCOUNT_ERR    := 0;
        --   
        delete from BANK_SPB_PNFF_DBF;
      end if;
      rCURRENT_PERS := null;
      rCURRENT_PERS.Company := sCOMP_CODE;
      -- 
      --   
      sERR  := null;
      sWARN := null;
      if recs.AGNFAMILYNAME is null then
        sERR := ' <>    '||CR;
      elsif nRESIDENT_SIGN = 1 then
--        if CHECK_ERR(sRUS||'- ''', recs.AGNFAMILYNAME) then
        if regexp_replace(recs.AGNFAMILYNAME,'([--߸'||sDELIM||']*)','') is not null then
          sERR := ' "" '||sERR_RUS_DELIM||' ('||recs.AGNFAMILYNAME||')'||CR;
        else
          WRITE_FIELD_CONTROL(sFIELD => 'fname', sSTR_VAL => recs.AGNFAMILYNAME );
        end if;
      elsif nRESIDENT_SIGN = 0 then
--        if CHECK_ERR(sRUS||sLAT||'- ''', recs.AGNFAMILYNAME) then
        if regexp_replace(recs.AGNFAMILYNAME,'([[:alpha:]'||sDELIM||']*)','') is not null then
          sERR := ' "" '||sERR_RUSLAT_DELIM||' ('||recs.AGNFAMILYNAME||')'||CR;
        else
          WRITE_FIELD_CONTROL(sFIELD => 'fname', sSTR_VAL => recs.AGNFAMILYNAME );
        end if;
      else
        WRITE_FIELD_CONTROL(sFIELD => 'fname', sSTR_VAL => recs.AGNFAMILYNAME );
      end if;
--      p_exception(0,'Family - '||rCURRENT_PERS.Fname);
      if recs.AGNFIRSTNAME is null then
        sERR := sERR||' <>    '||CR;
      elsif nRESIDENT_SIGN = 1 then
        if regexp_replace(recs.AGNFIRSTNAME,'([--'||sDELIM||']*)','') is not null then
          sERR := sERR||' "" '||sERR_RUS_DELIM||' ('||recs.AGNFIRSTNAME||')'||CR;
        else
          WRITE_FIELD_CONTROL(sFIELD => 'Lname', sSTR_VAL => recs.AGNFIRSTNAME );
        end if;
      elsif nRESIDENT_SIGN = 0 then
        if regexp_replace(recs.AGNFIRSTNAME,'([[:alpha:]'||sDELIM||']*)','') is not null then
          sERR := sERR||' "" '||sERR_RUSLAT_DELIM||' ('||recs.AGNFIRSTNAME||')'||CR;
        else
          WRITE_FIELD_CONTROL(sFIELD => 'Lname', sSTR_VAL => recs.AGNFIRSTNAME );
        end if;
      else
        WRITE_FIELD_CONTROL(sFIELD => 'Lname', sSTR_VAL => recs.AGNFIRSTNAME );
      end if;
      if recs.AGNLASTNAME is null and recs.R_SYMB = 'P' then
        sERR := sERR||' <>    '||CR;
      elsif nRESIDENT_SIGN = 1 then
        if regexp_replace(recs.AGNLASTNAME,'([--'||sDELIM||']*)','') is not null then
          sERR := sERR||' "" '||sERR_RUS_DELIM||' ('||recs.AGNLASTNAME||')'||CR;
        else
          WRITE_FIELD_CONTROL(sFIELD => 'sname', sSTR_VAL => recs.AGNLASTNAME );
        end if;
      elsif nRESIDENT_SIGN = 0 then
        if regexp_replace(recs.AGNLASTNAME,'([[:alpha:]'||sDELIM||']*)','') is not null then
          sERR := sERR||' "" '||sERR_RUSLAT_DELIM||' ('||recs.AGNLASTNAME||')'||CR;
        else
          WRITE_FIELD_CONTROL(sFIELD => 'sname', sSTR_VAL => recs.AGNLASTNAME );
        end if;
      else
        WRITE_FIELD_CONTROL(sFIELD => 'sname', sSTR_VAL => recs.AGNLASTNAME );
      end if;
--      if recs.RESIDENT_SIGN = 0 then
--        GET_EMBOSS(recs.EMBOSS);
--      end if;
      if recs.SEX is null then
        sERR := sERR||' ""    '||CR;
      else
        WRITE_FIELD_CONTROL(sFIELD => 'sex', sSTR_VAL => recs.SEX );
      end if;
      if recs.AGNBURN is null then
        sERR := sERR||' " "    '||CR;
      else
        WRITE_FIELD_CONTROL(sFIELD => 'Birthday', dDATE_VAL => recs.AGNBURN );
      end if;
      --  
      sTMP := substr(nvl(recs.ADDR_BURN,
                     nvl(F_AGNADDRESSES_GET_STR(recs.PERS_AGENT,5,'T'),
                     nvl(F_AGNADDRESSES_GET_STR(recs.PERS_AGENT,5,'Y'),
                         F_AGNADDRESSES_GET_STR(recs.PERS_AGENT,5,'C')))),1,250);
      sTMP := trim(regexp_replace(sTMP, '([,]+)', ' '));
      if sTMP is null then
        sERR := sERR||' < >    '||CR;
      else
        WRITE_FIELD_CONTROL(sFIELD => 'Place_b', sSTR_VAL => sTMP );
      end if;
      --      
      if regexp_replace(recs.code_citizenship, '([A-Z]*)', '') is not null then
        sERR := sERR||' " " ()       ('||recs.code_citizenship||')'||CR;
      elsif recs.code_citizenship is not null and instr(sCOUNTRY_LIST, ';'||recs.code_citizenship||';') = 0 then
        sERR := sERR||' " " ()      ('||recs.code_citizenship||') - ('||sCOUNTRY_LIST||')'||CR;
      elsif nvl(length(recs.code_citizenship),0) <> 2 and nRESIDENT_SIGN = 0 then
        sERR := sERR||' " " ()        2   ('||recs.code_citizenship||')'||CR;
      elsif nRESIDENT_SIGN = 1 and (nvl(length(recs.code_citizenship),0) = 1 or nvl(length(recs.code_citizenship),0) > 2) then
        sERR := sERR||' " " ()        2      ('||recs.code_citizenship||')'||CR;
      else
        WRITE_FIELD_CONTROL(sFIELD => 'Country', sSTR_VAL => nvl(rCURRENT_PERS.Country, recs.code_citizenship) );
      end if;
      --          
      --      
/*
      if rCURRENT_PERS.Country is null then
        sWARN := sWARN||'  " " ()  .     .       .'||CR;
        if regexp_replace(recs.pers_doc_code_country, '([A-Z]*)', '') is not null then
          sERR := sERR||' " " ( )       ('||recs.pers_doc_code_country||')'||CR;
        elsif recs.pers_doc_code_country is not null and instr(sCOUNTRY_LIST, ';'||recs.pers_doc_code_country||';') = 0 then
          sERR := sERR||' " " ( )      ('||recs.pers_doc_code_country||') - ('||sCOUNTRY_LIST||')'||CR;
        elsif nvl(length(recs.pers_doc_code_country),0) <> 2 and nRESIDENT_SIGN = 0 then
          sERR := sERR||' " " ( )        2   ('||recs.pers_doc_code_country||')'||CR;
        elsif nRESIDENT_SIGN = 1 and (nvl(length(recs.pers_doc_code_country),0) = 1 or nvl(length(recs.pers_doc_code_country),0) > 2) then
          sERR := sERR||' " " ( )        2      ('||recs.pers_doc_code_country||')'||CR;
        else
          WRITE_FIELD_CONTROL(sFIELD => 'Country', sSTR_VAL => recs.pers_doc_code_country );
--          rCURRENT_PERS.Country := recs.pers_doc_code_country;
        end if;
      end if;
*/
      --  
      if recs.AGNADDRESSES is not null then
        sTMP  := F_AGNADDRESSES_GET_STR_EX(recs.AGNADDRESSES,'P');
        if regexp_replace(sTMP,'([[:digit:]]*)','') is not null then    -- 
          sERR := sERR||' ""       ('||sTMP||')'||CR;
        elsif length(sTMP) <> 6 then    -- 
          sERR := sERR||' ""      6  ('||sTMP||')'||CR;
        else
          WRITE_FIELD_CONTROL(sFIELD => 'Index', nNUMB_VAL => sTMP );
        end if;
        sTMP  := F_AGNADDRESSES_GET_STR_EX(recs.AGNADDRESSES,'RD');
        if length(sTMP) > 40 then
          sERR := sERR||' ""       40  ('||sTMP||')'||CR;
        end if;
        WRITE_FIELD_CONTROL(sFIELD => 'Area', sSTR_VAL => substr(sTMP,1,40) );
        sTMP  := F_AGNADDRESSES_GET_STR_EX(recs.AGNADDRESSES,'T');
        if length(sTMP) > 40 then
          sERR := sERR||' " "       40  ('||sTMP||')'||CR;
        end if;
        WRITE_FIELD_CONTROL(sFIELD => 'Punkt', sSTR_VAL => substr(sTMP,1,40) );
        sTMP  := nvl(F_AGNADDRESSES_GET_STR_EX(recs.AGNADDRESSES,'Y'),'-'); -- YU
        if length(sTMP) > 35 then
          sERR := sERR||' ""       35  ('||sTMP||')'||CR;
        end if;
        WRITE_FIELD_CONTROL(sFIELD => 'City', sSTR_VAL => substr(sTMP,1,35) );
        sTMP  := nvl(F_AGNADDRESSES_GET_STR_EX(recs.AGNADDRESSES,'S'),'-');
        if length(sTMP) > 30 then
          sERR := sERR||' ""       30  ('||sTMP||')'||CR;
        end if;
        WRITE_FIELD_CONTROL(sFIELD => 'Street', sSTR_VAL => substr(sTMP,1,30) );
        sTMP  := replace(nvl(F_AGNADDRESSES_GET_STR_EX(recs.AGNADDRESSES,'H'),'-'),'. ','');
        if length(sTMP) > 7 then
          sERR := sERR||' " "       7  ('||sTMP||')'||CR;
        end if;
        WRITE_FIELD_CONTROL(sFIELD => 'House', sSTR_VAL => substr(sTMP,1,7) );
        sTMP  := replace(nvl(F_AGNADDRESSES_GET_STR_EX(recs.AGNADDRESSES,'B'),'-'),'. ','');
        if length(sTMP) > 7 then
          sERR := sERR||' ""       7  ('||sTMP||')'||CR;
        end if;
        WRITE_FIELD_CONTROL(sFIELD => 'Block', sSTR_VAL => substr(sTMP,1,7) );
        sTMP  := replace(nvl(F_AGNADDRESSES_GET_STR_EX(recs.AGNADDRESSES,'F'),'-'),'. ','');
        if length(sTMP) > 7 then
          sERR := sERR||' ""       7  ('||sTMP||')'||CR;
        end if;
        WRITE_FIELD_CONTROL(sFIELD => 'Appart', sSTR_VAL => substr(sTMP,1,7) );
      else
        sERR := sERR||'    "  "'||CR;
      end if;
      --   (  )
      if recs.AGNADDRESSES is not null then
        sTMP := substr(F_AGNADDRESSES_GET_STR_EX(recs.AGNADDRESSES,'PRDYUTSVWHBLF'),1,80);
      end if;
      for reca in
      (
        select RN
          from AGNADDRESSES
         where PRN = recs.PERS_AGENT
           and REAL_SIGN + REGISTRATION_SIGN > 0
           and (REGISTRATION_DATE is null or REGISTRATION_DATE <= trunc(sysdate)/*rec.DOC_DATE*/)
           and (REGISTRATION_END is null or REGISTRATION_END >= trunc(sysdate)/*rec.DOC_DATE*/)
         order by REGISTRATION_SIGN desc
      )
      loop
        sTMP := substr(F_AGNADDRESSES_GET_STR_EX(reca.RN,'PRDYUTSVWHBLF'),1,80);
        exit;
      end loop;
      WRITE_FIELD_CONTROL(sFIELD => 'Adress', sSTR_VAL => sTMP );
      if sTMP is null then
        sERR := sERR||'    "  "'||CR;
      end if;
      -- 
      recs.PHONE := regexp_replace(recs.PHONE, '([^[:digit:]]*)', '');
      if trim(recs.PHONE) is null then
        sERR := sERR||' </ >    '||CR;
      elsif length(recs.PHONE) > 20 then
        sERR := sERR||' "/ "     20  ('||recs.PHONE||')'||CR;
--      elsif substr(recs.PHONE,1,1) <> '7' then
--        sERR := sERR||' "/ "      "7"     ('||recs.PHONE||')'||CR;
      else
        WRITE_FIELD_CONTROL(sFIELD => 'Phone', sSTR_VAL => recs.PHONE );
      end if;
      -- 
      sTMP := STRCOMBINE(recs.PERS_DOC_SER, recs.PERS_DOC_NUMB, ' ');
      if trim(sTMP) is null then
        sERR := sERR||' "/ "    '||CR;
      elsif nRESIDENT_SIGN = 1 then
        if regexp_replace(sTMP,'([[:digit:]]{2}) ([[:digit:]]{2}) ([[:digit:]]{6})','') is not null then
          sERR := sERR||' "/ "     "99 99 999999" ('||sTMP||')'||CR;
        else
          WRITE_FIELD_CONTROL(sFIELD => 'Pasnom', sSTR_VAL => sTMP );
        end if;
      elsif nRESIDENT_SIGN = 0 then
        if regexp_replace(sTMP,'([[:alpha:][:digit:]]*) ([[:alpha:][:digit:]]*)','') is not null then
          sERR := sERR||' "/ "       ('||sTMP||')         '||CR;
        else
          WRITE_FIELD_CONTROL(sFIELD => 'Pasnom', sSTR_VAL => sTMP );
        end if;
      else  --   
        WRITE_FIELD_CONTROL(sFIELD => 'Pasnom', sSTR_VAL => sTMP );
      end if;
      if recs.PERS_DOC_DATE is null then
        sERR := sERR||'      '||CR;
      else
        WRITE_FIELD_CONTROL(sFIELD => 'Pasdat', dDATE_VAL => recs.PERS_DOC_DATE );
      end if;
      if trim(recs.PERS_DOC_WHO) is null then
        sERR := sERR||' <  >    '||CR;
      else
        WRITE_FIELD_CONTROL(sFIELD => 'Pasplace', sSTR_VAL => trim(recs.PERS_DOC_WHO) );
      end if;
      if recs.RESIDENT_SIGN = 1 then
       if trim(recs.PERS_DOC_DEPART) is null then
          sWARN := sWARN||'           < > ()      '||CR;
          recs.PERS_DOC_DEPART := '';
        elsif regexp_replace(recs.PERS_DOC_DEPART, '([[:digit:]]{3})-([[:digit:]]{3})') is not null then
          sWARN := sWARN||' " " ()        "000-000" ('||recs.PERS_DOC_DEPART||')'||CR;
          recs.PERS_DOC_DEPART := '';
       end if;
          WRITE_FIELD_CONTROL(sFIELD => 'Pasplace', sSTR_VAL => rCURRENT_PERS.Pasplace||' '||recs.PERS_DOC_DEPART );
      end if;
      --   
      if recs.RESIDENT_SIGN = 0 then
        sTMP := null;
        for reca in
        (
          select DOCSER,
                 DOCNUMB,
                 DATEBEG,
                 DATEEND
            from AGNMIGRAT
           where PRN = recs.PERS_AGENT
             and DATEBEG <= trunc(sysdate)--rec.DOC_DATE
             and (DATEEND is null or DATEEND >= trunc(sysdate)/*rec.DOC_DATE*/)
        )
        loop
          sTMP := trim(trim(reca.DOCSER)||' '||trim(reca.DOCNUMB)||'  '||to_char(reca.DATEBEG,'DD.MM.YYYY'))||'  '||to_char(reca.DATEEND,'DD.MM.YYYY');
          exit;
        end loop;
        if sTMP is null then
          sWARN := sWARN||' <  >  .      .'||CR;
          WRITE_FIELD_CONTROL(sFIELD => 'Mkart', sSTR_VAL => '-' );
        elsif length(sTMP) > 100 then
          sERR := sERR||' "  "     100  ('||sTMP||')'||CR;
--        elsif regexp_replace(substr(sTMP,'([[:alpha:]]+) ([[:digit:]]+)(  )([[:digit:]]{2})\.([[:digit:]]{2})\.([[:digit:]]{4})(  )([[:digit:]]{2})\.([[:digit:]]{2})\.([[:digit:]]{4})','') is not null then
--        elsif regexp_replace(substr(sTMP,1,instr(sTMP,'  ')-1),'([[:digit:][:alpha:][:space:]]+) ([[:digit:]]+)(  )([[:digit:]]{2})\.([[:digit:]]{2})\.([[:digit:]]{4})','') is not null then
        elsif regexp_replace(trim(sTMP),'([[:digit:][:alpha:][:space:]]+) ([[:digit:]]+)(  )([[:digit:]]{2})\.([[:digit:]]{2})\.([[:digit:]]{4})(  )([[:digit:]]{2})\.([[:digit:]]{2})\.([[:digit:]]{4})','') is not null then
          sERR := sERR||' "  "      ('||sTMP||')'||CR;
        else
          WRITE_FIELD_CONTROL(sFIELD => 'Mkart', sSTR_VAL => sTMP );
        end if;
        if recs.RF_DOC_NAME is null then
          --    "    " 
--          sERR := sERR||' "    "    '||CR;
          sWARN := sWARN||'  "    "  .      .'||CR;
        end if;
        --     
        sTMP := recs.RF_DOC_NAME||'@';
        if recs.RF_DOC_SER is not null or recs.RF_DOC_NUMB is not null then
          sTMP := sTMP||trim(recs.RF_DOC_SER||' '||recs.RF_DOC_NUMB)||'@';
        end if;
--        if recs.RF_DOC_BEGINDATE is not null then
        sTMP := sTMP||trim(to_char(recs.RF_DOC_BEGINDATE,'DD.MM.YYYY'))||'-';
--        end if;
        if recs.RF_DOC_ENDDATE is not null then
          sTMP := sTMP||to_char(recs.RF_DOC_ENDDATE,'DD.MM.YYYY');
        end if;
        if regexp_replace(trim(strtok(sTMP,'@',2)), '([[:digit:][:alpha:][:space:]]+) ([[:digit:]]+)','') is not null then
--          sERR := sERR||' <     >    '||CR;
          sWARN := sWARN||': <       >     ('||replace(sTMP, '@', ' ')||')'||CR;
        end if;
        sTMP  := replace(sTMP, '@', ' ');
        if length(sTMP) > 100 then
          sERR := sERR||' "     "     100  ('||sTMP||')'||CR;
        else
          if recs.RF_DOC_BEGINDATE is null then
            sWARN := sWARN||':  <        >  '||CR;
          end if;
          if recs.RF_DOC_ENDDATE is null then
            sWARN := sWARN||':  <        >  '||CR;
          end if;
          WRITE_FIELD_CONTROL(sFIELD => 'Permis', sSTR_VAL => sTMP );
        end if;
      end if;

      if sERR is not null then
        sERR := ': '||trim(recs.AGNABBR)||'.  : '||STRCOMBINE(trim(recs.TAB_PREF),trim(recs.TAB_NUMB),'-')||CR||sWARN||sERR;
        nCOUNT_ERR    := nCOUNT_ERR + 1;
        dbms_lob.writeappend(cLOG, length(sERR||CR), sERR||CR);
        sERR := '';
      else
        if sWARN is not null then
          sWARN := ': '||trim(recs.AGNABBR)||'.  : '||STRCOMBINE(trim(recs.TAB_PREF),trim(recs.TAB_NUMB),'-')||CR||sWARN;
          dbms_lob.writeappend(cLOG, length(sWARN||CR), sWARN||CR);
          sWARN := '';
        end if;
        nCOUNT_PERS   := nCOUNT_PERS + 1;
--        p_exception(0,'Family - '||rCURRENT_PERS.Fname);

        insert into BANK_SPB_PNFF_DBF
          values rCURRENT_PERS;
      end if;
    end loop; -- recs
    --     
    if nCOUNT_PERS > 0 or nCOUNT_ERR > 0 then
      CREATE_DBF_FILE
      (
        nSIGN_RES     => nRESIDENT_SIGN
       ,sFILE_NAME    => sFILENAME_SAVE
       ,nDOC          => nRN
       ,nIS_UNLOAD    => 1
      );
    end if;
    dbms_lob.trim(bBLOB,0);
    dbms_lob.trim(cLOG,0);
    --      
    --  (   )
    --    
    select n.sign_error
      into nCOUNT_ERR
      from UDOT_SLREGOPACC n
     where n.rn = nRN;

    if nCOUNT_ERR = 0 then
      sFILENAME  := '';
      for rc in (
      select b.rn, b.filename
        from file_buffer  b
       where b.ident = nPROCESS
       order by b.filename
      ) loop
--        p_exception(0, 'Hello '||rc.filename);
        if regexp_substr(lower(rc.filename),'(\.dbf)$') = '.dbf' then
          sFILENAME  := regexp_substr(rc.filename,'([[:digit:]\_]+)');
          --     
          for i in 1 .. aTableFiles.count
          loop
            if rc.filename = aTableFiles(i).sFilename then
              sFILENAME_SAVE  := UDOT_GET_FILENAME_BANKSPB(nCOMPANY, aTableFiles(i).sType, trunc(sysdate), sFILENAME);
              exit;
            end if;
          end loop;
        end if;
        --       
        for i in 1 .. aTableFiles.count
        loop
          if rc.filename = aTableFiles(i).sFilename then
            update file_buffer  b
               set b.filename = case when aTableFiles(i).sType is null then replace(sFILENAME_SAVE,'.dbf','.log') else sFILENAME_SAVE end
              where b.rn = rc.rn;
            if nvl(aTableFiles(i).sType,'_') = 'N' then
              update UDOT_SLREGOPACC u
                 set u.filename_nor  = sFILENAME_SAVE
               where u.rn = nRN;
            elsif nvl(aTableFiles(i).sType,'_') = 'P' then
              update UDOT_SLREGOPACC u
                 set u.filename_res  = sFILENAME_SAVE
               where u.rn = nRN;
            end if;
            exit;
          end if;
        end loop;
      end loop;
      --  
      update UDOT_SLREGOPACC u
         set u.is_unload = 1
       where u.rn = nRN;
    else
      --       
      delete from file_buffer b
       where b.ident = nPROCESS
         and regexp_substr(lower(b.filename), '(\.dbf)$') = '.dbf';
    end if;
  elsif nIS_UNLOAD = 1 then
    p_exception(0, '     dbf .      "  ".');
  end if;
  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersOpenAccounts','UDOT_SLREGOPACC_MAKE_DBF','UDOT_SLREGOPACC',nRN );

end P_UDOT_SLREGOPACC_MAKE_DBF;
/

grant execute on P_UDOT_SLREGOPACC_MAKE_DBF to public;

spool off

