
spool c:\BSPb\Parus8\Addon\logs\__create_objects_UdoSalaryRegistersTransfersPersons.log

create or replace procedure P_UDOT_SLREGTRNPR_JOINS
(
  nCOMPANY                  in number,       --   
  sAGNLIST                  in varchar2,     --  ()
  sAGNACC                   in varchar2,     --   () ( )
  nAGNLIST                  out number,      -- 
  nAGNACC                   out number       --   ()
)
as
begin
  -- 
  FIND_AGNLIST_BY_MNEMO( 0, nCOMPANY, sAGNLIST, nAGNLIST );

  --   ()
  FIND_AGNACC_CODE_EX( 0, 0, nCOMPANY, nAGNLIST, null, sAGNACC, nAGNACC );
end P_UDOT_SLREGTRNPR_JOINS;
/

grant execute on P_UDOT_SLREGTRNPR_JOINS to public;

create or replace procedure UDOT_FIND_AGNACC_FIRSTCODE
(
  nCOMPANY      in number,
  sAGENT        in varchar2,
  sSTRCODE     out varchar2
)
as
  sSTRCODE_RES AGNACC.STRCODE%TYPE;
  sAGNNAME_RES AGNLIST.AGNNAME%TYPE;
  nMINRN       PKG_STD.tREF;
  nAGENT       PKG_STD.tREF := null;
begin
  --  
  FIND_AGNLIST_BY_MNEMO( 1, nCOMPANY, sAGENT, nAGENT );
  /*     */
  sSTRCODE := null;
  if nAGENT is not null then
    select max(c.strcode)
      into sSTRCODE
      from AGNACC c
    where c.agnrn = nAGENT
      and c.access_flag = 1
      and nvl(c.open_date,trunc(sysdate)) <= trunc(sysdate)
      and nvl(c.close_date,trunc(sysdate)) >= trunc(sysdate);
  end if;
end UDOT_FIND_AGNACC_FIRSTCODE;
/

grant execute on UDOT_FIND_AGNACC_FIRSTCODE to public;

create or replace procedure       P_UDOT_SLREGTRNPR_BASE_INSERT
(
  nCOMPANY                  in number,       -- 
  nPRN                      in number,       -- 
  nAGNLIST                  in number,       -- 
  nAGNACC                   in number,       --   ()
  nTRN_SUM                  in number,       --   
  nKVDRN                    in number,       --   
  nFZ229_SUM                in number,       --  
  nRN                       out number       --  
)
as
begin
  /*    */
  nRN := gen_id;

  /*     */
  insert into UDOT_SLREGTRNPR
  (
    RN,
    PRN,
    AGNLIST,
    AGNACC,
    TRN_SUM,
    KVDRN,
    FZ229_SUM
  )
  values
  (
    nRN,
    nPRN,
    nAGNLIST,
    nAGNACC,
    nTRN_SUM,
    nKVDRN,
    nFZ229_SUM
  );
end P_UDOT_SLREGTRNPR_BASE_INSERT;
/

/* V_UDOT_SLREGTRNPR */
create or replace view V_UDOT_SLREGTRNPR (
  NRN,
  NCOMPANY,
  NCRN,
  NPRN,
  NJUR_PERS,
  NAGNLIST,
  SAGNLIST,
  SAGNFAMILYNAME,
  SAGNFIRSTNAME,
  SAGNLASTNAME,
  SSNILS,
  NAGNACC,
  SAGNACC,
  SCARDNUMB,
  NTRN_SUM
) as
select
  T.RN,                                 -- nRN
  T.COMPANY,                            -- nCOMPANY
  T.CRN,                                -- nCRN
  T.PRN,                                -- nPRN
  T.JUR_PERS,                           -- nJUR_PERS
  T.AGNLIST,                            -- nAGNLIST
  AGN.AGNABBR,                          -- sAGNLIST
  AGN.AGNFAMILYNAME,                    -- sAGNFAMILYNAME
  AGN.AGNFIRSTNAME,                     -- sAGNFIRSTNAME
  AGN.AGNLASTNAME,                      -- sAGNLASTNAME
  AGN.PENSION_NBR,                      -- sSNILS
  T.AGNACC,                             -- nAGNACC
  A.STRCODE,                            -- sAGNACC
  A.CARDNUMB,                           -- sCARDNUMB
  T.TRN_SUM                             -- nTRN_SUM
from
  UDOT_SLREGTRNPR T,
  AGNLIST         AGN,
  AGNACC          A
where T.AGNLIST = AGN.RN
  and T.AGNACC = A.RN
  and exists (select null from V_USERPRIV UP where UP.CATALOG = T.CRN)
  and exists (select null from V_USERPRIV UP where UP.JUR_PERS = T.JUR_PERS and UP.UNITCODE = 'UdotSalaryRegistersTransfers')
;

grant select on V_UDOT_SLREGTRNPR to public;

create or replace procedure       P_UDOT_SLREGTRNPR_BASE_UPDATE
(
  nRN                       in number,       --  
  nCOMPANY                  in number,       -- 
  nAGNLIST                  in number,       -- 
  nAGNACC                   in number,       --   ()
  nTRN_SUM                  in number,       --   
  nKVDRN                    in number,       --   
  nFZ229_SUM                in number        --  
)
as
begin
  /*     */
  update UDOT_SLREGTRNPR
     set AGNLIST = nAGNLIST,
         AGNACC = nAGNACC,
         TRN_SUM = nTRN_SUM,
         KVDRN = nKVDRN,
         FZ229_SUM = nFZ229_SUM
   where RN = nRN
     and COMPANY = nCOMPANY;

  if (SQL%NOTFOUND) then
    PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersTransfersPersons' );
  end if;
end P_UDOT_SLREGTRNPR_BASE_UPDATE;
/

create index I_UDOT_SLREGTRNPR_CRN_FK on UDOT_SLREGTRNPR(CRN) tablespace &INDX_B1709;

create or replace trigger T_UDOT_SLREGTRNPR_ADELETE
  after delete on UDOT_SLREGTRNPR for each row
begin
  /*       */
  P_LOG_DELETE( :old.RN,'UdotSalaryRegistersTransfersPersons' );
end T_UDOT_SLREGTRNPR_ADELETE;
/

create or replace trigger T_UDOT_SLREGTRNPR_BINSERT
  before insert on UDOT_SLREGTRNPR for each row
declare
  nLenBdata   number;
begin
  /*    master- */
  select COMPANY, CRN, JUR_PERS, nvl(dbms_lob.getlength(bdata),0)
    into :new.COMPANY, :new.CRN, :new.JUR_PERS, nLenBdata
    from UDOT_SLREGTRN
   where RN = :new.PRN;

  /*     dbf */
  if nLenBdata > 0 then
    p_exception(0, '    dbf .   .');
  end if;

  /*   */
  if ( PKG_IUD.PROLOGUE('UDOT_SLREGTRNPR', 'I') ) then
    PKG_IUD.REG_RN('RN', :new.RN);
    PKG_IUD.REG_COMPANY('COMPANY', :new.COMPANY);
    PKG_IUD.REG_CRN('CRN', :new.CRN);
    PKG_IUD.REG_PRN('PRN', :new.PRN);
    PKG_IUD.REG_JUR_PERS('JUR_PERS', :new.JUR_PERS);
    PKG_IUD.REG(1, 'AGNLIST', :new.AGNLIST, 'AGNLIST', 'AGNABBR');
    PKG_IUD.REG(2, 'AGNACC', :new.AGNACC, 'AGNACC', 'STRCODE');
    PKG_IUD.REG('TRN_SUM', :new.TRN_SUM);
    PKG_IUD.REG('KVDRN', :old.KVDRN);
    PKG_IUD.REG('FZ229_SUM', :old.FZ229_SUM);
    PKG_IUD.EPILOGUE;
  end if;
end T_UDOT_SLREGTRNPR_BINSERT;
/

create or replace procedure P_UDOT_SLREGTRNPR_BASE_DELETE
(
  nRN                       in number,       --  
  nCOMPANY                  in number        -- 
)
as
begin
  /*     */
  delete
    from UDOT_SLREGTRNPR
   where RN = nRN
     and COMPANY = nCOMPANY;

  if (SQL%NOTFOUND) then
    PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersTransfersPersons' );
  end if;
end P_UDOT_SLREGTRNPR_BASE_DELETE;
/

create or replace trigger T_UDOT_SLREGTRNPR_BDELETE
  before delete on UDOT_SLREGTRNPR for each row
declare
  nTMP         number( 17 );
  nLenBdata    number;
begin
  /*    master- */
  select nvl(dbms_lob.getlength(bdata),0)
    into nLenBdata
    from UDOT_SLREGTRN
   where RN = :old.PRN;

  /*     dbf */
  if nLenBdata > 0 then
    p_exception(0, '    dbf .   .');
  end if;

  /*     */
  P_DOCINPT_FIND_EXACT( 0, :old.COMPANY, 'UdotSalaryRegistersTransfersPersons', :old.RN, nTMP);
  /*      */
  for rec in
  (
    select /*+ INDEX(L I_DOCLINKS_OUT_DOCUMENT) */ L.IN_DOCUMENT
      from DOCLINKS L
     where L.OUT_DOCUMENT = :old.RN
       and L.OUT_UNITCODE = 'UdotSalaryRegistersTransfersPersons'
       and L.IN_UNITCODE  = 'SalaryTransfers'
  )
  loop
    P_LINKSALL_DELETE_LINK_IN(:old.COMPANY, 'SalaryTransfers', rec.IN_DOCUMENT, 'UdotSalaryRegistersTransfersPersons');
    P_LINKSALL_DELETE_LINK_IN(:old.COMPANY, 'SalaryTransfers', rec.IN_DOCUMENT, 'UdotSalaryRegistersTransfers');
  end loop;

  /*   */
  if ( PKG_IUD.PROLOGUE('UDOT_SLREGTRNPR', 'D') ) then
    PKG_IUD.REG_RN('RN', :old.RN);
    PKG_IUD.REG_COMPANY('COMPANY', :old.COMPANY);
    PKG_IUD.REG_CRN('CRN', :old.CRN);
    PKG_IUD.REG_PRN('PRN', :old.PRN);
    PKG_IUD.REG_JUR_PERS('JUR_PERS', :old.JUR_PERS);
    PKG_IUD.REG(1, 'AGNLIST', :old.AGNLIST, 'AGNLIST', 'AGNABBR');
    PKG_IUD.REG(2, 'AGNACC', :old.AGNACC, 'AGNACC', 'STRCODE');
    PKG_IUD.REG('TRN_SUM', :old.TRN_SUM);
    PKG_IUD.REG('KVDRN', :old.KVDRN);
    PKG_IUD.REG('FZ229_SUM', :old.FZ229_SUM);
    PKG_IUD.EPILOGUE;
  end if;
end T_UDOT_SLREGTRNPR_BDELETE;
/

create or replace procedure P_UDOT_SLREGTRNPR_EXISTS
(
  nRN                       in number,       --  
  nCOMPANY                  in number,       -- 
  nCRN                      out number,      -- 
  nJUR_PERS                 out number       --  
)
as
begin
  /*   */
  begin
    select CRN,JUR_PERS
      into nCRN,nJUR_PERS
      from UDOT_SLREGTRNPR
     where RN = nRN
       and COMPANY = nCOMPANY;
  exception
    when NO_DATA_FOUND then
      PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersTransfersPersons' );
  end;
end P_UDOT_SLREGTRNPR_EXISTS;
/

grant execute on P_UDOT_SLREGTRNPR_EXISTS to public;

create or replace trigger T_UDOT_SLREGTRNPR_BUPDATE
  before update on UDOT_SLREGTRNPR for each row
declare
  nTMP  PKG_STD.tNUMBER;
  nLenBdata   number;
begin
  /*     */
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGTRNPR', 'RN', :new.RN, :old.RN);
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGTRNPR', 'COMPANY', :new.COMPANY, :old.COMPANY);
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGTRNPR', 'PRN', :new.PRN, :old.PRN);
  PKG_UNCHANGE.CHECK_NE('UDOT_SLREGTRNPR', 'JUR_PERS', :new.JUR_PERS, :old.JUR_PERS);

  /*         */
  if (CMP_NUM(:old.CRN,:new.CRN) = 0 or
      CMP_NUM(:old.JUR_PERS,:new.JUR_PERS) = 0) then
    return;
  end if;
  /*    master- */
  select nvl(dbms_lob.getlength(bdata),0)
    into nLenBdata
    from UDOT_SLREGTRN
   where RN = :new.PRN;

  /*     dbf */
  if nLenBdata > 0 then
    p_exception(0, '    dbf .   .');
  end if;

  /*       */
  P_DOCINPT_FIND_EXACT( 0,:new.COMPANY,'UdotSalaryRegistersTransfers',:new.PRN,nTMP );

  /*   */
  if ( PKG_IUD.PROLOGUE('UDOT_SLREGTRNPR', 'U') ) then
    PKG_IUD.REG_RN('RN', :new.RN, :old.RN);
    PKG_IUD.REG_COMPANY('COMPANY', :new.COMPANY, :old.COMPANY);
    PKG_IUD.REG_CRN('CRN', :new.CRN, :old.CRN);
    PKG_IUD.REG_PRN('PRN', :new.PRN, :old.PRN);
    PKG_IUD.REG_JUR_PERS('JUR_PERS', :new.JUR_PERS, :old.JUR_PERS);
    PKG_IUD.REG(1, 'AGNLIST', :new.AGNLIST, :old.AGNLIST, 'AGNLIST', 'AGNABBR');
    PKG_IUD.REG(2, 'AGNACC', :new.AGNACC, :old.AGNACC, 'AGNACC', 'STRCODE');
    PKG_IUD.REG('TRN_SUM', :new.TRN_SUM, :old.TRN_SUM);
    PKG_IUD.REG('KVDRN', :old.KVDRN);
    PKG_IUD.REG('FZ229_SUM', :old.FZ229_SUM);
    PKG_IUD.EPILOGUE;
  end if;
end T_UDOT_SLREGTRNPR_BUPDATE;
/

create index I_UDOT_SLREGTRNPR_AGNACC_FK on UDOT_SLREGTRNPR(AGNACC) tablespace &INDX_B1709;

create index I_UDOT_SLREGTRNPR_JURPERS_FK on UDOT_SLREGTRNPR(JUR_PERS) tablespace &INDX_B1709;

create index I_UDOT_SLREGTRNPR_AGNLIST_FK on UDOT_SLREGTRNPR(AGNLIST) tablespace &INDX_B1709;

create or replace procedure P_UDOT_SLREGTRNPR_DELETE
(
  nRN                       in number,       --  
  nCOMPANY                  in number        -- 
)
as
  nCRN                      PKG_STD.tREF;    -- 
  nJUR_PERS                 PKG_STD.tREF;    --  
begin
  /*   */
  P_UDOT_SLREGTRNPR_EXISTS
  (
    nRN,
    nCOMPANY,
    nCRN,
    nJUR_PERS
  );

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersTransfersPersons','UDOT_SLREGTRNPR_DELETE','UDOT_SLREGTRNPR',nRN );

  /*   */
  P_UDOT_SLREGTRNPR_BASE_DELETE
  (
    nRN,
    nCOMPANY
  );

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersTransfersPersons','UDOT_SLREGTRNPR_DELETE','UDOT_SLREGTRNPR',nRN );
end;
/

grant execute on P_UDOT_SLREGTRNPR_DELETE to public;

create or replace procedure       P_UDOT_SLREGTRNPR_INSERT
(
  nCOMPANY                  in number,       -- 
  nPRN                      in number,       -- 
  sAGNLIST                  in varchar2,     --  ()
  sAGNACC                   in varchar2,     --   () ( )
  nTRN_SUM                  in number,       --   
  nKVDRN                    in number,       --   
  nFZ229_SUM                in number,       --  
  nRN                       out number       --  
)
as
  nCRN              PKG_STD.tREF;
  nJUR_PERS         PKG_STD.tREF;
  nAGNLIST          PKG_STD.tREF;    -- 
  nAGNACC           PKG_STD.tREF;    --   ()
  nIS_UNLOAD        pkg_std.tref;
begin
  /*  master  */
  P_UDOT_SLREGTRN_EXISTS(nPRN, nCOMPANY, nCRN, nJUR_PERS, nIS_UNLOAD);

  /*   */
  P_UDOT_SLREGTRNPR_JOINS
  (
    nCOMPANY,
    sAGNLIST,
    sAGNACC,
    nAGNLIST,
    nAGNACC
  );

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersTransfersPersons','UDOT_SLREGTRNPR_INSERT','UDOT_SLREGTRNPR' );

  /*   */
  P_UDOT_SLREGTRNPR_BASE_INSERT
  (
    nCOMPANY,
    nPRN,
    nAGNLIST,
    nAGNACC,
    nTRN_SUM,
    nKVDRN,
    nFZ229_SUM,
    nRN
  );

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersTransfersPersons','UDOT_SLREGTRNPR_INSERT','UDOT_SLREGTRNPR',nRN );
end P_UDOT_SLREGTRNPR_INSERT;
/

grant execute on P_UDOT_SLREGTRNPR_INSERT to public;

create or replace procedure             P_UDOT_SLREGTRNPR_UPDATE
(
  nRN                       in number,       --  
  nCOMPANY                  in number,       -- 
  sAGNLIST                  in varchar2,     --  ()
  sAGNACC                   in varchar2,     --   () ( )
  nTRN_SUM                  in number,       --   
  nKVDRN                    in number,       --   
  nFZ229_SUM                in number        --  
)
as
  nCRN                      PKG_STD.tREF;    -- 
  nJUR_PERS                 PKG_STD.tREF;    --  
  nAGNLIST                  PKG_STD.tREF;    -- 
  nAGNACC                   PKG_STD.tREF;    --   ()
begin
  /*   */
  P_UDOT_SLREGTRNPR_EXISTS
  (
    nRN,
    nCOMPANY,
    nCRN,
    nJUR_PERS
  );

  /*     */
  PKG_ENV.PROLOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersTransfersPersons','UDOT_SLREGTRNPR_UPDATE','UDOT_SLREGTRNPR',nRN );

  /*   */
  P_UDOT_SLREGTRNPR_JOINS
  (
    nCOMPANY,
    sAGNLIST,
    sAGNACC,
    nAGNLIST,
    nAGNACC
  );

  /*   */
  P_UDOT_SLREGTRNPR_BASE_UPDATE
  (
    nRN,
    nCOMPANY,
    nAGNLIST,
    nAGNACC,
    nTRN_SUM,
    nKVDRN,
    nFZ229_SUM
  );

  /*     */
  PKG_ENV.EPILOGUE( nCOMPANY,null,nCRN,nJUR_PERS,null,'UdotSalaryRegistersTransfersPersons','UDOT_SLREGTRNPR_UPDATE','UDOT_SLREGTRNPR',nRN );
end;
/

grant execute on P_UDOT_SLREGTRNPR_UPDATE to public;

create or replace package body                         PKG_UDOT_SLREGTRN
as
  --    ()
  procedure BASE_FORM
  (
    nCOMPANY                  in number,
    nRN                       in number,       -- 
    nIDENT                    in number,       -- 
    dFORM_DATE                in date,         --  
    nAGENT                    in number,       --  
    nAGNJURDOCS               in number,       -- 
    sAGNBANKS                 in varchar2,     --  
    sREGCRN                   in varchar2,     --   
    sDOCTYPES                 in varchar2,     --  
    sDOC_PREF                 in varchar2,     --   
    dDOC_DATE                 in date,         --  
    nGRPTRTYPE                in number,       --    
    nGRPBANKPRG               in number,       --     
    nRESULT                  out number
  )
  as
    nVERSION_AGENT            PKG_STD.tREF;
    nCRN                      PKG_STD.tREF;
    nTMP                      PKG_STD.tREF;
    nJURPERSONS               PKG_STD.tREF;
    nDOC_TYPE                 PKG_STD.tREF;
    nAGNBANKS                 PKG_STD.tREF;
    nAGNACC                   PKG_STD.tREF;
    nSLTRTYPE                 PKG_STD.tREF;
    nBANKPRG                  PKG_STD.tREF;
    nBANKATTRS                PKG_STD.tREF;
    nUDOT_SLREGTRN            PKG_STD.tREF := nRN;
    nUDOT_SLREGTRNPR          PKG_STD.tREF;
    sDOC_NUMB                 UDOT_SLREGTRN.DOC_NUMB%type;
    sSEQSYMB                  varchar2(255) := GET_OPTIONS_STR('SeqSymb', nCOMPANY);
    sTMP                      OPTIONS.STR_VALUE%type;
  begin
    nRESULT := -1;
    if nRN is null then
      -- 
      if sREGCRN is null then
        FIND_ROOT_CATALOG( nCOMPANY, 'UdotSalaryRegistersTransfers', nCRN );
      else
        FIND_ACATALOG_NAME(0, nCOMPANY, null, 'UdotSalaryRegistersTransfers', sREGCRN, nCRN);
      end if;
      --  
      FIND_DOCTYPES_CODE_EX( 0,0,nCOMPANY,sDOCTYPES,nDOC_TYPE );
      --  /  
--      FIND_AGNACC_CODE_EX( 0, 1, nCOMPANY, nAGENT, null, sAGNACC, nAGNACC );
    end if;

    delete from IDLIST;

    --  .    
--    sTMP := GET_OPTIONS_STR(/*'Udot*/'SalaryRegistersTransfers_BankProrams',nCOMPANY);
--    for i in 1..STRCNT(sTMP,sSEQSYMB) loop
--      FIND_BANKPRG_CODE(0,1,nCOMPANY,STRTOK(sTMP,sSEQSYMB,i),nTMP);
--      if nTMP is not null then
--        insert into IDLIST (ID) values (nTMP);
--      end if;
--    end loop;

    --     
    find_version_by_company( nCOMPANY, 'AGNLIST', nVERSION_AGENT);
    find_agnbanks_vers_agent(0, nVERSION_AGENT, sAGNBANKS, nAGNBANKS );

    /*    :  */
    PKG_INHIER.CONSTRUCTOR_EXT( nCOMPANY,nIDENT );
    /*        */
    PKG_INHIER.PREP_LINK( nIDENT );
    /*     ()  */
    PKG_INHIER.SET_IN_UNIT( nIDENT,0,'SalaryTransfers' );
    /*      */
    PKG_INHIER.SET_OUT_UNIT( nIDENT,0,'UdotSalaryRegistersTransfers' );
    PKG_INHIER.SET_OUT_UNIT( nIDENT,1,'UdotSalaryRegistersTransfersPersons' );

    -- 
    for rec in
    (
      select T.JURPERSONS,
             A.AGNBANKS,
             decode(nGRPTRTYPE,0,null,T.SLTRTYPE) SLTRTYPE,
             decode(nGRPBANKPRG,0,null,A.BANKPRG) BANKPRG,
             T.BANKATTRS,
             T.RECIPIENT,
             T.RN,
             T.CRN,
             T.TRANSFSUMM,
             T.INCTRANSFTYP,
             T.COLSUMM,
             R.AGNABBR
        from SELECTLIST  S,
             SLTRANSFERS T,
             AGNACC      A,
             AGNLIST     R
       where S.DOCUMENT   = T.RN
         and T.BANKATTRS  = A.RN
         and T.RECIPIENT  = R.RN
         and S.IDENT      = nIDENT
         and A.Agnbanks   = nAGNBANKS
         and (sTMP is null or A.BANKPRG in (select ID from IDLIST))
         and (nRN is not null or
                F_DOCLINKS_LINK_OUT_DOC('SalaryTransfers',T.RN,'UdotSalaryRegistersTransfers') is null
--              (F_DOCLINKS_LINK_OUT_DOC('SalaryTransfers',T.RN,'UdotSalaryRegistersTransfers') is null and
--               F_DOCLINKS_LINK_OUT_DOC('SalaryTransfers',T.RN,'BankDocuments') is null and
--               F_DOCLINKS_LINK_OUT_DOC('SalaryTransfers',T.RN,'EconomicOperations') is null
--              )
             )
       order by 1, 2, 3, 4, 5
    )
    loop
      if rec.AGNBANKS is null then
        P_EXCEPTION(0,'     ,      !   '||trim(rec.AGNABBR)||'.');
      end if;
      /*     */
--      PKG_ENV.PROLOGUE( nCOMPANY,null,rec.CRN,'SalaryTransfers','UDOT_SLTRANSFERS_REG_CREATE','SLTRANSFERS',rec.RN );

      --      ,   ,   
      if nRN is null and
        (CMP_NUM(rec.JURPERSONS,nJURPERSONS) = 0 or
         CMP_NUM(rec.AGNBANKS,nAGNBANKS) = 0 or
         (nGRPTRTYPE = 1 and CMP_NUM(rec.SLTRTYPE,nSLTRTYPE) = 0) or
         (nGRPBANKPRG = 1 and CMP_NUM(rec.BANKPRG,nBANKPRG) = 0) ) then
        --  
        nJURPERSONS := rec.JURPERSONS;
        nAGNBANKS   := rec.AGNBANKS;
        nSLTRTYPE   := rec.SLTRTYPE;
        nBANKPRG    := rec.BANKPRG;
        nBANKATTRS  := null;
        --  
        P_UDOT_SLREGTRN_BASE_GETNEXTN(nCOMPANY, nJURPERSONS, dDOC_DATE, nDOC_TYPE, sDOC_PREF, sDOC_NUMB);
        P_UDOT_SLREGTRN_BASE_INSERT
        (
          nCOMPANY,
          nCRN,
          nJURPERSONS,
          nDOC_TYPE,
          sDOC_PREF,
          sDOC_NUMB,
          dDOC_DATE,
          nAGNBANKS,
          nAGNJURDOCS,
          nBANKPRG,
          nAGNACC,
          nSLTRTYPE,
          nvl(dFORM_DATE,P_TOOLS_NOW),
          nUDOT_SLREGTRN
        );
      end if;

      /*  ,    */
      PKG_INHIER.SET_IN_DOC( nIDENT,0,rec.RN );
      /*       */
      PKG_INHIER.SET_OUT_DOC( nIDENT,0,nUDOT_SLREGTRN );

      --   
      if CMP_NUM(rec.BANKATTRS,nBANKATTRS) = 0 then
        --  
        nBANKATTRS := rec.BANKATTRS;
        --    
        P_UDOT_SLREGTRNPR_BASE_INSERT
        (
          nCOMPANY,
          nUDOT_SLREGTRN,
          rec.RECIPIENT,
          nBANKATTRS,
          rec.TRANSFSUMM,
          rec.INCTRANSFTYP,
          rec.COLSUMM,
          nUDOT_SLREGTRNPR
        );
      else
        update UDOT_SLREGTRNPR
           set TRN_SUM = TRN_SUM + rec.TRANSFSUMM,
               FZ229_SUM = FZ229_SUM + rec.COLSUMM
         where RN = nUDOT_SLREGTRNPR;
      end if;
      /*       */
      PKG_INHIER.SET_OUT_DOC( nIDENT,1,nUDOT_SLREGTRNPR );
      /*      */
      PKG_INHIER.LINK_IN( nIDENT);

      /*     */
--      PKG_ENV.EPILOGUE( nCOMPANY,null,rec.CRN,'SalaryTransfers','UDOT_SLTRANSFERS_REG_CREATE','SLTRANSFERS',rec.RN );
      nRESULT := 1;
    end loop;

    if nRN is not null then
      update UDOT_SLREGTRN
         set FORM_DATE = nvl(dFORM_DATE,P_TOOLS_NOW)
       where RN = nRN;
      if (SQL%NOTFOUND) then
        PKG_MSG.RECORD_NOT_FOUND( nRN,'UdotSalaryRegistersTransfers' );
      end if;
    end if;

    /*            */
    PKG_INHIER.LINK_PROLOGUE( nIDENT );
    /*        */
    PKG_INHIER.LINK_DOCS( nIDENT );
    /*    */
    PKG_INHIER.INHR_PROPS( nIDENT );
    /*          */
    PKG_INHIER.LINK_EPILOGUE( nIDENT );
    /*    */
    PKG_INHIER.DESTRUCTOR( nIDENT );
  end BASE_FORM;
/*
  --   
  procedure BASE_FILL_BUFF
  (
    nCOMPANY      in number,      -- 
    nIDENT        in number,      --  
    dDOC_DATE     in date,        --   
    nDATE_SIGN    in number,      --  -   -
    sMODEL_DOC    in varchar2,    --   
    nCRN_DOC      in varchar2,    -- ,   
    nRESULT      out number
  )
  as
    nRN              PKG_STD.tREF;
    nPRN             PKG_STD.tREF;
    nRNDOC           PKG_STD.tREF;                             --   
    r_MDLBDOCS       MDLBDOCS%ROWTYPE;                         --  
    nMODEL_DOC       PKG_STD.tREF;                             --  
    sBANK_DOCTYPE    DOCTYPES.DOCCODE%TYPE;                    --    
    nBCURRENCY       PKG_STD.tREF;                             --  
    nINSCURRENCY     PKG_STD.tREF;                             -- 
    nVALID_DOCTYPE   PKG_STD.tREF;                             --   
    sVALID_DOCNUMB   BANKDOCSBUFF_COMMON.VALID_DOCNUMB%TYPE;   --   
    dVALID_DOCDATE   BANKDOCSBUFF_COMMON.VALID_DOCDATE%TYPE;   --   
    nAGENT_FROM      BANKDOCSBUFF_COMMON.AGENT_FROM%TYPE;      -- 
    nAGENT_FROM_ACC  BANKDOCSBUFF_COMMON.AGENT_FROM_ACC%TYPE;  --  
    nAGENT_TO        BANKDOCSBUFF_COMMON.AGENT_TO%TYPE;        -- 
    nAGENT_TO_ACC    BANKDOCSBUFF_COMMON.AGENT_TO_ACC%TYPE;    --  
    nJUR_PERS        BANKDOCSBUFF_COMMON.JUR_PERS%TYPE;        -- 
    sJURPERSONS      JURPERSONS.CODE%TYPE;
    nTYPOPER_DIRECT  DICTOPER.TYPOPER_DIRECT%TYPE;             --     0 - , 1-
    sNUMBER          BANKDOCSBUFF_COMMON.BANK_DOCNUMB%TYPE;
    dDOCDATE         BANKDOCSBUFF_COMMON.BANK_DOCDATE%TYPE;
    nTRANSFSUMM      SLTRANSFERS.TRANSFSUMM%TYPE;              --  
    nFEESUMM         SLTRANSFERS.FEESUMM%TYPE;                 --    
    nFLAGADD         number(1);
    nBASEJUR_PERS    BANKDOCSBUFF_COMMON.JUR_PERS%TYPE;        --   (RN)
    sBASEJUR_PERS    JURPERSONS.CODE%TYPE;                     --   ()
    sBANKNAME        AGNLIST.AGNNAME%TYPE;                     --  
    nBANK_DOCTYPE    PKG_STD.tREF;                             --   
    sBANK_DOCPREF    BANKDOCSBUFF_COMMON.BANK_DOCPREF%TYPE;    --    
    nPERCENT_TAX_SUM BANKDOCSBUFF_COMMON.PERCENT_TAX_SUM%TYPE; --  
    sPAY_TYPE        BANKDOCSBUFF_COMMON.PAY_TYPE%TYPE;
    sPAY_KIND        BANKDOCSBUFF_COMMON.PAY_KIND%TYPE;
    nBALUNIT         PKG_STD.tREF;                             -- 
    nGOVCNTRID       PKG_STD.tREF;
    sSQL             PKG_STD.tSQL;

    procedure GET_FIRST_ACC
    (
      nAGENT     in number,
      nAGENT_ACC out number
    )
    as
    begin
      select A.RN into nAGENT_ACC
        from AGNACC A
       where A.AGNRN = nAGENT
         and A.STRCODE in(select min(B.STRCODE) from AGNACC B where B.AGNRN = nAGENT);
    exception
      when NO_DATA_FOUND then
        nAGENT_ACC := null;
    end GET_FIRST_ACC;

    procedure GET_AGENT_FROM
    (
      nBDOCSAGNFROM     in number,
      nTRANSAGNFROM     in number,
      nBDOCSAGNFROMACC  in number,
      nAGENT_FROM       out number,
      nAGENT_FROM_ACC   out number
    )
    as
    begin
      nAGENT_FROM := nvl(nBDOCSAGNFROM,nTRANSAGNFROM);
      if nBDOCSAGNFROMACC is null then
        GET_FIRST_ACC(nAGENT_FROM,nAGENT_FROM_ACC);
      else
        nAGENT_FROM_ACC := nBDOCSAGNFROMACC;
      end if;
    end GET_AGENT_FROM;

    \*    *\
    function GET_SUMNDS
    (
      nPAYSUMM   in number,
      nNDS       in number
    )
    return number
    as
    begin
      if nNDS<>0 then
        return round(nPAYSUMM* nNDS/(100+nNDS),2);
      else
        return 0;
      end if;
    end GET_SUMNDS;

    procedure BANKDOCSBUFF_SUMMUPDATE
    as
      nPAY_SUMM_ALL        BANKDOCSBUFF_COMMON.PAY_SUM%TYPE;
      nRESULT              number(1);
    begin
      for cDOC in
      (
        select RN,
               BANK_DOCDATE,
               PAY_SUM
          from BANKDOCSBUFF_COMMON
         where IDENT = nIDENT
      )
      loop
        P_CURHIST_CALCSUM(nCOMPANY,cDOC.BANK_DOCDATE,r_MDLBDOCS.CURRENCY,cDOC.PAY_SUM,nPAY_SUMM_ALL,nRESULT);

        \*         *\
        P_BANKDOCSBUFF_BASE_UPDATE_SUM( cDOC.RN,null,nPAY_SUMM_ALL,0 );
      end loop;
    end BANKDOCSBUFF_SUMMUPDATE;

    procedure BANKDOCSBUFF_NDSSUMMUPDATE
    as
      nSUMNDS         BANKDOCSBUFF_COMMON.TAX_SUM %TYPE;
    begin
      for cDOC in
      (
        select RN,
               PAY_SUM,
               PERCENT_TAX_SUM
          from BANKDOCSBUFF_COMMON
         where IDENT = nIDENT
      )
      loop
        nSUMNDS := GET_SUMNDS(cDOC.PAY_SUM, cDOC.PERCENT_TAX_SUM);
        \*         *\
        P_BANKDOCSBUFF_BASE_UPDATE_SUM( cDOC.RN,null,null,null,nSUMNDS,0 );
      end loop;
    end BANKDOCSBUFF_NDSSUMMUPDATE;

  begin
    sPAY_TYPE := GET_OPTIONS_STR( 'Pay_Type',nCOMPANY );
    sPAY_KIND := GET_OPTIONS_STR( 'Pay_Kind',nCOMPANY );
    \*   *\
    FIND_CURRENCY_BASE( nCOMPANY,nBCURRENCY );
    \*  *\
    FIND_MDLBDOCS_BY_NAME(0,0,nCOMPANY,sMODEL_DOC,nMODEL_DOC);
    select *
      into r_MDLBDOCS
      from MDLBDOCS A
     where A.RN = nMODEL_DOC;
    if r_MDLBDOCS.TYPE_OPER is null then
       P_EXCEPTION( 0,'    .' );
    end if;
    if r_MDLBDOCS.CURRENCY <> nBCURRENCY then
      nINSCURRENCY := r_MDLBDOCS.CURRENCY;
    else
      nINSCURRENCY := nBCURRENCY;
    end if;
    \*    *\
    if r_MDLBDOCS.BANK_DOCTYPE is null then
      sBANK_DOCTYPE := GET_OPTIONS_STR( 'BankDocType',nCOMPANY );
      FIND_DOCTYPES_CODE(nCOMPANY,sBANK_DOCTYPE,null,0,nBANK_DOCTYPE);
    else
      nBANK_DOCTYPE := r_MDLBDOCS.BANK_DOCTYPE;
    end if;
    \*   *\
    sBANK_DOCPREF := nvl(r_MDLBDOCS.BANK_DOCPREF,GET_OPTIONS_STR( 'BankPref',nCOMPANY ));
    \*   *\
    if r_MDLBDOCS.PERCENT_TAX_SUM <> 0 then
      nPERCENT_TAX_SUM := r_MDLBDOCS.PERCENT_TAX_SUM;
    else
      nPERCENT_TAX_SUM := nvl(GET_OPTIONS_NUM( 'BankDocsNDSDef',nCOMPANY ),0);
    end if;
    select TYPOPER_DIRECT
      into nTYPOPER_DIRECT
      from DICTOPER
     where RN = r_MDLBDOCS.TYPE_OPER;
    \*   *\
    nVALID_DOCTYPE := r_MDLBDOCS.VALID_DOCTYPE;
    sVALID_DOCNUMB := r_MDLBDOCS.VALID_DOCNUMB;
    dVALID_DOCDATE := r_MDLBDOCS.VALID_DOCDATE;

    \*   *\
    FIND_JURPERSONS_OPTION(0, nCOMPANY, sBASEJUR_PERS, nBASEJUR_PERS);
    \*    *\
    select AGENT
      into nAGENT_FROM
      from JURPERSONS
     where RN =  nBASEJUR_PERS;
    \*  *\
    GET_AGENT_FROM(r_MDLBDOCS.AGENT_FROM,nAGENT_FROM,r_MDLBDOCS.AGENT_FROM_ACC,nAGENT_FROM,nAGENT_FROM_ACC);
    \*  *\
    nAGENT_TO     := r_MDLBDOCS.AGENT_TO;
    nAGENT_TO_ACC := r_MDLBDOCS.AGENT_TO_ACC;
    \*  *\
    nBALUNIT := r_MDLBDOCS.BALUNIT;
    \*  *\
    FIND_JURPERSONS_OPERTYPE_BASE(1,nCOMPANY,nTYPOPER_DIRECT,nAGENT_FROM,nAGENT_TO,sJURPERSONS,nJUR_PERS);
    dDOCDATE := dDOC_DATE;
    nTRANSFSUMM := 0;
    nFEESUMM    := 0;
    nFLAGADD    := 0;

    for cREC in
    (
      select B.RN,
             B.CRN,
             B.TRANSFSUMM,
             B.FEESUMM,
             P.PRN
        from UDOT_SLREGTRNPR  P,
             SLTRANSFERS B,
             DOCLINKS    L
       where L.IN_DOCUMENT  = B.RN
         and L.OUT_DOCUMENT = P.RN
         and P.PRN in ( select R.RN
                          from SELECTLIST L,
                               UDOT_SLREGTRN   R
                         where L.DOCUMENT = R.RN
                           and L.IDENT    = nIDENT )
         and L.IN_UNITCODE  = 'SalaryTransfers'
         and L.OUT_UNITCODE = 'UdotSalaryRegistersTransfersPersons'
         and F_DOCLINKS_LINK_OUT_DOC('SalaryTransfers',B.RN,'BankDocuments') is null
       order by P.PRN
    )
    loop
      \*    ()   0 *\
      PKG_INHIER.SET_IN_DOC( nIDENT,0,cREC.RN,cREC.CRN );
      begin
        select RN
          into nRN
          from BANKDOCSBUFF_COMMON
          where IDENT = nIDENT
            and cREC.PRN = nPRN;

        \*         *\
        PKG_INHIER.SET_BUFF_DOC( nIDENT,0,nRN );

        \*         *\
        P_BANKDOCSBUFF_BASE_UPDATE_SUM(nRN, null, cREC.TRANSFSUMM + cREC.FEESUMM, 1);

        \*    ,  - *\
        if PROCEDURE_EXISTS('P_SLTRANSFERSSP_FILL_BUFF') = 1 then
          sSQL := 'begin  P_SLTRANSFERSSP_FILL_BUFF(:nCOMPANY, :nIDENT, :nTRANS_RN, :nBANK_RN); end;';
          execute immediate sSQL using nCOMPANY, nIDENT, cREC.RN, nRN;
        end if;
      exception
        when NO_DATA_FOUND then
          nPRN := cREC.PRN;
          \*    *\
          P_BANKDOCSBUFF_BASE_NEXTNUMB( nCOMPANY, nIDENT, nJUR_PERS, dDOCDATE, nBANK_DOCTYPE, sBANK_DOCPREF, sNUMBER );

          if dDOCDATE is null then
            P_EXCEPTION(0,'    .');
          end if;

          \*   *\
          nGOVCNTRID := null;
          if r_MDLBDOCS.TYPE_OPER is not null then
            for recs in
            (
              select TYPOPER_DIRECT
                from DICTOPER
               where RN = r_MDLBDOCS.TYPE_OPER
            )
            loop
              if recs.TYPOPER_DIRECT = 0 then -- 
                nGOVCNTRID := GET_GOVCNTRID_AGNACC( nCOMPANY, nAGENT_TO_ACC );
              else
                nGOVCNTRID := GET_GOVCNTRID_AGNACC( nCOMPANY, nAGENT_FROM_ACC );
              end if;
            end loop;
          end if;

          \*   *\
          P_BANKDOCSBUFF_BASE_INSERT(nCOMPANY, nIDENT, 1, nCRN_DOC, null, 1,
            nBANK_DOCTYPE, sBANK_DOCPREF, sNUMBER,dDOCDATE, nVALID_DOCTYPE,
            sVALID_DOCNUMB, dVALID_DOCDATE, nAGENT_FROM, nAGENT_FROM_ACC,
            nAGENT_TO, nAGENT_TO_ACC, nBALUNIT, r_MDLBDOCS.TYPE_OPER,
            r_MDLBDOCS.PAY_SEQ, null, r_MDLBDOCS.PAY_INFO, r_MDLBDOCS.PAY_NOTE,
            r_MDLBDOCS.BANK_OPER, cREC.TRANSFSUMM + cREC.FEESUMM, 0, nPERCENT_TAX_SUM,
            nINSCURRENCY, sPAY_TYPE, sPAY_KIND, nJUR_PERS, r_MDLBDOCS.INCOMECLASS,
            r_MDLBDOCS.TRANSREASON, r_MDLBDOCS.TRANSPERIOD, r_MDLBDOCS.TRANSNUMBER,
            r_MDLBDOCS.TRANSDATE, r_MDLBDOCS.TRANSTYPE, r_MDLBDOCS.TAXPSTATUS,
            r_MDLBDOCS.SPECIAL_MARK, null, null, 0, r_MDLBDOCS.OKATO,
            r_MDLBDOCS.REASON_CODE, null, null, r_MDLBDOCS.UIN, nGOVCNTRID, null, nRNDOC );

          \*         *\
          PKG_INHIER.SET_BUFF_DOC( nIDENT,0,nRNDOC );

          \*    ,  - *\
          if PROCEDURE_EXISTS('P_SLTRANSFERSSP_FILL_BUFF') = 1 then
            sSQL := 'begin  P_SLTRANSFERSSP_FILL_BUFF(:nCOMPANY, :nIDENT, :nTRANS_RN, :nBANK_RN); end;';
            execute immediate sSQL using nCOMPANY, nIDENT, cREC.RN, nRNDOC;
          end if;
      end;

      \*         *\
      PKG_INHIER.LINK_IN( nIDENT );

      nRESULT :=1;
    end loop;
    \*   *\
    if r_MDLBDOCS.CURRENCY <> nBCURRENCY then
      BANKDOCSBUFF_SUMMUPDATE;
    end if;
    \*   *\
    BANKDOCSBUFF_NDSSUMMUPDATE;
  end BASE_FILL_BUFF;
*/
  --       (   P_BANKDOCSBUFF_BASE_REPLACE)
  procedure BDOC_APPLY
  (
    nCOMPANY                  in number,       -- 
    nUDOT_SLREGTRNPR          in number,       --     
    nBANKDOCS                 in number        --    
  )
  as
    /*   */
    procedure LINK_DIRECT
    (
      sIN_UNITCODE       in varchar2,
      nIN_DOCUMENT       in number,
      nIN_PRN_DOCUMENT   in number,
      sOUT_UNITCODE      in varchar2,
      nOUT_DOCUMENT      in number,
      nOUT_PRN_DOCUMENT  in number default null
    )
    as
    begin
      P_LINKSALL_LINK_DIRECT_SMART
      (
        nCOMPANY,           -- nCOMPANY
        sIN_UNITCODE,       -- sIN_UNITCODE
        nIN_DOCUMENT,       -- nIN_DOCUMENT
        nIN_PRN_DOCUMENT,   -- nIN_PRN_DOCUMENT
        sysdate,            -- dIN_IN_DATE
        0,                  -- nIN_STATUS
        sOUT_UNITCODE,      -- sOUT_UNITCODE
        nOUT_DOCUMENT,      -- nOUT_DOCUMENT
        nOUT_PRN_DOCUMENT,  -- nOUT_PRN_DOCUMENT
        sysdate,            -- dOUT_IN_DATE
        0                   -- nOUT_STATUS
      );
    end LINK_DIRECT;

  begin
    for rec in
    (
      select T.RN,
             T.CRN,
             T.JUR_PERS
        from UDOT_SLREGTRN   T,
             UDOT_SLREGTRNPR P
       where T.RN = P.PRN
         and P.RN = nUDOT_SLREGTRNPR
    )
    loop
      PKG_ENV.ACCESS( nCOMPANY,null,rec.CRN,rec.JUR_PERS,'UdotSalaryRegistersTransfers','UDOT_SLREGTRN_MAKE_DOC' );
      LINK_DIRECT( 'UdotSalaryRegistersTransfers', rec.RN, null, 'BankDocuments', nBANKDOCS );
      LINK_DIRECT( 'UdotSalaryRegistersTransfersPersons', nUDOT_SLREGTRNPR, rec.RN, 'BankDocuments', nBANKDOCS );
    end loop;
  end BDOC_APPLY;

end PKG_UDOT_SLREGTRN;
/

spool off

