
set echo on

spool c:\BSPb\Parus8\Addon\logs\__import_NB.log


--  
create or replace function UDOT_GET_ACATALOG_DICT_DESCR
(
  sIN_PARAM    in varchar2   --      (in_RN  in_NAME)
 ,sOUT_PARAM   in varchar2   --      (out_RN  out_NAME)
 ,sCONTROL     in varchar2   --          
 ,sUNITCODE    in varchar2   --         ( 'SalaryTransfers')
)
return varchar2
as
begin
  delete from UDOT_VIRTUALDICT;

  return '<DictionaryInterface UnitCode="UdotDictionary" Method="catalog">'
     || '<Params><Param Name="' || sIN_PARAM  || '"><ParamTypes><In>1</In></ParamTypes><Control>'||sCONTROL||'</Control></Param>'
     || '<Param Name="' || sOUT_PARAM || '"><ParamTypes><Out>1</Out></ParamTypes><Control>'||sCONTROL||'</Control></Param>'
     || '<Param Name="in_UNITCODE"><ParamTypes><In>1</In></ParamTypes><Constant>'||sUNITCODE||'</Constant></Param>'
     || '</Params></DictionaryInterface>';
end UDOT_GET_ACATALOG_DICT_DESCR;
/



grant EXECUTE on UDOT_GET_ACATALOG_DICT_DESCR to PUBLIC;

create or replace procedure UDOT_P_SLTRANSFERS_REG_CREATE
(
  nCOMPANY                  in number,     -- .
  nIDENT                    in number,     --     selectlist (not null)
  sJUR_PERS                 in varchar2,   --  
  sAGENT                    in varchar2,   --  
  sAGNBANS                  in varchar2,   --  
  sREGCRN                   in varchar2,   --   
  sDOCTYPES                 in varchar2,   --  
  sDOC_PREF                 in varchar2,   --   
  dDOC_DATE                 in date,       --  
  dFORM_DATE                in date,       --  
  nGRPTRTYPE                in number,     --    
  nGRPBANKPRG               in number default 0,     --     
  nRES                     out number      --   (0 -   , >= 1 -  )
)
as
  nJUR_PERS                 PKG_STD.tREF;  --  
  nAGENT                    PKG_STD.tREF;  -- 
  sSQL                      PKG_STD.tSQL;
begin
  --   
  find_agnlist_by_mnemo( 0, nCOMPANY, sAGENT, nAGENT);

  if sJUR_PERS is not null then
    FIND_JURPERSONS_CODE( 0,0,nCOMPANY,sJUR_PERS,nJUR_PERS );
  end if;

  for rec in
  (
    select B.RN,
           B.JURPERSONS,
           J.AGENT,
           case
             when exists (select null
                            from DOCLINKS L
                            where L.IN_DOCUMENT = B.RN
                              and L.IN_UNITCODE = 'SalaryTransfers'
                              and L.OUT_UNITCODE ='BankDocuments')
               then 1
               else 0
           end IS_BD,
           case
             when exists (select null
                            from DOCLINKS L
                            where L.IN_DOCUMENT = B.RN
                              and L.IN_UNITCODE ='SalaryTransfers'
                              and L.OUT_UNITCODE ='UdotSalaryRegistersTransfers')
               then 1
               else 0
           end IS_REG
      from SELECTLIST  A,
           SLTRANSFERS B,
           JURPERSONS  J
     where A.DOCUMENT   = B.RN
       and B.JURPERSONS = J.RN
       and A.IDENT      = nIDENT
  )
  loop
    if /*rec.IS_BD = 1 or */rec.IS_REG = 1 or (nJUR_PERS is not null and rec.JURPERSONS <> nJUR_PERS) then
      delete from SELECTLIST
       where IDENT = nIDENT
         and DOCUMENT = rec.RN;
    else
      nAGENT := rec.AGENT;
    end if;
  end loop;

  /*   */
  sSQL := 'begin
    PKG_UDOT_SLREGTRN.BASE_FORM
    (
      :nCOMPANY,
      null,            -- nRN
      :nIDENT,
      :dFORM_DATE,
      :nAGENT,
      :nAGNJURDOCS,
      :sAGNBANS,
      :sREGCRN,
      :sDOCTYPES,
      :sDOC_PREF,
      :dDOC_DATE,
      :nGRPTRTYPE,
      :nGRPBANKPRG,
      :nRESULT
    );end;';
  execute immediate sSQL using
    nCOMPANY,
    nIDENT,
    dFORM_DATE,
    nAGENT,
--    to_number(sAGNJURDOCS),
    to_number(null),
    sAGNBANS,
    sREGCRN,
    sDOCTYPES,
    sDOC_PREF,
    dDOC_DATE,
    nGRPTRTYPE,
    nGRPBANKPRG,
    out nRES;
end UDOT_P_SLTRANSFERS_REG_CREATE;
/



grant EXECUTE on UDOT_P_SLTRANSFERS_REG_CREATE to PUBLIC;

--   
declare nRN_PROC number; nRN_LINK number; nPARAM_RN number; nSHOWMETHOD_RN number; nCRN number;
  nRN_FORM number; cCLOB clob; sSQL pkg_std.tstring; nINIT_RN number;
begin
  dbms_lob.createtemporary(cCLOB, true);
  find_acatalog_name_ex(0,0,null,null,'UserProcedures',' ',nCRN);
  nRN_PROC := gen_id;
  insert into USERPROCS (RN,CRN,CODE,NAME,PROCTYPE,PROCAUTO,PROCNAME,BLOCKTEXT,LOCK4EXEC)
      values (nRN_PROC, nCRN, 'UDOT_P_SLTRANSFERS_R', '  ',0,0,'UDOT_P_SLTRANSFERS_REG_CREATE','',1);

  nRN_LINK := gen_id;
  insert into USERPROCSLINKS (RN,PRN,NAME,UNITCODE,RELOADVIEW,COMMIT_SIGN,CONFIRM_SIGN,CONFIRM_TEXT)
      values (nRN_LINK, nRN_PROC, '  ','SalaryTransfers',2,0,0,'');

  nPARAM_RN := null;
  nSHOWMETHOD_RN := null;
  nINIT_RN := null;

  insert into USERPROCSPARAMS (RN,PRN,CRN,POSITION,PARAMNAME,DATATYPE,IS_BOOLEAN,PARAMTYPE,NAME,LINKING,UNITCODE,PARAM_RN,SHOWMETHOD_RN,INIT_RN,ED_RN,VISUALIZE,MANDATORY,DEFAULT_VALUE)
      values ( gen_id, nRN_PROC, nCRN, 1,'NCOMPANY',1,0,0,'NCOMPANY',1,'',nPARAM_RN,nSHOWMETHOD_RN,nINIT_RN,null,0,1,'');

  nPARAM_RN := null;
  nSHOWMETHOD_RN := null;
  nINIT_RN := null;

  insert into USERPROCSPARAMS (RN,PRN,CRN,POSITION,PARAMNAME,DATATYPE,IS_BOOLEAN,PARAMTYPE,NAME,LINKING,UNITCODE,PARAM_RN,SHOWMETHOD_RN,INIT_RN,ED_RN,VISUALIZE,MANDATORY,DEFAULT_VALUE)
      values ( gen_id, nRN_PROC, nCRN, 2,'NIDENT',1,0,0,'NIDENT',7,'',nPARAM_RN,nSHOWMETHOD_RN,nINIT_RN,null,0,1,'');

  select SM.RN, UP.RN, (select P.RN from USERPROCSPARAMS P where P.PRN = nRN_PROC and P.PARAMNAME = '')
    into nSHOWMETHOD_RN, nPARAM_RN, nINIT_RN
    from UNIT_SHOWMETHODS SM, UNITPARAMS UP
   where SM.UNITCODE = 'JuridicalPersons' and SM.METHOD_CODE = 'normal'
     and SM.RN  = UP.PARENT_METHOD and UP.IN_CODE  = 'pos_code' and UP.OUT_CODE = 'code';

  insert into USERPROCSPARAMS (RN,PRN,CRN,POSITION,PARAMNAME,DATATYPE,IS_BOOLEAN,PARAMTYPE,NAME,LINKING,UNITCODE,PARAM_RN,SHOWMETHOD_RN,INIT_RN,ED_RN,VISUALIZE,MANDATORY,DEFAULT_VALUE)
      values ( gen_id, nRN_PROC, nCRN, 3,'SJUR_PERS',0,0,0,' ',2,'JuridicalPersons',nPARAM_RN,nSHOWMETHOD_RN,nINIT_RN,null,0,0,'');

  select SM.RN, UP.RN, (select P.RN from USERPROCSPARAMS P where P.PRN = nRN_PROC and P.PARAMNAME = '')
    into nSHOWMETHOD_RN, nPARAM_RN, nINIT_RN
    from UNIT_SHOWMETHODS SM, UNITPARAMS UP
   where SM.UNITCODE = 'AGNLIST' and SM.METHOD_CODE = 'agents'
     and SM.RN  = UP.PARENT_METHOD and UP.IN_CODE  = 'pos_agnmnemo' and UP.OUT_CODE = 'agnmnemo';

  insert into USERPROCSPARAMS (RN,PRN,CRN,POSITION,PARAMNAME,DATATYPE,IS_BOOLEAN,PARAMTYPE,NAME,LINKING,UNITCODE,PARAM_RN,SHOWMETHOD_RN,INIT_RN,ED_RN,VISUALIZE,MANDATORY,DEFAULT_VALUE)
      values ( gen_id, nRN_PROC, nCRN, 4,'SAGENT',0,0,0,'  ',2,'AGNLIST',nPARAM_RN,nSHOWMETHOD_RN,nINIT_RN,null,0,1,'');

  select SM.RN, UP.RN, (select P.RN from USERPROCSPARAMS P where P.PRN = nRN_PROC and P.PARAMNAME = '')
    into nSHOWMETHOD_RN, nPARAM_RN, nINIT_RN
    from UNIT_SHOWMETHODS SM, UNITPARAMS UP
   where SM.UNITCODE = 'AGNBANKS' and SM.METHOD_CODE = 'normal'
     and SM.RN  = UP.PARENT_METHOD and UP.IN_CODE  = 'pos_code' and UP.OUT_CODE = 'code';

  insert into USERPROCSPARAMS (RN,PRN,CRN,POSITION,PARAMNAME,DATATYPE,IS_BOOLEAN,PARAMTYPE,NAME,LINKING,UNITCODE,PARAM_RN,SHOWMETHOD_RN,INIT_RN,ED_RN,VISUALIZE,MANDATORY,DEFAULT_VALUE)
      values ( gen_id, nRN_PROC, nCRN, 5,'SAGNBANS',0,0,0,' ',2,'AGNBANKS',nPARAM_RN,nSHOWMETHOD_RN,nINIT_RN,null,0,1,'');

  nPARAM_RN := null;
  nSHOWMETHOD_RN := null;
  nINIT_RN := null;

  insert into USERPROCSPARAMS (RN,PRN,CRN,POSITION,PARAMNAME,DATATYPE,IS_BOOLEAN,PARAMTYPE,NAME,LINKING,UNITCODE,PARAM_RN,SHOWMETHOD_RN,INIT_RN,ED_RN,VISUALIZE,MANDATORY,DEFAULT_VALUE)
      values ( gen_id, nRN_PROC, nCRN, 6,'SREGCRN',0,0,0,' ',0,'',nPARAM_RN,nSHOWMETHOD_RN,nINIT_RN,null,0,0,'');

  select SM.RN, UP.RN, (select P.RN from USERPROCSPARAMS P where P.PRN = nRN_PROC and P.PARAMNAME = '')
    into nSHOWMETHOD_RN, nPARAM_RN, nINIT_RN
    from UNIT_SHOWMETHODS SM, UNITPARAMS UP
   where SM.UNITCODE = 'DOCTYPES' and SM.METHOD_CODE = 'normal'
     and SM.RN  = UP.PARENT_METHOD and UP.IN_CODE  = 'pos_mnemo' and UP.OUT_CODE = 'mnemo';

  insert into USERPROCSPARAMS (RN,PRN,CRN,POSITION,PARAMNAME,DATATYPE,IS_BOOLEAN,PARAMTYPE,NAME,LINKING,UNITCODE,PARAM_RN,SHOWMETHOD_RN,INIT_RN,ED_RN,VISUALIZE,MANDATORY,DEFAULT_VALUE)
      values ( gen_id, nRN_PROC, nCRN, 7,'SDOCTYPES',0,0,0,' ',2,'DOCTYPES',nPARAM_RN,nSHOWMETHOD_RN,nINIT_RN,null,0,1,'');

  nPARAM_RN := null;
  nSHOWMETHOD_RN := null;
  nINIT_RN := null;

  insert into USERPROCSPARAMS (RN,PRN,CRN,POSITION,PARAMNAME,DATATYPE,IS_BOOLEAN,PARAMTYPE,NAME,LINKING,UNITCODE,PARAM_RN,SHOWMETHOD_RN,INIT_RN,ED_RN,VISUALIZE,MANDATORY,DEFAULT_VALUE)
      values ( gen_id, nRN_PROC, nCRN, 8,'SDOC_PREF',0,0,0,'',0,'',nPARAM_RN,nSHOWMETHOD_RN,nINIT_RN,null,0,0,'');

  nPARAM_RN := null;
  nSHOWMETHOD_RN := null;
  nINIT_RN := null;

  insert into USERPROCSPARAMS (RN,PRN,CRN,POSITION,PARAMNAME,DATATYPE,IS_BOOLEAN,PARAMTYPE,NAME,LINKING,UNITCODE,PARAM_RN,SHOWMETHOD_RN,INIT_RN,ED_RN,VISUALIZE,MANDATORY,DEFAULT_VALUE)
      values ( gen_id, nRN_PROC, nCRN, 9,'DDOC_DATE',2,0,0,'',0,'',nPARAM_RN,nSHOWMETHOD_RN,nINIT_RN,null,0,1,'');

  nPARAM_RN := null;
  nSHOWMETHOD_RN := null;
  nINIT_RN := null;

  insert into USERPROCSPARAMS (RN,PRN,CRN,POSITION,PARAMNAME,DATATYPE,IS_BOOLEAN,PARAMTYPE,NAME,LINKING,UNITCODE,PARAM_RN,SHOWMETHOD_RN,INIT_RN,ED_RN,VISUALIZE,MANDATORY,DEFAULT_VALUE)
      values ( gen_id, nRN_PROC, nCRN, 10,'DFORM_DATE',2,0,0,' ',0,'',nPARAM_RN,nSHOWMETHOD_RN,nINIT_RN,null,0,0,'');

  nPARAM_RN := null;
  nSHOWMETHOD_RN := null;
  nINIT_RN := null;

  insert into USERPROCSPARAMS (RN,PRN,CRN,POSITION,PARAMNAME,DATATYPE,IS_BOOLEAN,PARAMTYPE,NAME,LINKING,UNITCODE,PARAM_RN,SHOWMETHOD_RN,INIT_RN,ED_RN,VISUALIZE,MANDATORY,DEFAULT_VALUE)
      values ( gen_id, nRN_PROC, nCRN, 11,'NGRPTRTYPE',1,1,0,'   ',0,'',nPARAM_RN,nSHOWMETHOD_RN,nINIT_RN,null,0,1,'0');

  nPARAM_RN := null;
  nSHOWMETHOD_RN := null;
  nINIT_RN := null;

  insert into USERPROCSPARAMS (RN,PRN,CRN,POSITION,PARAMNAME,DATATYPE,IS_BOOLEAN,PARAMTYPE,NAME,LINKING,UNITCODE,PARAM_RN,SHOWMETHOD_RN,INIT_RN,ED_RN,VISUALIZE,MANDATORY,DEFAULT_VALUE)
      values ( gen_id, nRN_PROC, nCRN, 12,'NGRPBANKPRG',1,1,0,'    ',0,'',nPARAM_RN,nSHOWMETHOD_RN,nINIT_RN,null,0,1,'0');

  nPARAM_RN := null;
  nSHOWMETHOD_RN := null;
  nINIT_RN := null;

  insert into USERPROCSPARAMS (RN,PRN,CRN,POSITION,PARAMNAME,DATATYPE,IS_BOOLEAN,PARAMTYPE,NAME,LINKING,UNITCODE,PARAM_RN,SHOWMETHOD_RN,INIT_RN,ED_RN,VISUALIZE,MANDATORY,DEFAULT_VALUE)
      values ( gen_id, nRN_PROC, nCRN, 13,'NRES',1,0,1,'',0,'',nPARAM_RN,nSHOWMETHOD_RN,nINIT_RN,null,0,0,'');


  nRN_FORM := gen_id;
  insert into USERFORMS (RN, FORM_UNITCODE, FORM_NAME, FORM_CLASS, FORM_ACTIVE, FORM_KIND, FORM_ID, REPL_FORM_ID, FORM_LANGUAGE, EVENTS_LANGUAGE, REPL_TABLE, LINK_APPS, LINK_PRIVS, PRODUCER, FORM_DATA, FORM_EVENTS, FORM_DATA_EXT, FORM_EVENTS_EXT)
    values ( nRN_FORM, 'UserProcedures', ' ', ' ', 1, 1, nRN_PROC, nRN_PROC, 'RUSSIAN', '', 'USERPROCS', 0, 0, '12744-6', empty_clob(), empty_clob(), empty_clob(), empty_clob());


  dbms_lob.trim(cCLOB,0);
  sSQL := '<?xml version="1.0" encoding="windows-1251" standalone="yes"?><Object Class="TPDynamicForm" Name="TUserProceduresContentProvider"><Left><I>382</I></Left><Top><I>101</I></Top><Width><I>410</I></Width><Height><I>313</I></Height><DesignSize><List><Item Index="0"><I>404</I></Item><Item Index="1"><I>288</I></Item></List></DesignSize><PixelsPerInch><I>96</I></PixelsPerInch><TextHeight><I>13</I></TextHeight><Object Class="TPContentGroupBox" Name="ContainerForAutoCreatedControls"><Left><I>8</I></Left><Top><I>7</I></Top><Width><I>388</I></Width><Height><I>240</I></Height><Anchors><Set><Item>akLeft</Item><Item>akTop</Item><Item>akRight</Item><Item>akBottom</Item></Set></Anchors><TabOrder><I>0</I></TabOrder><ControlId><![CDATA[{C43DEADA-9851-4BB6-B0D6-39F76C3283BB}]]></ControlId><Object Class="TPContentDictEdit" Name="SJUR_PERS"><Left><I>200</I></Left><Top><I>8</I></Top><Width><I>160</I></Width><ContentDictInterface.Params><Collection><Item Index="0"><Name><![CDATA[pos_code]]></Name><ParamTypes><Set><Item>ptIn</Item><It';
  dbms_lob.writeappend(cCLOB, length(sSQL), sSQL);
  sSQL := 'em>ptSingleKey</Item></Set></ParamTypes><Control>SJUR_PERS</Control><SourceKind>skControl</SourceKind></Item><Item Index="1"><Name><![CDATA[code]]></Name><ParamTypes><Set><Item>ptOut</Item></Set></ParamTypes><Control>SJUR_PERS</Control><SourceKind>skControl</SourceKind></Item></Collection></ContentDictInterface.Params><ContentDictInterface.DocCode><![CDATA[JuridicalPersons]]></ContentDictInterface.DocCode><ContentDictInterface.ShowMethod><![CDATA[normal]]></ContentDictInterface.ShowMethod><ControlLabel.Position><I>8</I></ControlLabel.Position><ControlLabel.Text><![CDATA[ ]]></ControlLabel.Text><TabOrder><I>0</I></TabOrder><ValueStored>True</ValueStored><DictLink.ParentLink>True</DictLink.ParentLink><ControlId><![CDATA[{8C7A424E-0C9A-48D5-AE61-F05A835239BF}]]></ControlId></Object><Object Class="TPContentDictEdit" Name="SAGENT"><Left><I>200</I></Left><Top><I>33</I></Top><Width><I>160</I></Width><ContentDictInterface.Params><Collection><Item Index="0"><Name><![CDATA[pos_agnmnemo]]></Name><ParamTyp';
  dbms_lob.writeappend(cCLOB, length(sSQL), sSQL);
  sSQL := 'es><Set><Item>ptIn</Item><Item>ptSingleKey</Item></Set></ParamTypes><Control>SAGENT</Control><SourceKind>skControl</SourceKind></Item><Item Index="1"><Name><![CDATA[agnmnemo]]></Name><ParamTypes><Set><Item>ptOut</Item></Set></ParamTypes><Control>SAGENT</Control><SourceKind>skControl</SourceKind></Item></Collection></ContentDictInterface.Params><ContentDictInterface.DocCode><![CDATA[AGNLIST]]></ContentDictInterface.DocCode><ContentDictInterface.ShowMethod><![CDATA[agents]]></ContentDictInterface.ShowMethod><ControlLabel.Position><I>8</I></ControlLabel.Position><ControlLabel.Text><![CDATA[  ]]></ControlLabel.Text><Required>True</Required><TabOrder><I>1</I></TabOrder><ValueStored>True</ValueStored><DictLink.ParentLink>True</DictLink.ParentLink><ControlId><![CDATA[{F9EF021C-8455-4A6F-BF17-15DB267F6E83}]]></ControlId></Object><Object Class="TPContentEdit" Name="SREGCRN"><Left><I>200</I></Left><Top><I>83</I></Top><Width><I>160</I></Width><ContentDictInterface.FuncName><![CDATA[UDOT_GET_ACA';
  dbms_lob.writeappend(cCLOB, length(sSQL), sSQL);
  sSQL := 'TALOG_DICT_DESCR]]></ContentDictInterface.FuncName><ContentDictInterface.FuncParams><Collection><Item Index="0"><Name><![CDATA[SIN_PARAM]]></Name><SourceKind>skValue</SourceKind><Value><![CDATA[in_NAME]]></Value></Item><Item Index="1"><Name><![CDATA[SOUT_PARAM]]></Name><SourceKind>skValue</SourceKind><Value><![CDATA[out_NAME]]></Value></Item><Item Index="2"><Name><![CDATA[SCONTROL]]></Name><SourceKind>skValue</SourceKind><Value><![CDATA[SREGCRN]]></Value></Item><Item Index="3"><Name><![CDATA[SUNITCODE]]></Name><SourceKind>skValue</SourceKind><Value><![CDATA[UdotSalaryRegistersTransfers]]></Value></Item></Collection></ContentDictInterface.FuncParams><ControlLabel.Position><I>8</I></ControlLabel.Position><ControlLabel.Text><![CDATA[ ]]></ControlLabel.Text><MaxLength><I>120</I></MaxLength><TabOrder><I>3</I></TabOrder><ValueStored>True</ValueStored><ControlId><![CDATA[{A4FD3BAD-1133-418E-B519-629317DC2A77}]]></ControlId></Object><Object Class="TPContentDictEdit" Name="SDOCTYPES"><Left><I>200</I><';
  dbms_lob.writeappend(cCLOB, length(sSQL), sSQL);
  sSQL := '/Left><Top><I>108</I></Top><Width><I>160</I></Width><ContentDictInterface.Params><Collection><Item Index="0"><Name><![CDATA[pos_mnemo]]></Name><ParamTypes><Set><Item>ptIn</Item><Item>ptSingleKey</Item></Set></ParamTypes><Control>SDOCTYPES</Control><SourceKind>skControl</SourceKind></Item><Item Index="1"><Name><![CDATA[mnemo]]></Name><ParamTypes><Set><Item>ptOut</Item></Set></ParamTypes><Control>SDOCTYPES</Control><SourceKind>skControl</SourceKind></Item></Collection></ContentDictInterface.Params><ContentDictInterface.DocCode><![CDATA[DOCTYPES]]></ContentDictInterface.DocCode><ContentDictInterface.ShowMethod><![CDATA[normal]]></ContentDictInterface.ShowMethod><ControlLabel.Position><I>8</I></ControlLabel.Position><ControlLabel.Text><![CDATA[ ]]></ControlLabel.Text><Required>True</Required><TabOrder><I>4</I></TabOrder><ValueStored>True</ValueStored><DictLink.ParentLink>True</DictLink.ParentLink><ControlId><![CDATA[{AB68B3B3-F489-437E-80AD-E6CFAFE62176}]]></ControlId></Object><Object Class="TPContent';
  dbms_lob.writeappend(cCLOB, length(sSQL), sSQL);
  sSQL := 'Edit" Name="SDOC_PREF"><Left><I>200</I></Left><Top><I>133</I></Top><Width><I>160</I></Width><ControlLabel.Position><I>8</I></ControlLabel.Position><ControlLabel.Text><![CDATA[]]></ControlLabel.Text><MaxLength><I>120</I></MaxLength><TabOrder><I>5</I></TabOrder><ValueStored>True</ValueStored><ControlId><![CDATA[{77C5DBFD-C449-4584-995A-BD6A41933277}]]></ControlId></Object><Object Class="TPContentDateEdit" Name="DDOC_DATE"><Left><I>250</I></Left><Top><I>158</I></Top><Width><I>110</I></Width><ControlLabel.Position><I>8</I></ControlLabel.Position><ControlLabel.Text><![CDATA[]]></ControlLabel.Text><Required>True</Required><TabOrder><I>6</I></TabOrder><ValueStored>True</ValueStored><ControlId><![CDATA[{4DE5DB72-9FFC-4033-B6FB-47C9E61806F1}]]></ControlId></Object><Object Class="TPContentDateEdit" Name="DFORM_DATE"><Left><I>250</I></Left><Top><I>183</I></Top><Width><I>110</I></Width><ControlLabel.Position><I>8</I></ControlLabel.Position><ControlLabel.Text><![CDATA[ ]]></ControlLabel.Text><Ta';
  dbms_lob.writeappend(cCLOB, length(sSQL), sSQL);
  sSQL := 'bOrder><I>7</I></TabOrder><ValueStored>True</ValueStored><ControlId><![CDATA[{52894605-54F9-443F-A8E3-6E1D4DE3EC2C}]]></ControlId></Object><Object Class="TPContentCheckBox" Name="NGRPTRTYPE"><Left><I>8</I></Left><Top><I>208</I></Top><Width><I>218</I></Width><Height><I>17</I></Height><Caption><![CDATA[   ]]></Caption><TabOrder><I>8</I></TabOrder><ValueStored>True</ValueStored><ControlId><![CDATA[{1F9B19E5-1AF4-41E2-A18F-1CEF254091C9}]]></ControlId></Object><Object Class="TPContentCheckBox" Name="NGRPBANKPRG"><Left><I>232</I></Left><Top><I>210</I></Top><Width><I>264</I></Width><Height><I>17</I></Height><Caption><![CDATA[    ]]></Caption><Enabled>False</Enabled><TabOrder><I>9</I></TabOrder><ValueStored>True</ValueStored><Visible>False</Visible><ControlId><![CDATA[{B835FB40-93A9-40DE-B3E9-6F843727440F}]]></ControlId></Object><Object Class="TPContentDictEdit" Name="SAGNBANS"><Left><I>200</I></Left><Top><I>58</I></Top><Width><I>160</I></Width><Co';
  dbms_lob.writeappend(cCLOB, length(sSQL), sSQL);
  sSQL := 'ntentDictInterface.Params><Collection><Item Index="0"><Name><![CDATA[pos_code]]></Name><ParamTypes><Set><Item>ptIn</Item><Item>ptSingleKey</Item></Set></ParamTypes><Control>SAGNBANS</Control><SourceKind>skControl</SourceKind></Item><Item Index="1"><Name><![CDATA[code]]></Name><ParamTypes><Set><Item>ptOut</Item></Set></ParamTypes><Control>SAGNBANS</Control><SourceKind>skControl</SourceKind></Item></Collection></ContentDictInterface.Params><ContentDictInterface.DocCode><![CDATA[AGNBANKS]]></ContentDictInterface.DocCode><ContentDictInterface.ShowMethod><![CDATA[normal]]></ContentDictInterface.ShowMethod><ControlLabel.Position><I>8</I></ControlLabel.Position><ControlLabel.Text><![CDATA[ ]]></ControlLabel.Text><Required>True</Required><TabOrder><I>2</I></TabOrder><ValueStored>True</ValueStored><DictLink.ParentLink>True</DictLink.ParentLink><ControlId><![CDATA[{F61DC879-CE4D-495D-A3CF-BD6FB6E7976C}]]></ControlId></Object></Object><Object Class="TPContentButton" Name="DefaultButton"><Left><I>306</I></L';
  dbms_lob.writeappend(cCLOB, length(sSQL), sSQL);
  sSQL := 'eft><Top><I>255</I></Top><Width><I>90</I></Width><Anchors><Set><Item>akRight</Item><Item>akBottom</Item></Set></Anchors><TabOrder><I>3</I></TabOrder><Caption><![CDATA[ ]]></Caption></Object><Object Class="TPContentCancelButton" Name="CancelButton"><Left><I>211</I></Left><Top><I>255</I></Top><Width><I>90</I></Width><Anchors><Set><Item>akRight</Item><Item>akBottom</Item></Set></Anchors><TabOrder><I>2</I></TabOrder></Object><Object Class="TPContentOkButton" Name="OKButton"><Left><I>116</I></Left><Top><I>255</I></Top><Width><I>90</I></Width><Anchors><Set><Item>akRight</Item><Item>akBottom</Item></Set></Anchors><TabOrder><I>1</I></TabOrder></Object><Object Class="TPContentUserConditions" Name="AutoCreatedUserConditions"><Conditions><![CDATA[<?xml version="1.0" encoding="windows-1251" standalone="yes"?>'||CR||'<control-rules/>]]></Conditions></Object></Object>';
  dbms_lob.writeappend(cCLOB, length(sSQL), sSQL);
  update USERFORMS  set FORM_DATA = cCLOB where RN = nRN_FORM;

end;
/

commit;

spool off

set echo off
